{$A+,B-,D-,E+,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$M 16384,0,655360}


{ Set the next definition to compile for 160x200 mode, and also set LOWRES }
{ to 1 in HAND_TIA.ASM, and set LOWRES to 1 in ATARIMNU.PAS                }

{ DEFINE LOWRES}
Program Atari_2600_Emulator (Input,Output);
Uses
  OPCrt,              { OPCrt is a drop-in replacement for the Crt unit and is  }
  Dos,                {  needed for PCAE to run on DELL Pentium II 266 machines }
  HexWrite,           {  (maybe others as well).  It is copyrighted, so I can't }
  Keyboard,           {  distribute the source.  It comes with TurboPower's     }
  AtariDbg,           {  Object Professional for Borland Pascal.  It turns out  }
  TIASound,           {  that the standard Crt unit contains a bug that causes  }
  Mouse,              {  problems with any program compiled with BP7 and run    }
  Time,               {  on such P-II-266 machines.  Programs using OPCrt must  }
  _Globals,           {  use it instead of Crt in ALL units, to avoid a         }
  _XMS,               {  conflict.  OPCrt has built-in code that detects a      }
  SPUnit,             {  conflict and aborts the program if there is one.       }
  Profile,
  GameStat,
  AtariMnu,
  AtariDis;

Const
(*
  Player1Fire    : Byte = 1;
  JoystickReset  : Byte = 2;   { Also Booster-Grip button 1 }
  Player2Fire    : Byte = 4;
  JoystickSelect : Byte = 8;   { Also Booster-Grip button 2 }
*)
  M0BugMove : Array[0..3] Of Word = (15,15,16,14);
  PadMax = 800;
  playback_freq : Word = 31400;
  sample_freq   : Word = 31400;
  num_bufs      : Word = 2;
  SoundBufSize  : Word = 4096;   { Default buffer size = 4k }

  SC_INDEX      = $3C4;   { Sequence Controller Index register   }
  GC_INDEX      = $3CE;   { Graphics Controller Index register   }
  CRTC_INDEX    = $3D4;   { CRT Controller Index register        }
  MISCELLANEOUS = 6;      { Moscellaneous register index in GC   }
  MEMORY_MODE   = 4;      { Memory Mode register index in SC     }
  GRAPHICS_MODE = 5;      { Graphics Mode register index in GC   }
  MAX_SCAN_LINE = 9;      { Maximum Scan Line reg index in CRTC  }
  UNDERLINE     = $14;    { Underline Location reg index in CRTC }
  MODE_CONTROL  = $17;    { Mode Control register index in CRTC  }
  MAP_MASK      = 2;      { Map Mask register index in SC        }

  HORZ_TOTAL         = 0; { CRTC registers }
  HORZ_DISPLAY_END   = 1;
  START_HORZ_BLANK   = 2;
  END_HORZ_BLANK     = 3;
  START_HORZ_RETRACE = 4;
  END_HORZ_RETRACE   = 5;
  VERT_TOTAL         = 6;
  OVERFLOW           = 7;
  START_VERT_RETRACE = $10;
  END_VERT_RETRACE   = $11;
  VERT_DISPLAY_END   = $12;
  CRTC_OFFSET        = $13;
  START_VERT_BLANK   = $15;
  END_VERT_BLANK     = $16;

  Version        = '2.0b';
{  ExtraAdd       = 2;}
  Passes         = 50;
  SetLocDelay    = 4;
  Read_Delay     = 12500;
  _32BIT_OPERAND = $66;
  _32BIT_ADDRESS = $67;
  ConfigFile     = 'PCAE.CFG';
  SBPort         = $220;
  SBInt          = 7;
  SBDMA          = 1;
  FMChip         = $388;
  SoundDiv       = 5.9;
  MaxScan        : Word = 250;
  Indy500Trans : Array[0..3] Of Byte = ($EF,$FF,$7F,$CF);
  FMDiv : Array[0..15] Of Word =
{   (1,1,15,1,2,2,31,2,1,1,31,1,6,6,93,6);}
{   (50,1,15,1,2,2,31,2,1,1,31,1,6,6,93,6);}
    (1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1);


  PFDelay : Array[0..3] Of Byte = (5,2,3,4);

  Coeff : Array[0..15] Of Word =
{   (0,13,120,32,2,2,62,62,1,62,69,0,6,6,186,64);}
{   (0,13,120,32,2,2,31,62,1,62,69,0,6,6,186,64);}
{   (0,13,8,32,1,1,1,31,1,62,2,0,1,1,2,11);}


{   (0,13,8,32,1,1,1,31,1,62,1,0,1,1,1,11);}

{   (1,13,8,32,1,1,1,31,1,62,1,0,1,1,1,11);}
    (1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1);

  { TIA write registers }

  VSYNC   = 0;
  VBLANK  = 1;
  WSYNC   = 2;
  RSYNC   = 3;
  NUSIZ0  = 4;
  NUSIZ1  = 5;
  COLUP0  = 6;
  COLUP1  = 7;
  COLUPF  = 8;
  COLUBK  = 9;
  CTRLPF  = $0A;
  REFP0   = $0B;
  REFP1   = $0C;
  PF0     = $0D;
  PF1     = $0E;
  PF2     = $0F;
  RESP0   = $10;
  RESP1   = $11;
  RESM0   = $12;
  RESM1   = $13;
  RESBL   = $14;
  AUDC0   = $15;
  AUDC1   = $16;
  AUDF0   = $17;
  AUDF1   = $18;
  AUDV0   = $19;
  AUDV1   = $1A;
  GRP0    = $1B;
  GRP1    = $1C;
  ENAM0   = $1D;
  ENAM1   = $1E;
  ENABL   = $1F;
  HMP0    = $20;
  HMP1    = $21;
  HMM0    = $22;
  HMM1    = $23;
  HMBL    = $24;
  VDELP0  = $25;
  VDELP1  = $26;
  VDELBL  = $27;
  RESMP0  = $28;
  RESMP1  = $29;
  HMOVE   = $2A;
  HMCLR   = $2B;
  CXCLR   = $2C;
  SWCHA1  = $280;
  SWACNT1 = $281;
  SWCHB1  = $282;
  SWBCNT1 = $283;
  INTTIM1 = $284;
  INTTIM3 = $285;
  TIM1T1  = $294;
  TIM2T1  = $295;
  TIM3T1  = $296;
  TIM4T1  = $297;
  SWCHA2  = $380;
  SWACNT2 = $381;
  SWCHB2  = $382;
  SWBCNT2 = $383;
  INTTIM2 = $384;
  TIM1T2  = $394;
  TIM2T2  = $395;
  TIM3T2  = $396;
  TIM4T2  = $397;
(*
  TIA_Name : Array[0..$2C] Of String[6] =
   ('VSYNC' ,'VBLANK','WSYNC' ,'RSYNC' ,'NUSIZ0','NUSIZ1','COLUP0','COLUP1',
    'COLUPF','COLUBK','CTRLPF','REFP0' ,'REFP1' ,'PF0'   ,'PF1'   ,'PF2',
    'RESP0' ,'RESP1' ,'RESM0' ,'RESM1' ,'RESBL' ,'AUDC0' ,'AUDC1' ,'AUDF0',
    'AUDF1' ,'AUDV0' ,'AUDV1' ,'GRP0'  ,'GRP1'  ,'ENAM0' ,'ENAM1' ,'ENABL' ,
    'HMP0'  ,'HMP1'  ,'HMM0'  ,'HMM1'  ,'HMBL'  ,'VDELP0','VDELP1','VDELBL',
    'RESMP0','RESMP1','HMOVE' ,'HMCLR' ,'CXCLR');

  PIA_Name : Array[$280..$297] Of String[8] =
   ('SWCHA','SWACNT','SWCHB','SWBCNT','INTTIM','INTRPT','','','','','','','','',
    '','','','','','','TIM1T','TIM8T','TIM64T','TIM1024T');

  TIA_Read_Name : Array[0..$D] Of String[6] =
   ('CXM0P' ,'CXM1P', 'CXP0FB','CXP1FB','CXM0FB','CXM1FB','CXBLPF','CXPPMM',
    'INPUT0','INPUT1','INPUT2','INPUT3','INPUT4','INPUT5');
*)
  P0CBase = $7D8F;
  P1CBase = $8D7F;
  M0CBase = $FE33;
  M1CBase = $32FF;
  PFCBase = $D7D5;
  BLCBase = $EBEB;

  P0COr   = P0CBase Xor $FFFF;
  P1COr   = P1CBase Xor $FFFF;
  M0COr   = M0CBase Xor $FFFF;
  M1COr   = M1CBase Xor $FFFF;
  PFCOr   = PFCBase Xor $FFFF;
  BLCOr   = BLCBase Xor $FFFF;

  Player0Set  = 2;
  Player1Set  = 4;
  Missile0Set = 8;
  Missile1Set = 16;
  BallSet     = 32;

  TIA_And : Array[0..$7F] Of Byte =
   ($00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F,
    $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,
    $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,
    $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F,
    $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F,
    $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,
    $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,
    $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F);
(*
  Timer_And : Array[$0..$1F] Of Byte =
   ($80,$81,$82,$83,$84,$85,$84,$85,$80,$81,$82,$83,$84,$85,$84,$85,
{    $94,$95,$96,$97,$94,$95,$96,$97,$94,$95,$96,$97,$94,$95,$96,$97);}
    $94,$95,$96,$97,$94,$95,$96,$97,$94,$95,$96,$97,$94,$95,$96,$97);
*)
  FMReg : Array[0..17] Of Byte =
   ($00,$01,$02,$08,$09,$0A,$10,$11,$12,$03,$04,$05,$0B,$0C,$0D,$13,$14,$15);

  MissileSize: Array[0..3] Of Byte = (1,2,4,8);
  PlayerSize:  Array[0..7] Of Word = (7,23,39,39,71,15,71,31);
  _PlayerSize: Array[0..7] Of Word = (8,8,8,8,8,16,8,32);
{
  Add1 : Array[0..7] Of Integer = (8,144,288,-272,  72,8,-544,8);
  Add2 : Array[0..7] Of Integer = (8, 16, 32,-128,-512,8,-256,8);
  Add3 : Array[0..7] Of Integer = (8,144,288,-256,  72,8,  32,8);

  Add1A : Array[0..7] Of Integer = (8,272,544,-528,   72,8,-1056,8);
  Add2A : Array[0..7] Of Integer = (8, 16, 32,-256,-1024,8, -512,8);
  Add3A : Array[0..7] Of Integer = (8,272,544,-512,   72,8,   32,8);
}
  Add1 : Array[0..7] Of Integer = (8,144,288,-272, 192,8,-544,8);
  Add2 : Array[0..7] Of Integer = (8, 16, 32,-128,-512,8,-256,8);
  Add3 : Array[0..7] Of Integer = (8,144,288,-256, 192,8,  32,8);

  Add1A : Array[0..7] Of Integer = (8,272,544,-528,  320,16,-1056,32);
  Add2A : Array[0..7] Of Integer = (8, 16, 32,-256,-1024,16, -512,32);
  Add3A : Array[0..7] Of Integer = (8,272,544,-512,  320,16,   32,32);

  Sep1 : Array[0..7] Of Integer = (228, 16, 32,16, 64,228,32,228);
  Sep2 : Array[0..7] Of Integer = (228,228,228,16,228,228,32,228);
  SP1 : Array[0..7] Of Word = ($1000,$0000,$1000,$0000,$1000,$0800,$1000,$0800);
  SP2 : Array[0..7] Of Word = ($1800,$1800,$0000,$1000,$1800,$1800,$0800,$1000);

  { TIA read registers }

  INPUT0  = $8;
  INPUT1  = $9;
  INPUT2  = $A;
  INPUT3  = $B;
  INPUT4  = $C;
  INPUT5  = $D;

  { Execution times }

  Cycles : Array[0..255] Of Byte =
   (7,6,0,8,3,3,5,5, 3,2,2,2,4,4,6,6,  { 00-0F }
    2,5,0,8,4,4,6,6, 2,4,2,7,4,4,7,7,  { 10-1F }
    6,6,0,8,3,3,5,5, 4,2,2,2,4,4,6,6,  { 20-2F }
    2,5,0,8,4,4,6,6, 2,4,2,7,4,4,7,7,  { 30-3F }
    6,6,0,8,3,3,5,5, 3,2,2,2,3,4,6,6,  { 40-4F }
    2,5,0,8,4,4,6,6, 2,4,2,7,4,4,7,7,  { 50-5F }
    6,6,0,8,3,3,5,5, 4,2,2,2,5,4,6,6,  { 60-6F }
    2,5,0,8,4,4,6,6, 2,4,2,7,4,4,7,7,  { 70-7F }
    2,6,2,6,3,3,3,3, 2,2,2,2,4,4,4,4,  { 80-8F }
    2,6,0,6,4,4,4,4, 2,5,2,5,5,5,5,5,  { 90-9F }
    2,6,2,6,3,3,3,3, 2,2,2,2,4,4,4,4,  { A0-AF }
    2,5,0,5,4,4,4,4, 2,4,2,4,4,4,4,4,  { B0-BF }
    2,6,2,8,3,3,5,5, 2,2,2,2,4,4,6,6,  { C0-CF }
    2,5,0,8,4,4,6,6, 2,4,2,7,4,4,7,7,  { D0-DF }
    2,6,2,8,3,3,5,5, 2,2,2,2,4,4,6,6,  { E0-EF }
    2,5,0,8,4,4,6,6, 2,4,2,7,0,4,7,7); { F0-FF }
(*
  Bytes : Array[0..255] Of Word =
   (1,2,1,2,2,2,2,2, 1,2,1,2,3,3,3,3,  { 00-0F }
    2,2,1,2,2,2,2,2, 1,3,1,3,3,3,3,3,  { 10-1F }
    3,2,1,2,2,2,2,2, 1,2,1,2,3,3,3,3,  { 20-2F }
    2,2,1,2,2,2,2,2, 1,3,1,3,3,3,3,3,  { 30-3F }
    1,2,1,2,2,2,2,2, 1,2,1,2,3,3,3,3,  { 40-4F }
    2,2,1,2,2,2,2,2, 1,3,1,3,3,3,3,3,  { 50-5F }
    1,2,1,2,2,2,2,2, 1,2,1,1,3,3,3,3,  { 60-6F }
    2,2,1,2,2,2,2,2, 1,3,1,3,3,3,3,3,  { 70-7F }
    2,2,2,2,2,2,2,2, 1,1,1,2,3,3,3,3,  { 80-8F }
    2,2,1,2,2,2,2,2, 1,3,1,3,3,3,3,3,  { 90-9F }
    2,2,2,1,2,2,2,2, 1,2,1,2,3,3,3,3,  { A0-AF }
    2,2,1,2,2,2,2,2, 1,3,1,3,3,3,3,3,  { B0-BF }
    2,2,2,2,2,2,2,2, 1,2,1,2,3,3,3,3,  { C0-CF }
    2,2,1,2,2,2,2,2, 1,3,1,3,3,3,3,3,  { D0-DF }
    2,2,2,1,2,2,2,1, 1,2,1,2,3,3,3,1,  { E0-EF }
    2,2,1,1,2,2,2,1, 1,3,1,1,1,3,3,1); { F0-FF }
*)
(*
  CyclesDec: Array[0..255] Of Byte =
   (7,6,0,0,0,3,5,0, 3,2,2,0,0,4,6,0,  { 00-0F }
    2,5,0,0,0,4,6,0, 2,4,0,0,0,4,7,0,  { 10-1F }
    6,6,0,0,3,3,5,0, 4,2,2,0,4,4,6,0,  { 20-2F }
    2,5,0,0,0,4,6,0, 2,4,0,0,0,4,7,0,  { 30-3F }
    6,6,0,0,0,3,5,0, 3,2,2,0,3,4,6,0,  { 40-4F }
    2,5,0,0,0,4,6,0, 2,4,0,0,0,4,7,0,  { 50-5F }
    6,7,0,0,0,4,5,0, 4,3,2,0,5,5,6,0,  { 60-6F }
    2,6,0,0,0,5,6,0, 2,5,0,0,0,5,7,0,  { 70-7F }
    0,6,0,0,3,3,3,0, 2,0,2,0,4,4,4,0,  { 80-8F }
    2,6,0,0,4,4,4,0, 2,5,2,0,0,5,0,0,  { 90-9F }
    2,6,2,0,3,3,3,0, 2,2,2,0,4,4,4,0,  { A0-AF }
    2,5,0,0,4,4,4,0, 2,4,2,0,4,4,4,0,  { B0-BF }
    2,6,0,0,3,3,5,0, 2,2,2,0,4,4,6,0,  { C0-CF }
    2,5,0,0,0,4,6,0, 2,4,0,0,0,4,7,0,  { D0-DF }
    2,7,0,0,3,4,5,0, 2,3,2,0,4,5,6,0,  { E0-EF }
    2,6,0,0,0,5,6,0, 2,5,0,0,4,5,7,0); { F0-FF }

  SPBank : Array[0..255] Of Byte =
   (0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,  { 00-0F }
    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,  { 10-1F }
    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,  { 20-2F }
    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,  { 30-3F }
    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,  { 40-4F }
    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,  { 50-5F }
    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,  { 60-6F }
    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,  { 70-7F }
    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,  { 80-8F }
    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,  { 90-9F }
    0,0,0,0,0,0,0,0, 0,0,0,0,0,1,0,0,  { A0-AF }
    0,0,0,0,0,0,0,0, 0,0,0,0,0,1,0,0,  { B0-BF }
    0,0,0,0,0,0,0,0, 0,0,0,0,0,1,0,0,  { C0-CF }
    0,0,0,0,0,0,0,0, 0,1,0,0,0,1,0,0,  { D0-DF }
    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,  { E0-EF }
    0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0); { F0-FF }

   (0,1,0,1,0,0,0,0, 0,0,0,0,0,1,1,1,  { 00-0F }
    0,1,0,1,0,0,0,0, 0,1,0,1,0,1,1,1,  { 10-1F }
    0,1,0,1,0,0,0,0, 0,0,0,0,1,1,1,1,  { 20-2F }
    0,1,0,1,0,0,0,0, 0,1,0,1,0,1,1,1,  { 30-3F }
    0,1,0,1,0,0,0,0, 0,0,0,0,0,1,1,1,  { 40-4F }
    0,1,0,1,0,0,0,0, 0,1,0,1,0,1,1,1,  { 50-5F }
    0,1,0,1,0,0,0,0, 0,0,0,0,0,1,1,1,  { 60-6F }
    0,1,0,1,0,0,0,0, 0,1,0,1,0,1,1,1,  { 70-7F }
    0,1,0,1,0,0,0,0, 0,0,0,0,1,1,1,1,  { 80-8F }
    0,1,0,1,0,0,0,0, 0,1,0,0,1,1,1,1,  { 90-9F }
    0,1,0,1,0,0,0,0, 0,0,0,0,1,1,1,1,  { A0-AF }
    0,1,0,1,0,0,0,0, 0,1,0,0,1,1,1,1,  { B0-BF }
    0,1,0,1,0,0,0,0, 0,0,0,0,1,1,1,1,  { C0-CF }
    0,1,0,1,0,0,0,0, 0,1,0,1,0,1,1,1,  { D0-DF }
    0,1,0,1,0,0,0,0, 0,0,0,0,1,1,1,1,  { E0-EF }
    0,1,0,1,0,0,0,0, 0,1,0,1,0,1,1,1); { F0-FF }
*)
(*
  Mnem : Array[0..255] Of String[3] =
   ('BRK','ORA','   ','slo','skb','ORA','ASL','slo',   { 00-07 }
    'PHP','ORA','ASL','anc','skw','ORA','ASL','slo',   { 08-0F }
    'BPL','ORA','   ','slo','skb','ORA','ASL','slo',   { 10-17 }
    'CLC','ORA','NOP','slo','skw','ORA','ASL','slo',   { 18-1F }
    'JSR','AND','   ','rla','BIT','AND','ROL','rla',   { 20-27 }
    'PLP','AND','ROL','anc','BIT','AND','ROL','rla',   { 28-2F }
    'BMI','AND','   ','rla','skb','AND','ROL','rla',   { 30-37 }
    'SEC','AND','NOP','rla','skw','AND','ROL','rla',   { 38-3F }
    'RTI','EOR','   ','sre','skb','EOR','LSR','sre',   { 40-47 }
    'PHA','EOR','LSR','asr','JMP','EOR','LSR','sre',   { 48-4F }
    'BVC','EOR','   ','sre','skb','EOR','LSR','sre',   { 50-57 }
    'CLI','EOR','NOP','sre','skw','EOR','LSR','sre',   { 58-5F }
    'RTS','ADC','   ','rra','skb','ADC','ROR','rra',   { 60-67 }
    'PLA','ADC','ROR','   ','JMP','ADC','ROR','rra',   { 68-6F }
    'BVS','ADC','   ','rra','skb','ADC','ROR','rra',   { 70-77 }
    'SEI','ADC','NOP','rra','skw','ADC','ROR','rra',   { 78-7F }
    'skb','STA','skb','sax','STY','STA','STX','sax',   { 80-87 }
    'DEY','NOP','TXA','ane','STY','STA','STX','sax',   { 88-8F }
    'BCC','STA','   ','sha','STY','STA','STX','sax',   { 90-97 }
    'TYA','STA','TXS','shs','shy','STA','shx','sha',   { 98-9F }
    'LDY','LDA','LDX','lax','LDY','LDA','LDX','lax',   { A0-A7 }
    'TAY','LDA','TAX','lxa','LDY','LDA','LDX','lax',   { A8-AF }
    'BCS','LDA','   ','lax','LDY','LDA','LDX','lax',   { B0-B7 }
    'CLV','LDA','TSX','las','LDY','LDA','LDX','lax',   { B8-BF }
    'CPY','CMP','skb','dcp','CPY','CMP','DEC','dcp',   { C0-C7 }
    'INY','CMP','DEX','sbx','CPY','CMP','DEC','dcp',   { C8-CF }
    'BNE','CMP','   ','dcp','skb','CMP','DEC','dcp',   { D0-D7 }
    'CLD','CMP','NOP','dcp','skw','CMP','DEC','dcp',   { D8-DF }
    'CPX','SBC','skb','   ','CPX','SBC','INC','   ',   { E0-E7 }
    'INX','SBC','NOP','SBC','CPX','SBC','INC','   ',   { E8-EF }
    'BEQ','SBC','   ','   ','skb','SBC','INC','   ',   { F0-F7 }
    'SED','SBC','NOP','   ','skw','SBC','INC','   ');  { F8-FF }

  ATyp : Array[0..255] Of String[3] =
   ('IMP','I.X','   ','I.X','IMP','Z.P','Z.P','Z.P',   { 00-07 }
    'IMP','IMM','ACC','IMM','IMP','ABS','ABS','ABS',   { 08-0F }
    'REL','I.Y','   ','I.Y','IMP','Z.X','Z.X','Z.X',   { 10-17 }
    'IMP','A.Y','IMP','A.Y','IMP','A.X','A.X','A.X',   { 18-1F }
    'ABS','I.X','   ','I.X','Z.P','Z.P','Z.P','Z.P',   { 20-27 }
    'IMP','IMM','ACC','IMM','ABS','ABS','ABS','ABS',   { 28-2F }
    'REL','I.Y','   ','I.Y','IMP','Z.X','Z.X','Z.X',   { 30-37 }
    'IMP','A.Y','IMP','A.Y','IMP','A.X','A.X','A.X',   { 38-3F }
    'IMP','I.X','   ','I.X','IMP','Z.P','Z.P','Z.P',   { 40-47 }
    'IMP','IMM','ACC','IMM','ABS','ABS','ABS','ABS',   { 48-4F }
    'REL','I.Y','   ','I.Y','IMP','Z.X','Z.X','Z.X',   { 50-57 }
    'IMP','A.Y','IMP','A.Y','IMP','A.X','A.X','A.X',   { 58-5F }
    'IMP','I.X','   ','I.X','IMP','Z.P','Z.P','Z.P',   { 60-67 }
    'IMP','IMM','ACC','   ','IND','ABS','ABS','ABS',   { 68-6F }
    'REL','I.Y','   ','I.Y','IMP','Z.X','Z.X','Z.X',   { 70-77 }
    'IMP','A.Y','IMP','A.Y','IMP','A.X','A.X','A.X',   { 78-7F }
    'IMP','I.X','IMP','I.X','Z.P','Z.P','Z.P','Z.P',   { 80-87 }
    'IMP','IMP','IMP','IMM','ABS','ABS','ABS','ABS',   { 88-8F }
    'REL','I.Y','   ','I.Y','Z.X','Z.X','Z.Y','Z.Y',   { 90-97 }
    'IMP','A.Y','IMP','IMP','A.X','A.X','A.Y','A.Y',   { 98-9F }
    'IMM','I.X','IMM','I.X','Z.P','Z.P','Z.P','Z.P',   { A0-A7 }
    'IMP','IMM','IMP','I+A','ABS','ABS','ABS','ABS',   { A8-AF }
    'REL','I.Y','   ','I.Y','Z.X','Z.X','Z.Y','Z.Y',   { B0-B7 }
    'IMP','A.Y','IMP','ASY','A.X','A.X','A.Y','A.Y',   { B8-BF }
    'IMM','I.X','IMP','I.X','Z.P','Z.P','Z.P','Z.P',   { C0-C7 }
    'IMP','IMM','IMP','IMM','ABS','ABS','ABS','ABS',   { C8-CF }
    'REL','I.Y','   ','I.Y','IMP','Z.X','Z.X','Z.X',   { D0-D7 }
    'IMP','A.Y','IMP','A.Y','IMP','A.X','A.X','A.X',   { D8-DF }
    'IMM','I.X','IMP','   ','Z.P','Z.P','Z.P','   ',   { E0-E7 }
    'IMP','IMM','IMP','IMM','ABS','ABS','ABS','   ',   { E8-EF }
    'REL','I.Y','   ','   ','IMP','Z.X','Z.X','   ',   { F0-F7 }
    'IMP','A.Y','IMP','   ','IMP','A.X','A.Y','   ');  { F8-FF }
*)
Type
  RGB = Record
    R,G,B: Byte;
  End;
{  PDisArray    = ^TDisArray;
  TDisArray    = Array[0..62 * 1024 - 1] Of Boolean;}
  Strng4       = String[4];
  TIA_RegList  = Array[0..$3F] Of Byte;
{
  ConfigRec    = Record
    UseJoystick1 : Boolean;
    UseJoystick2 : Boolean;
    DoSound      : Boolean;
    MinJoyX      : Word;
    MaxJoyX      : Word;
    MinJoyY      : Word;
    MaxJoyY      : Word;
    MinJoyX2     : Word;
    MaxJoyX2     : Word;
    MinJoyY2     : Word;
    MaxJoyY2     : Word;
    FrameRate    : Word;
    SoundBufSize : Word;
    JoyCenterX   : Word;
    JoyCenterY   : Word;
    JoyCenterX2  : Word;
    JoyCenterY2  : Word;
    PlaybackRate : Word;
    Reserved     : Array[0..5] Of Byte;
  End;
}
  TSoundType = (stPureTone,stPolyphonic,stNoise);
  TPalette   = Array[0..127] Of RGB;

Const
  FMSoundType : Array[0..15] Of TSoundType =
{   (stNoise,   stPolyphonic,stPolyphonic,stPolyphonic,
    stPureTone,stPureTone,  stPureTone,  stPolyphonic,
    stNoise,   stPolyphonic,stPureTone,  stNoise,
    stPureTone,stPureTone,  stPureTone,  stPolyphonic);}
{
   (stPureTone,stPolyphonic,stPolyphonic,stPolyphonic,
    stPureTone,stPureTone,  stPureTone,  stPolyphonic,
    stNoise,   stPolyphonic,stPureTone,  stNoise,
    stPureTone,stPureTone,  stPureTone,  stPolyphonic);
}
   (stPureTone,stPureTone,stPureTone,stPureTone,
    stPureTone,stPureTone,stPureTone,stPureTone,
    stPureTone,stPureTone,stPureTone,stPureTone,
    stPureTone,stPureTone,stPureTone,stPureTone);

(*
   (stPolyphonic,stPolyphonic,stPolyphonic,stPolyphonic,
    stPureTone,stPureTone,  stPureTone,  stPolyphonic,
    stPolyphonic,stPolyphonic,stPureTone,  stPolyphonic,
    stPureTone,stPureTone,  stPureTone,  stPolyphonic);
*)
Var
  Dummy                          : Word; { Used to dword-align BitTest }
  BitTest                        : Array[0..127] Of LongInt;
  DispJump                       : LongInt;
  Player0Size160                 : LongInt;
  Player1Size160                 : LongInt;
  Missile0Size160                : LongInt;
  Missile1Size160                : LongInt;
  BallSize160                    : LongInt;
  Player0Size                    : LongInt;
  Player1Size                    : LongInt;
  _Player0Size                   : LongInt;
  _Player1Size                   : LongInt;
  Player0Size128                 : LongInt;
  Player1Size128                 : LongInt;
  ResetPlayer0Size128            : LongInt;
  ResetPlayer1Size128            : LongInt;
  Missile0Size                   : LongInt;
  Missile1Size                   : LongInt;
  Missile0SizeNum                : LongInt;
  Missile1SizeNum                : LongInt;
  OldPlayer0Size128              : LongInt;
  OldPlayer1Size128              : LongInt;
  Missile0SizeNumAdd             : LongInt;
  Missile1SizeNumAdd             : LongInt;
  Missile0Adjust                 : LongInt;
  Missile1Adjust                 : LongInt;
  Missile0Wrap                   : LongInt;
  Missile1Wrap                   : LongInt;
  BallAdjust                     : LongInt;
  BallSize                       : LongInt;
  TIA_Count                      : LongInt;
  Old_TIA_Count                  : LongInt;
  AddCycle                       : LongInt;
  CyclesDone                     : LongInt;
  TimerInterval                  : LongInt;
  TimerValue                     : LongInt;
  TimerShift                     : LongInt;

  TimerX                         : LongInt;
  TimerSize                      : LongInt;
  OrigTimer                      : LongInt;
  TimerElapsed                   : LongInt;

  TIA_Scan                       : LongInt;
  LastScan                       : LongInt;
  NewScan                        : LongInt;
  ReadTime                       : LongInt;
  Write_TIA                      : LongInt;
  ObjectSet                      : LongInt;
  Limit                          : LongInt;
  CLW,CRW                        : LongInt;
  Addr                           : LongInt;
  Save_BX                        : LongInt;
  ColorOrBW                      : LongInt;
  Difficulty1                    : LongInt;
  Difficulty2                    : LongInt;
  PaddleGround0                  : LongInt;
  PaddleGround1                  : LongInt;
  PaddleGround2                  : LongInt;
  PaddleGround3                  : LongInt;
  Time0                          : Double;{LongInt;}
  TimeErr                        : Double;{LongInt;}
  KeyColumn                      : LongInt;
  Indy500                        : LongInt;
  ObjectLoc                      : Array[0..16] Of LongInt;
  OldObjectLoc                   : Array[0..16] Of LongInt;
  ObjectPix                      : Array[0..16] Of LongInt;
  Locations                      : Array[0..255] Of Word;
  Handle_TIA_Jump                : Array[0..31] Of Word;
  ColorLum                       : Array[0..3] Of Word;
  Handle_IO_Loc                  : Array[0..TIM4T2] Of Word;
  Handle_IO_Loc_After            : Array[0..CXCLR] Of Word;
  TIA_Delay                      : Array[0..CXCLR] Of Word;
  AtariSeg                       : TASeg;
  MegaBoy                        : Array[0..15] Of Byte;
  ExtraAdd                       : Array[-68..160] Of Word;

  SetAdjust                      : Array[0..16 * 67 - 1] Of Integer;

  ASeg                           : Pointer;
  ROMBackup                      : Pointer;
  ROMSize                        : LongInt;
  TimerDone                      : Boolean;
  GRP0Latch                      : Byte;
  GRP1Latch                      : Byte;

  MegaBoyNum                     : Word;

  OldNUSIZ0                      : Byte;
  OldNUSIZ1                      : Byte;
  OldHMxx                        : Array[0..4] Of Byte;

  ResetOffset                    : Array[0..4] Of Word;
  ResetOfs                       : Word;


  BCDTable                       : Array[0..1,0..255] Of Byte;

  LastVBLANK                     : Integer;

{
  GRP0Write                      : Integer;
  GRP1Write                      : Integer;
}
  BallLatch                      : Byte;
  CTRLPFLatch                    : Byte;
  CTRLPFScan                     : Integer;
  CTRLPFCount                    : Integer;
{  KBFlag                         : Byte;}
  BitSwap                        : Array[0..255] Of Byte;
  TIA_Regs                       : TIA_RegList;
  Input_Byte                     : Array[0..$F] Of Byte;
  Latched                        : Boolean;
  ByteShift                      : Array[0..2047] Of Byte;
  MissileTable                   : Array[0..128 * 32 - 1] Of Byte;
  Handle_IO_Set                  : Boolean;
  Handle_IO_Set_After            : Boolean;
  ColorOrBWChange                : Boolean;
  Difficulty1Change              : Boolean;
  Difficulty2Change              : Boolean;
  Handle_TIA_Jump_Set            : Boolean;
  Debugger                       : Boolean;
  DebugLoad                      : Boolean;
  M0Bug                          : Boolean;
  M0BugCount                     : Byte;
  FixTimer                       : Byte;
  FixTimerNum                    : Byte;

  VBLANKOff                      : Boolean;


  Pal                            : TPalette;
  Pal1                           : TPalette;
  Palette                        : Byte;

{
  UseKBControllers               : Boolean;
  VideoTouchPad                  : Boolean;
  UseIndy500                     : Boolean;
}
  Controller                     : TController;
  Work_Real                      : Real;
{  FMReg                          : Array[0..17] Of Byte;}
  FMChanOn                       : Array[0..9] Of Byte;
  FMFeedBack                     : Array[0..9] Of Byte;
  FMBaseLevel                    : Array[0..21] Of Word;
  FMScale                        : Array[0..8] Of Word;
  FMRealScale                    : Array[0..8] Of Word;
  FMVoc                          : Array[0..8] Of Byte;
  FMFreq                         : Array[0..8] Of Word;
{  FMSoundType                    : Array[0..15] Of TSoundType;}
  BankSwitch                     : TBankSwitch;
  VAddAdjust                     : Word;
  VAdd                           : Word;
  VUserAdd                       : Word;
  CurrentBank                    : Byte;
  BankStart                      : Word;
  BankSize                       : Word;
  LineStart                      : Word;
  JoyCenterX                     : Word;
  JoyCenterY                     : Word;
  JoyMinX                        : Word;
  JoyMinY                        : Word;
  JoyMaxX                        : Word;
  JoyMaxY                        : Word;
  JoyCenterX2                    : Word;
  JoyCenterY2                    : Word;
  JoyMinX2                       : Word;
  JoyMinY2                       : Word;
  JoyMaxX2                       : Word;
  JoyMaxY2                       : Word;
  OldStart                       : Word;

  _CTRLPF                        : Byte;

  Table                          : Array[0..511] Of Single;
  OldByte                        : Byte;
  SPBankNum                      : Byte;
  MaxRows                        : Byte;

  StarpathWriteValue             : Byte;
  StarpathWrite                  : Boolean;
  DoHMOVE                        : Boolean;
  OldDoHMOVE                     : Boolean;
  HMOVECount                     : LongInt;
  Cart                           : TCart;
  KBWrite                        : Boolean;
{
  ParkerBS                       : Boolean;
  Activision                     : Boolean;
  MNetwork                       : Boolean;
  Starpath                       : Boolean;
  CBS                            : Boolean;
  SuperChip                      : Boolean;
  TigerVision                    : Boolean;
  Pitfall2                       : Boolean;
}
  TigerLimit                     : Byte;
  SCLimit                        : Byte;
  TopVBLANK                      : Boolean;
  MNetworkRAM                    : Byte;
  LockXMS                        : Boolean;
  StarpathLastAddr               : Word;
  UseMenu                        : Boolean;
  Disasm                         : Boolean;
  Top                            : Integer;
  Sel                            : Integer;
  Config                         : ConfigRec;
  Div3                           : Array[0..228] Of Byte;

  PhysAddr                       : DWord;
  TotalFree                      : Word;
  LargestFree                    : Word;
  Handle                         : XMS_XmBlk;
  MovePacket                     : XMS_MovePacket;
  SoundBuf                       : TSoundBuf;

  SBuf                           : Array[0..1] Of Pointer;

  PhysAddr0                      : DWord;
  PhysAddr1                      : DWord;
  PF2ReadCount                   : TPF2ReadCount;
{
  PF2Read                        : Pointer;
  PF2ReadSize                    : Word;
}

  Hi3                            : Word;
  HaltLine                       : Integer;
  AutoCenter                     : Byte;
  AutoCenterChange               : Boolean;

{ ------------------------------------------------------------------------- }
{  Executed                       : Array[$1000..$1FFF] Of Boolean;
  Branched                       : Array[$1000..$1FFF] Of Boolean;}
{
  Executed                       : PDisArray;
  Branched                       : PDisArray;
}
  _Intr_Num                      : Byte;
  _Voice_Status                  : Word;
  _IO_Addx                       : Word;
  _DMA                           : Word;
  _DSP_Version                   : Word;
  Org_Int_Addx                   : Pointer;

{$F+}
Function _CTV_Card_Here: Word; External;
Function _CTV_Detect: Word;    External;
Function _CTV_Output(Buf: Pointer; BufLen,SampleRate: Word): Word; External;
Function _CTV_Halt: Word;      External;
Function _CTV_Uninstall: Word; External;
Procedure Prog_DMA; External;
{$F-}
{$L CTV-ATA4.OBJ}

Procedure SetPalette(Var Pal: TPalette);
Var I: Integer;
Begin
  Port[$3C8] := 0;
  For I := 0 To 127 Do
  Begin
    Port[$3C9] := Pal[I].B Shr 2;
    Port[$3C9] := Pal[I].G Shr 2;
    Port[$3C9] := Pal[I].R Shr 2;

    { Duplicate the colors here to avoid having to worry about bit 0 }

    Port[$3C9] := Pal[I].B Shr 2;
    Port[$3C9] := Pal[I].G Shr 2;
    Port[$3C9] := Pal[I].R Shr 2;
  End; { For I }
End; { SetPalette }


Procedure Build_Table;
Var
  Freq  : Word;
  Kind  : Word;
  S3    : Single;
  Index : Word;

Begin
  Index := 0;
  Freq  := 0;
  While Freq < 32 Do
  Begin
    Kind := 0;
    While Kind < 16 Do
    Begin
      S3 := 0;
      If Coeff[Kind] <> 0 Then
      Begin
        S3 := 30000 / (Freq + 1);
        S3 := S3 / (Coeff[Kind] * FMDiv[Kind] * SoundDiv);
        If S3 > 1023 Then S3 := 1023;
      End;
      Table[Index] := S3;
      Inc(Index);
      Inc(Kind);
    End; { While }
    Inc(Freq);
  End; { While }
End; { Build_Table }


Procedure WriteFM(Reg,Data: Byte);
Var B: Byte;
Begin
  Port[FMChip] := Reg;
  B := Port[FMChip];
  Port[FMChip + 1] := Data;
  B := Port[FMChip];
  B := Port[FMChip];
  B := Port[FMChip];
  B := Port[FMChip];
End; { WriteFM }


Procedure InitFM;
Var I: Byte;
Begin
  For I := 1 To $F5 Do WriteFM(I,0);
  Build_Table;
End; { InitFM }


Procedure Digital(Chan: Byte);
Var I1,T: LongInt;
Begin
  If Chan = 0 Then
  Begin
    Asm
      DB    _32BIT_OPERAND
      SUB   AX,AX
      DB    _32BIT_OPERAND
      SUB   BX,BX
      MOV   BX,WORD PTR SoundBufSize
      MOV   AL,BYTE PTR FMVoc
      SHL   AX,5
      ADD   AX,WORD PTR FMFreq
      DB    _32BIT_OPERAND
      MUL   BX
      DB    _32BIT_OPERAND
      MOV   WORD PTR I1,AX
    End; { Asm }

    { Handle channel 1 }

    If LockXMS Then XMS.RawMove(PhysAddr0,PhysAddr + I1,SoundBufSize) Else
    Begin
      MovePacket.Length     := SoundBufSize;
      MovePacket.srcHandle  := Handle.Handle;
      MovePacket.srcOffset  := I1;
      MovePacket.destHandle := 0;
      MovePacket.destOffset := DWord(SoundBuf[0]);
      XMS.MoveXM(MovePacket);
    End;
    Asm
      MOV   AL,BYTE PTR FMRealScale
      SHL   AL,3
      MOV   BX,0FFFFh
      LES   DI,DWORD PTR SoundBuf[0 * 4]
      MOV   CX,WORD PTR SoundBufSize
      SHR   CX,2
  @L1:
      DB    _32BIT_OPERAND
      MOV   DX,WORD PTR [ES:DI]
      DB    _32BIT_OPERAND
      OR    DX,DX
      JZ    @L2
      TEST  DL,BL
      JZ    @L3
      MOV   DL,AL
  @L3:
      TEST  DH,BL
      JZ    @L4
      MOV   DH,AL
  @L4:
      DB    _32BIT_OPERAND
      ROR   DX,16
      TEST  DL,BL
      JZ    @L5
      MOV   DL,AL
  @L5:
      TEST  DH,BL
      JZ    @L6
      MOV   DH,AL
  @L6:
      DB    _32BIT_OPERAND
      ROR   DX,16
      DB    _32BIT_OPERAND
      MOV   WORD PTR [ES:DI],DX
  @L2:
      ADD   DI,4
      DEC   CX
      JNZ   @L1
    End; { Asm }
  End
  Else
  Begin
    Asm
      DB    _32BIT_OPERAND
      SUB   AX,AX
      DB    _32BIT_OPERAND
      SUB   BX,BX
      MOV   BX,WORD PTR SoundBufSize
      MOV   AL,BYTE PTR FMVoc[1]
      SHL   AX,5
      ADD   AX,WORD PTR FMFreq[2]
      DB    _32BIT_OPERAND
      MUL   BX
      DB    _32BIT_OPERAND
      MOV   WORD PTR I1,AX
    End; { Asm }

    { Handle channel 2 }

    If LockXMS Then XMS.RawMove(PhysAddr1,PhysAddr + I1,SoundBufSize) Else
    Begin
      MovePacket.Length     := SoundBufSize;
      MovePacket.srcHandle  := Handle.Handle;
      MovePacket.srcOffset  := I1;
      MovePacket.destHandle := 0;
      MovePacket.destOffset := DWord(Ptr(Seg(SoundBuf[0]^),Ofs(SoundBuf[0]^) + SoundBufSize));
      XMS.MoveXM(MovePacket);
    End;
    Asm
      MOV   AL,BYTE PTR FMRealScale[2]
      SHL   AL,3
      MOV   BX,0FFFFh
      LES   DI,DWORD PTR SoundBuf[0 * 4]
      ADD   DI,WORD PTR SoundBufSize
      MOV   CX,WORD PTR SoundBufSize
      SHR   CX,2
  @L1:
      DB    _32BIT_OPERAND
      MOV   DX,WORD PTR [ES:DI]
      DB    _32BIT_OPERAND
      OR    DX,DX
      JZ    @L2
      TEST  DL,BL
      JZ    @L3
      MOV   DL,AL
  @L3:
      TEST  DH,BL
      JZ    @L4
      MOV   DH,AL
  @L4:
      DB    _32BIT_OPERAND
      ROR   DX,16
      TEST  DL,BL
      JZ    @L5
      MOV   DL,AL
  @L5:
      TEST  DH,BL
      JZ    @L6
      MOV   DH,AL
  @L6:
      DB    _32BIT_OPERAND
      ROR   DX,16
      DB    _32BIT_OPERAND
      MOV   WORD PTR [ES:DI],DX
  @L2:
      ADD   DI,4
      DEC   CX
      JNZ   @L1
    End; { Asm }
  End;
  Asm
    LES   DI,DWORD PTR SoundBuf[1 * 4]
    MOV   CX,WORD PTR SoundBufSize
    SHR   CX,2
    MOV   BX,WORD PTR SoundBufSize
    PUSH  DS
    LDS   SI,DWORD PTR SoundBuf[0 * 4]
@L1:
    DB    _32BIT_OPERAND
    MOV   AX,WORD PTR [SI]
    DB    _32BIT_OPERAND
    ADD   AX,WORD PTR [SI + BX]
    DB    _32BIT_OPERAND
    MOV   WORD PTR [ES:DI],AX
    ADD   SI,4
    ADD   DI,4
    DEC   CX
    JNZ   @L1
    POP   DS
  End; { Asm }
End; { Digital }


Procedure SetFM(Chan: Byte; On: Boolean);
Begin
  FMChanOn[Chan] := FMChanOn[Chan] And $DF;
  If On Then FMChanOn[Chan] := FMChanOn[Chan] Or $20;
  WriteFM(Chan + $B0,FMChanOn[Chan]);
End; { SetFM }


Procedure SetFMVoice(Chan,Voc: Word);
Var B,C,Index,Len,Oct,Freq: Word;
  F         : Single;
Begin
  If Not Config.DoSound Then Exit;

{  Voc := 8;}

  Voc := Voc And $F;
  FMVoc[Chan] := Voc;
  If FMSoundType[Voc] <> stNoise
   Then FMFeedback[Chan] := 0 Else FMFeedback[Chan] := 1;
  WriteFM(Chan + $C0,FMFeedBack[Chan]);

  { Operator 1 }

  B := FMReg[Chan];

  If FMSoundType[Voc] = stPureTone
   Then C := $3F - $0D
   Else C := $3F - 7;
  If FMFeedBack[Chan] <> 0 Then C := 0;


  C := 0;


  FMBaseLevel[B] := C;



  F   := Table[(FMFreq[Chan] Shl 4) + FMVoc[Chan]];
  Oct := 7;
  While (F < 512) And (Oct > 0) Do
  Begin
    Dec(Oct);
    F := F + F;
  End; { While }
  Freq := Round(F);
  If Freq > 1023 Then Freq := 1023;
  WriteFM(Chan + $A0,Freq And $FF);
  FMChanOn[Chan] := $20 Or ((((Freq Shr 8) And 3) Or (Oct Shl 2)) And $1F);
  WriteFM(Chan + $B0,FMChanOn[Chan]);



{  C := ($3F - ((FMScale[Chan] * C + 8) Div 15));}
{  C := $3F - (FMScale[Chan] Shl 2);}
  If FMScale[Chan] = 0 Then C := $3F Else C := 15 - FMScale[Chan];

{  C := 0;}

  WriteFM(B + $20,$21);    { AM/Vib/EG/KSR/Multiple     }
  WriteFM(B + $40,C);      { Total level                }

  WriteFM(B + $60,$80);    { Attack/decay rates         }
  WriteFM(B + $80,$08);    { Sustain level/release rate }

(*
  WriteFM(B + $60,$DF);    { Attack/decay rates         }
  WriteFM(B + $80,$0F);    { Sustain level/release rate }
*)
  WriteFM(B + $E0,0{2});      { Wave select                }

  { Operator 2 }

  B := FMReg[Chan + $09];
{  C := $3F;}

  C := 0;


  If FMFeedBack[Chan] <> 0 Then C := 0;
  FMBaseLevel[B] := C;
{  C := ($3F - ((FMScale[Chan] * C + 8) Div 15));}
{  C := $3F - (FMScale[Chan] Shl 2);}
  If FMScale[Chan] = 0 Then C := $3F Else C := 15 - FMScale[Chan];
  WriteFM(B + $20,$21);                { AM/Vib/EG/KSR/Multiple     }
  WriteFM(B + $40,C);                  { Total level                }

  WriteFM(B + $60,$80);                { Attack/decay rates         }
  WriteFM(B + $80,$08);                { Sustain level/release rate }
(*
  WriteFM(B + $60,$DF);                { Attack/decay rates         }
  WriteFM(B + $80,$0F);                { Sustain level/release rate }
*)
  If FMSoundType[Voc] = stPureTone
   Then WriteFM(B + $E0,0)             { Wave select                }
   Else WriteFM(B + $E0,1);            { Wave select                }
End; { SetFMVoice }


Procedure SetFMFreq(Chan: Byte; Freq: Word);
Var
  Index,Len : Word;
  F         : Single;
  Oct       : Word;

Begin
  If Not Config.DoSound Then Exit;
  Freq := Freq And $1F;
  FMFreq[Chan] := Freq;
{
  If FMVoc[Chan] = 8 Then
  Begin
    Index := FMRealScale[Chan] + (Freq Shl 4);
    If SRec[Index].SampleLen >= 16 Then
    Begin
      Len := SRec[Index].SampleLen;
      _CTV_Halt;
      XMS.RawMove(SegOffToPhys(SoundBuf),PhysAddr + SRec[Index].SampleOfs,Even(Len));
      _CTV_Output(SoundBuf,SRec[Index].SampleLen,SRec[Index].SampleRate);
    End
    Else _CTV_Halt;
  End;
}
  F   := Table[(Freq Shl 4) + FMVoc[Chan]];

{  WriteLn(Freq,'  ',F:11:5,' (',Chan,')  ',FMVoc[Chan]);}

  Oct := 7;
  While (F < 512) And (Oct > 0) Do
  Begin
    Dec(Oct);
    F := F + F;
  End; { While }
  Freq := Round(F);
  If Freq > 1023 Then Freq := 1023;
  WriteFM(Chan + $A0,Freq And $FF);
  FMChanOn[Chan] := $20 Or ((((Freq Shr 8) And 3) Or (Oct Shl 2)) And $1F);
  WriteFM(Chan + $B0,FMChanOn[Chan]);
End; { SetFMFreq }


Procedure SetFMFreq1(Chan: Byte; Freq: Word);
{ -------------------------------------------------------------------- }
{ Used only for Pitfall II.  Freq is really the wavelength.            }
{ -------------------------------------------------------------------- }
Var
  Index,Len : Word;
  F         : Single;
  Oct       : Word;

Begin
  If FMFreq[Chan] <> Freq Then
  Begin
    FMFreq[Chan] := Freq;
    Oct := 7;
{    F := Freq;}
    F := 3000 / Freq;
    While (F < 512) And (Oct > 0) Do
    Begin
      Dec(Oct);
      F := F + F;
    End; { While }
    Freq := Round(F);
    If Freq > 1023 Then Freq := 1023;
    WriteFM(Chan + $A0,Freq And $FF);
    FMChanOn[Chan] := $20 Or ((((Freq Shr 8) And 3) Or (Oct Shl 2)) And $1F);
    WriteFM(Chan + $B0,FMChanOn[Chan]);
  End;
End; { SetFMFreq1 }


Procedure SetFMScale(Chan,Scale: Word);
Var B,C,Index,Len: Word;
Begin
  If Not Config.DoSound Then Exit;
  Scale := Scale And $F;
  FMRealScale[Chan] := Scale;
{  Scale := Round(15 * Sqrt(Sqrt(Sqrt(Scale / 15))));}
  If Scale > 15 Then Scale := 15;
  FMScale[Chan] := Scale;

  { Operator 1 }

  B := FMReg[Chan];
  C := FMBaseLevel[B];
{  C := ($3F - ((Scale * C + 8) Div 15));}
{  C := $3F - (Scale Shl 2);}
  If FMScale[Chan] = 0 Then C := $3F Else C := 15 - FMScale[Chan];

  If FMFeedBack[Chan] <> 0 Then C := $3F;

  C := $1F;

  WriteFM(B + $40,C);                   { Total level }

  { Operator 2 }

  B := FMReg[Chan + $09];
  C := FMBaseLevel[B];
{  C := ($3F - ((Scale * C + 8) Div 15));}
{  C := $3F - (Scale Shl 2);}
  If FMScale[Chan] = 0 Then C := $3F Else C := 15 - FMScale[Chan];

  If FMFeedBack[Chan] <> 0 Then C := $3F;

  WriteFM(B + $40,C);                     { Total level }
End; { SetFMScale }


Procedure DSPWrite(B: Byte);
Var B1: Byte;
Begin
  Repeat
    B1 := Port[$22C];
  Until (B1 And $80) = 0;
  Port[$22C] := B;
End; { DSPWrite }


Procedure SetVoice(Chan,Voc: Word);
Begin
{    SetFMVoice(Chan,Voc);}
(*
  If {(Chan = 2) And} (Voc In [4,5,6,10,12,13,14]) Then
  Begin
    SetFMVoice(Chan,Voc);
{    Update_TIA_Sound($15 + Chan,Voc);}
    AUDV[Chan] := 0;
    OutVol[Chan] := 0;
{    If Not (FMVoc[Chan] In [4,5,6,10,12,13,14]) Then
    Begin}
      AUDV[Chan] := 0;
      OutVol[Chan] := 0;
      If Update_TIA_Sound($15 + Chan,Voc) Then FillBuffer;
{    End;}
  End
  Else
  Begin
{    If FMVoc[Chan] In [4,5,6,10,12,13,14] Then} SetFMScale(Chan,0);
{    AUDF[Chan] := FMFreq[Chan] And $1F;
    AUDV[Chan] := (FMRealScale[Chan] And $0F) Shl 3;}

    If Update_TIA_Sound($15 + Chan,Voc){ Or
       Update_TIA_Sound($17 + Chan,FMFreq[Chan]) Or
       Update_TIA_Sound($19 + Chan,FMRealScale[Chan])} Then FillBuffer;

  End;
*)

  If (Cart = ctPitfall2) And (Chan = 0) Then
  Begin
    If Config.DoSound Then
    Begin
      If FMVoc[0] <> 4 Then SetFMVoice(0,4);
      If FMVoc[2] <> 4 Then SetFMVoice(2,4);
      If FMVoc[3] <> 4 Then SetFMVoice(3,4);
    End;
  End
  Else
  If Config.DoSound Then
  Begin
    FMVoc[Chan] := Voc And $F;
    Digital(Chan);
  End;

End; { SetVoice }


Procedure SetFrequency(Chan,Freq: Word);
Begin
{    SetFMFreq(Chan,Freq);}
(*
  If {(Chan = 2) And} (FMVoc[Chan] In [4,5,6,10,12,13,14]) Then
  Begin
    SetFMFreq(Chan,Freq);
{    Update_TIA_Sound($17 + Chan,Freq);}
    AUDV[Chan] := 0;
    OutVol[Chan] := 0;
{    If Not (FMVoc[Chan] In [4,5,6,10,12,13,14]) Then
    Begin
      Update_TIA_Sound($17 + Chan,Freq);
      AUDV[Chan] := 0;
      FillBuffer;
    End;}
  End
  Else
  Begin
{    SetFMScale(Chan,0);}
{    AUDC[Chan] := FMVoc[Chan];}
{    AUDV[Chan] := (FMRealScale[Chan] And $0F) Shl 3;}
    If {Update_TIA_Sound($15 + Chan,FMVoc[Chan]) Or}
       Update_TIA_Sound($17 + Chan,Freq) {Or
       Update_TIA_Sound($19 + Chan,FMRealScale[Chan])} Then FillBuffer;
  End;
*)

  If (Cart = ctPitfall2) And (Chan = 0) Then
  Begin
  End
   Else
   If Config.DoSound Then
   Begin
     FMFreq[Chan] := Freq And $1F;
     Digital(Chan);
   End;

End; { SetFrequency }


Procedure SetVolume(Chan,Scale: Word);
Begin
{    SetFMScale(Chan,Scale);}
(*
  If {(Chan = 2) And} (FMVoc[Chan] In [4,5,6,10,12,13,14]) Then
  Begin
    SetFMScale(Chan,Scale);
{    Update_TIA_Sound($19 + Chan,Scale);}
    AUDV[Chan] := 0;
    OutVol[Chan] := 0;
{    If Not (FMVoc[Chan] In [4,5,6,10,12,13,14]) Then
    Begin
      Update_TIA_Sound($19 + Chan,Scale);
      AUDV[Chan] := 0;
      FillBuffer;
    End;}
  End
  Else
  Begin
    SetFMScale(Chan,0);
{    AUDC[Chan] := FMVoc[Chan];
    AUDF[Chan] := FMFreq[Chan];}
{    AUDV[Chan] := (FMRealScale[Chan] And $0F) Shl 3;}
    If {Update_TIA_Sound($15 + Chan,FMVoc[Chan]) Or
       Update_TIA_Sound($17 + Chan,FMFreq[Chan]) Or}
       Update_TIA_Sound($19 + Chan,Scale) Then FillBuffer;
  End;
*)
  If (Cart = ctPitfall2) And (Chan = 0) Then
  Begin
    If Config.DoSound Then
    Begin
      If WaveLen[1] = 0
       Then SetFMFreq1(0,1)
       Else SetFMFreq1(0,WaveLen[1]);
      If WaveLen[2] = 0
       Then SetFMFreq1(2,1)
       Else SetFMFreq1(2,WaveLen[2]);
      If WaveLen[3] = 0
       Then SetFMFreq1(3,1)
       Else SetFMFreq1(3,WaveLen[3]);


      Case Signal[1] Of
        3: If FMRealScale[0] <> 13 Then SetFMScale(0,13);
      Else If FMRealScale[0] <> 0 Then SetFMScale(0,0);
      End; { Case }

      Case Signal[2] Of
        3: If FMRealScale[2] <> 14 Then SetFMScale(2,14);
      Else If FMRealScale[2] <> 0 Then SetFMScale(2,0);
      End; { Case }

      Case Signal[3] Of
        3: If FMRealScale[3] <> 15 Then SetFMScale(3,15);
      Else If FMRealScale[3] <> 0 Then SetFMScale(3,0);
      End; { Case }

    End;
  End
  Else
  If Config.DoSound Then
  Begin
    FMRealScale[Chan] := Scale And $F;
    Digital(Chan);
  End;

End; { SetVolume }


Procedure JoyStatus; Assembler;
{ ------------------------------------------------------------------------- }
{ Returns:                                                                  }
{    BL - JoyStatus                                                         }
{    CX - X1  SI - X2                                                       }
{    DX - Y1  DI - Y2                                                       }
{ ------------------------------------------------------------------------- }
Asm
  SUB    BX,BX
  SUB    CX,CX
  SUB    SI,SI
  SUB    DI,DI
  MOV    DX,0201h
  CLI
  SUB    AH,AH

  { Reset delays }

@L2:
  INC    BX
  CMP    BX,8000
  JE     @L2A
  IN     AL,DX
  TEST   AL,0Fh
  JNZ    @L2
@L2A:
  SUB    BX,BX

  OUT    DX,AL
  JMP    @L1
@L1:
  AAA

  { Get coordinates }

@L3:
  IN     AL,DX
  TEST   AL,1            { Player 1 X coordinate }
  JZ     @L4
  INC    BX
  CMP    BX,1000h
  JA     @L6
@L4:
  TEST   AL,2            { Player 1 Y coordinate }
  JZ     @L5
  INC    CX
  JC     @L6
  CMP    CX,1000h
  JA     @L6
@L5:
  IN     AL,DX
  TEST   AL,4            { Player 2 X coordinate }
  JZ     @L4A
  INC    SI
  CMP    SI,1000h
  JA     @L6
@L4A:
  TEST   AL,8            { Player 2 Y coordinate }
  JZ     @L5A
  INC    DI
  JC     @L6
  CMP    DI,1000h
  JA     @L6
@L5A:
  MOV    AH,0Fh
  TEST   BYTE PTR Config.UseJoystick2,0FFh
  JNZ    @Use2
  TEST   BYTE PTR Config.UseRealControllers,0FFh
  JNZ    @Use2
  MOV    AH,3
@Use2:
  TEST   AL,AH
  JNZ    @L3
@L6:
  STI
  MOV    DX,CX
  MOV    CX,BX
  MOV    BX,AX
  SUB    BH,BH
  SHR    BX,1
  SHR    BX,1
  SHR    BX,1
  SHR    BX,1
  XOR    BX,0Fh
End; { JoyStatus }

(*
Function HexByte(B: Byte): String;
Const Digit: String = '0123456789ABCDEF';
Begin
  HexByte := Digit[(B Shr 4) + 1] +
             Digit[(B And $F) + 1];
End; { HexByte }


Function HexWord(W: Word): String;
Const Digit: String = '0123456789ABCDEF';
Begin
  HexWord := Digit[((W Shr 12) And $F) + 1] +
             Digit[((W Shr 8) And $F) + 1] +
             Digit[((W Shr 4) And $F) + 1] +
             Digit[(W And $F) + 1];
End; { HexWord }
*)

Function Int2Str(L: LongInt): String;
Var St: String;
Begin
  Str(L,St);
  Int2Str := St;
End; {Int2Str }


Procedure Go_Mode(Mode: Byte);
Var Regs: Registers;
Begin
  Regs.AH := 0;
  Regs.AL := Mode;
  Intr($10,Regs);
End; { Go_Mode }


Function Timer: Real;
Begin
  Timer := (Mem[0:$46F] * 1677722.0 + Mem[0:$46E] * 65536.0 +
            Mem[0:$46D] * 256       + Mem[0:$46C]) / 18.20648;
End; { Timer }

(*
Procedure Unassemble(PC: Word; Var Bank: Word);
Var
  Addr     : Word;
  _Addr    : Word;
  B        : Byte;
  Instr    : String[3];
  Opcode   : Byte;
  _PC      : Word;
  NewBank  : Word;

Begin

  { Tally instructions }

  _PC            := PC - $1000 + Bank * 1024;
  Branched^[_PC] := True;
  While Not Executed^[_PC] Do
  Begin
    Executed^[_PC] := True;
    Opcode         := AtariSeg[PC];
    Instr          := Mnem[Opcode];

    { Handle some bankswitching }

    If ATyp[Opcode] = 'ABS' Then
    Begin
      Addr := MemW[Seg(AtariSeg):Ofs(AtariSeg) + PC + 1] And $1FFF;
      If BankSwitch[Addr] <> 0 Then
      Begin
        Case BankSwitch[Addr] Of
          1..13: Begin                             { 2k/4k/8k/16k }
                   NewBank := BankSwitch[Addr] - 1;
                   Move(Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + NewBank * 1024],AtariSeg[$1000],4096);
                   Unassemble(PC + Bytes[Opcode],NewBank);
                   Move(Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + Bank * 1024],AtariSeg[$1000],4096);
                 End;
       $21..$29: Begin                             { CBS }
                   NewBank := BankSwitch[Addr] - $21;
                   Move(Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + NewBank * 1024],AtariSeg[$1000],4096);
                   Unassemble(PC + Bytes[Opcode],NewBank);
                   Move(Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + Bank * 1024],AtariSeg[$1000],4096);
                 End;
       $40..$4F: Begin                             { SuperChip }
                   NewBank := (BankSwitch[Addr] - $40) Shl 2;
                   Move(Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + NewBank * 1024],AtariSeg[$1000],4096);
                   Unassemble(PC + Bytes[Opcode],NewBank);
                   Move(Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + Bank * 1024],AtariSeg[$1000],4096);
                 End;
        End; { Case }
      End;
    End;

    { Look for control transfer instructions }

    If (Instr = 'JSR') Or
       (Instr = 'BPL') Or
       (Instr = 'BMI') Or
       (Instr = 'BVC') Or
       (Instr = 'BVS') Or
       (Instr = 'BEQ') Or
       (Instr = 'BNE') Or
       (Instr = 'BCC') Or
       (Instr = 'BCS') Then
    Begin
      If Instr = 'JSR'
       Then Addr := MemW[Seg(AtariSeg):Ofs(AtariSeg) + PC + 1] And $1FFF
       Else
       Begin
         B := AtariSeg[PC + 1];
         Asm
           MOV   BX,WORD PTR PC
           ADD   BX,2
           MOV   AL,BYTE PTR B
           CBW
           ADD   BX,AX
           MOV   WORD PTR Addr,BX
         End; { Asm }
       End;
      _Addr            := Addr - $1000 + Bank * 1024;
{      Branched^[_Addr] := True;}
      Unassemble(Addr,Bank);
    End;
    If Instr <> 'RTS' Then
    Begin
      If Instr = 'JMP' Then
      Begin
        If ATyp[Opcode] = 'ABS'
         Then PC := MemW[Seg(AtariSeg):Ofs(AtariSeg) + PC + 1] And $1FFF
         Else PC := MemW[Seg(AtariSeg):Ofs(AtariSeg) +
                     MemW[Seg(AtariSeg):Ofs(AtariSeg) + PC + 1] And $1FFF] And $1FFF;
        _PC := PC - $1000 + Bank * 1024;
        Branched^[_PC] := True;
      End
      Else Inc(PC,Bytes[Opcode]);
    End;
    _PC := PC - $1000 + Bank * 1024;
  End; { While }
End; { Unassemble }
*)
{$F+}
Procedure Handle_TIA; Far; External;
{$L HAND_TIA.OBJ}
{$F-}

Procedure SwitchBank; Assembler;
Asm
  PUSH  DX
  PUSH  BX
  PUSH  AX
  PUSH  CX
  PUSH  DI
  PUSH  DS
  PUSH  SI

  MOV   BYTE PTR DebugLoad,0

  { Save the current bank to simulate RAM if necessary }

  CMP   BYTE PTR Cart,ctMNetwork
{  TEST  BYTE PTR MNetwork,0FFh}
  JNE   @NoCopyBack{CheckStarpath}

  CMP   BYTE PTR BankSwitch[BX],0DCh
  JAE   @NoCopyBack
  CMP   BYTE PTR BankSwitch[BX],0D8h
  JAE   @CopyBack256
  CMP   BYTE PTR CurrentBank,7
  JNE   @NoCopyBack



  MOV   SI,1000h
  MOV   CX,256
  MOV   AX,4000h
{  CMP   BYTE PTR CurrentBank,7
  JE    @NotCopying256}
  JMP   @NotCopying256

@CopyBack256:
  MOV   CX,64
  MOV   AH,BYTE PTR MNetworkRAM{CurrentBank}
  SUB   AH,8
  SUB   AL,AL
  ADD   AX,4400h
  MOV   SI,1800h
  ADD   SI,OFFSET AtariSeg
@NotCopying256:
  LES   DI,DWORD PTR ROMBackup
  ADD   DI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  JMP   @NoCopyBack


(*
  MOV   AL,BYTE PTR CurrentBank
  SUB   AH,AH
  SHL   AX,10
  MOV   SI,WORD PTR BankStart
  LES   DI,DWORD PTR ROMBackup
  ADD   DI,AX
  CLD
  MOV   CX,WORD PTR BankSize
  DB    _32BIT_OPERAND
  REP   MOVSW
  JMP   @NoCopyBack
*)


{@CheckStarpath:
  TEST  BYTE PTR Starpath,0FFh
  JZ    @NoCopyBack
  CMP   BX,1FF8h
  JNE   @NoCopyBack}


@NoCopyBack:

  { Find out which bank we're switching to }

  MOV   DL,CL  { Save accumulator }
  MOV   CX,AX  { Save X and Y }
  MOV   WORD PTR BankStart,1000h
  MOV   AL,BYTE PTR BankSwitch[BX]
  CMP   AL,29{16}
  JBE   @OneToFour

  { 30/31 means toggle between banks 1 and 2 }

  CMP   AL,0E0h
  JAE   @ParkerBros
  CMP   AL,0D0h
  JAE   @MNetwork

  CMP   AL,0CBh{0CEh}
  JAE   @Pitfall2

  CMP   AL,80h
  JAE   @MegaBoy

  CMP   AL,070h
  JAE   @Starpath

  CMP   AL,060h
  JE    @TigerVision

{
  CMP   AL,060h
  JAE   @Pitfall2
}
  CMP   AL,040h
  JAE   @SuperChip
  CMP   AL,20h
  JAE   @CBS
{
  CMP   AL,21
  JE    @Act1
  CMP   AL,17
  JE    @Act1
  SUB   AL,AL
  DEC   BYTE PTR BankSwitch[BX]
  JMP   @Act2
@Act1:
}
  XOR   BYTE PTR BankSwitch[BX],1{4}
  SUB   AL,30
  SHL   AL,2
{  SUB   AL,17}
  XOR   AL,4
{
  JNZ   @Act2
  MOV   BYTE PTR BankSwitch[BX],19
@Act2:
}
  INC   AL
  JMP   @OneToFour

  { Handle 32-in-1 MegaBoy }

@MegaBoy:
  INC   BYTE PTR MegaBoyNum
  AND   BYTE PTR MegaBoyNum,0Fh
  CMP   BYTE PTR MegaBoyNum,0Fh
  JNE   @NotMBLast
  MOV   CX,3FCh
  MOV   AX,DS
  MOV   ES,AX
  MOV   DI,1000h
  ADD   DI,OFFSET AtariSeg
  CLD
  PUSH  DS
  SUB   AX,AX
  MOV   AL,BYTE PTR MegaBoyNum
  SHL   AX,12
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   DS
  MOV   SI,OFFSET MegaBoy
  MOV   CX,4
  DB    _32BIT_OPERAND
  REP   MOVSW
(*
  PUSH  DS
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   DS
  MOV   SI,OFFSET MegaBoy
  MOV   CX,4
  DB    _32BIT_OPERAND
  REP   MOVSW
*)
  JMP   @GetOut
@NotMBLast:
  MOV   CX,400h
  MOV   AX,DS
  MOV   ES,AX
  MOV   DI,1000h
  ADD   DI,OFFSET AtariSeg
  CLD
  PUSH  DS
  SUB   AX,AX
  MOV   AL,BYTE PTR MegaBoyNum
  SHL   AX,12
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
{  PUSH  SI}
  DB    _32BIT_OPERAND
  REP   MOVSW
{  POP   SI}
(*
  MOV   CX,200h
  DB    _32BIT_OPERAND
  REP   MOVSW
*)
  POP   DS
  JMP   @GetOut

  { Handle Starpath Supercharger }

@Starpath:
(*  CMP   BYTE PTR [DI],0CDh   { Look for CMP abs/abs. x/abs. y }
  JE    @SPYes
  CMP   BYTE PTR [DI],0D9h
  JE    @SPYes
  CMP   BYTE PTR [DI],0DDh
  JE    @SPYes
  POP   SI
  POP   DS
  JMP   @NoDebug
@SPYes:*)
{  CMP   BX,11FEh
  JA    @Write}
{  CMP   WORD PTR StarpathLastAddr,0
  JNE   @Write}
{@NoWrite:}

{  CMP   WORD PTR [DI + 1],0EFF0h
  JB    @NotRAM
  CMP   WORD PTR [DI + 1],0F0FFh
  JA    @Write
  JMP   @NoWrite}



{ -------------------------------------------------------- }
{ Intermediate Starpath code begins here                   }
{ -------------------------------------------------------- }

(*
  PUSH  BX
  TEST  BYTE PTR StarpathWrite,1
  JNZ   @MustBeWriting
@GetAddress:

  { Check for indirect Y }

  MOV   AL,BYTE PTR [DI]
  PUSH  DS
  MOV   DS,WORD PTR Global_Save_DS
  MOV   SI,AX
  AND   SI,0FFh
  SHL   SI,2
  MOV   DX,WORD PTR ATyp[SI + 1]
  MOV   AL,BYTE PTR ATyp[SI + 3]
  POP   DS
  CMP   DL,'I'             { Indirect/Immediate }
  JNE   @NotIndY
  CMP   DH,'.'             { Indirect }
  JNE   @NotIndY
  CMP   AL,'Y'             { Indirect Y }
  JNE   @NotIndY
  MOV   CX,WORD PTR [DI + 1]
  CMP   CX,1000h
  JB    @NotIndY
  CMP   CX,10FFh
  JA    @NotIndY
  MOV   BX,CX
@NotIndY:
  CMP   BX,010FFh
  JA    @NotRAM
  MOV   BYTE PTR StarpathWrite,1
  MOV   BYTE PTR StarpathWriteValue,BL
  JMP   @NotRAM
@MustBeWriting:
  MOV   BYTE PTR StarpathWrite,0
  CMP   BX,1100h
  JB    @GetAddress
  CMP   BX,1FF8h                            { Always write enabled }
  JE    @Writing
  TEST  BYTE PTR SPBankNum,2         { If write isn't enabled, exit }
  JZ    @NotRAM
  CMP   BX,1800h
  JB    @Writing
  TEST  BYTE PTR SPBankNum,8         { Can't write to the ROM area }
  JZ    @NotRAM
@Writing:
  MOV   AL,BYTE PTR StarpathWriteValue
  MOV   BYTE PTR [BX],AL
  CMP   BX,1FF8h                            { Check for bank switch }
  JNE   @NotRAM                             { Exit if not }

  { Perform a bank switch }

  { Copy back to ROM backup to simulate RAM }

  PUSH  DI
  PUSH  BX

  TEST  BYTE PTR Debugger,0FFh
  JZ    @NoDebugA
  MOV   BX,WORD PTR OldStart
  CMP   BX,1000h
  JL    @NoDebugA
  MOV   AL,BYTE PTR OldByte
  MOV   BYTE PTR [BX],AL
@NoDebugA:

  MOV   BL,BYTE PTR SPBankNum
  SHR   BL,1
  AND   BL,0Eh
  SUB   BH,BH

  MOV   AX,WORD PTR SP1[BX]       { Copy the low bank }
  MOV   CX,200h
  MOV   SI,1000h
  LES   DI,DWORD PTR ROMBackup
  ADD   DI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW

  MOV   AX,WORD PTR SP2[BX]       { Copy the high bank }
  MOV   CX,200h
  MOV   SI,1800h
  LES   DI,DWORD PTR ROMBackup
  ADD   DI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW

  POP   BX
  POP   DI

  { Copy in the new banks }

  MOV   BX,DS
  MOV   ES,BX
  MOV   BL,AtariSeg[1FF8h]
  MOV   DL,BL
  SHR   BL,1
  AND   BL,0Eh
  SUB   BH,BH

  MOV   AX,WORD PTR SP1[BX]       { Copy the low bank }
  MOV   CX,200h
  MOV   DI,1000h
  PUSH  DS
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   DS

  MOV   AX,WORD PTR SP2[BX]       { Copy the high bank }
  MOV   CX,200h
  MOV   DI,1800h
  PUSH  DS
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   DS

  MOV   BYTE PTR SPBankNum,DL      { Set to the new bank }
  MOV   BYTE PTR AtariSeg[1FF8h],DL
  POP   BX
  JMP   @GetOut

@NotRAM:
  POP   BX
  POP   SI
  POP   DS
  JMP   @NoDebug
*)

{ -------------------------------------------------------- }
{ Intermediate Starpath code ends here                     }
{ -------------------------------------------------------- }


{ -------------------------------------------------------- }
{ New Starpath code begins here                            }
{ -------------------------------------------------------- }
{
  PUSH  OFFSET AtariSeg
  PUSH  DS

}  MOV   AX,WORD PTR SPBankNum
{  MOV   DS,WORD PTR Global_Save_DS}
{
  DB    _32BIT_OPERAND
  PUSH  WORD PTR AtariSeg
}

  DB    _32BIT_OPERAND
  PUSH  WORD PTR ASeg

  DB    _32BIT_OPERAND
  PUSH  WORD PTR ROMBackup
  SUB   DI,OFFSET AtariSeg
  PUSH  DI
  PUSH  BX
  PUSH  AX


  PUSH  WORD PTR TIA_Count
  PUSH  WORD PTR TIA_Scan
  PUSH  WORD PTR ROMSize

  TEST  BYTE PTR Debugger,0FFh
  JZ    @NoDebugA1
  MOV   BX,WORD PTR OldStart
  CMP   BX,1000h
  JL    @NoDebugA1
  MOV   CL,BYTE PTR OldByte
  MOV   BYTE PTR AtariSeg[BX],CL
@NoDebugA1:

  CALL  HandleStarpath
  MOV   CL,BYTE PTR SPBank

  MOV   BYTE PTR SPBankNum,CL



  TEST  BYTE PTR Debugger,0FFh
  JZ    @NoDebugA
{  TEST  AL,0FFh
  JZ    @NoDebugA}
  MOV   BX,WORD PTR OldStart
  CMP   BX,1000h
  JL    @NoDebugA
  MOV   CL,BYTE PTR AtariSeg[BX]
  MOV   BYTE PTR OldByte,CL
  MOV   BYTE PTR AtariSeg[BX],BreakInstruction
@NoDebugA:
  POP   SI
  POP   DS
  JMP   @NoDebug


{ -------------------------------------------------------- }
{ New Starpath code ends here                              }
{ -------------------------------------------------------- }

{ -------------------------------------------------------- }
{ Old Starpath code begins here                            }
{ -------------------------------------------------------- }

(*
  MOV   AL,BYTE PTR [DI]
  PUSH  DS
  MOV   DS,WORD PTR Global_Save_DS
  MOV   SI,AX
  AND   SI,0FFh
{  MOV   AH,BYTE PTR SPBank[SI]}
  SHL   SI,2
  MOV   DX,WORD PTR ATyp[SI + 1]
  MOV   AL,BYTE PTR ATyp[SI + 3]
  POP   DS
{  TEST  AH,0FFh
  JZ    @NotRAM}


  CMP   DL,'I'             { Indirect/Immediate }
  JE    @SPContI
  CMP   DL,'A'             { Absolute/Accumulator }
  JE    @SPContA
  JMP   @NotRAM
@SPContA:
  CMP   DH,'C'             { Accumulator }
  JE    @NotRAM
  JMP   @SPCont1
@SPContI:
  CMP   DH,'.'             { Indirect }
  JNE   @NotRAM
@SPCont1:


  CMP   BX,01000h
  JB    @NotRAM
  CMP   BX,010FFh
  JBE   @NoWrite
  CMP   BX,011FEh
  JA    @Write




  CMP   DL,'I'
  JE    @Indirect
  CMP   DL,'A'
  JNE   @NotRAM
  CMP   DH,'B'            { ABS/A.X/A.Y/ACC }
  JE    @Write
  CMP   DH,'C'
  JE    @NotRAM
  CMP   AL,'Y'
  JE    @SubY
  SUB   CH,CH             { Absolute X }
  MOV   SI,BX
  SUB   SI,CX
  CMP   SI,010FFh
  JA    @Write
  JMP   @NoWrite
@Indirect:                { IMP/I.X/I.Y/IMM/I+A }
  CMP   DH,'.'
  JNE   @NotRAM
  CMP   AL,'X'
  JE    @Write
@SubY:
  MOV   CL,CH             { Absolute Y }
  SUB   CH,CH
  MOV   SI,BX
  SUB   SI,CX
  CMP   SI,010FFh
  JA    @Write
  JMP   @NoWrite

@NoWrite:
  MOV   WORD PTR StarpathLastAddr,BX
@NotRAM:
  POP   SI
  POP   DS
  JMP   @NoDebug
@Write:
  CMP   WORD PTR StarPathLastAddr,0
  JE    @NotRAM
  CMP   BX,1FF8h
  JE    @SPCont
  TEST  BYTE PTR SPBankNum,2{[1FF8h],2}
  JZ    @NotRAM
  MOV   AL,BYTE PTR StarpathLastAddr
  MOV   BYTE PTR AtariSeg[BX],AL
  MOV   WORD PTR StarPathLastAddr,0
  POP   SI
  POP   DS
  JMP   @NoDebug

@SPCont:

  { Copy back to ROM backup to simulate RAM }

  PUSH  DI
  PUSH  BX

  TEST  BYTE PTR Debugger,0FFh
  JZ    @NoDebugA
  MOV   BX,WORD PTR OldStart
  CMP   BX,1000h
  JL    @NoDebugA
  MOV   AL,BYTE PTR OldByte
  MOV   BYTE PTR AtariSeg[BX],AL
@NoDebugA:

  MOV   BL,BYTE PTR SPBankNum{[1FF8h]}
  SHR   BL,1
  AND   BL,0Eh
  SUB   BH,BH
  MOV   AX,WORD PTR SP1[BX]
  MOV   CX,200h
  MOV   SI,1000h
  LES   DI,DWORD PTR ROMBackup
  ADD   DI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW

  MOV   AX,WORD PTR SP2[BX]
  MOV   CX,200h
  MOV   SI,1800h
  LES   DI,DWORD PTR ROMBackup
  ADD   DI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW

  POP   BX
  POP   DI

  { Copy in the new banks }

  MOV   BX,DS
  MOV   ES,BX
  MOV   BL,BYTE PTR StarpathLastAddr
  MOV   DL,BL
  SHR   BL,1
  AND   BL,0Eh
  SUB   BH,BH

  MOV   AX,WORD PTR SP1[BX]
  MOV   CX,200h
  MOV   DI,1000h
  PUSH  DS
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   DS

  MOV   AX,WORD PTR SP2[BX]
  MOV   CX,200h
  MOV   DI,1800h
  PUSH  DS
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   DS

  MOV   BYTE PTR SPBankNum,DL{[1FF8h],DL}
  MOV   WORD PTR StarPathLastAddr,0
  JMP   @GetOut
*)
{ -------------------------------------------------------- }
{ Old Starpath code ends here                              }
{ -------------------------------------------------------- }


  { Handle TigerVision games }

@TigerVision:
  MOV   AL,BYTE PTR AtariSeg[003Fh]
  CMP   AL,BYTE PTR TigerLimit
  JBE   @TigerLimitOk
  MOV   AL,BYTE PTR TigerLimit
@TigerLimitOk:
{  AND   AX,3}
  MOV   BYTE PTR CurrentBank,AL
  SHL   AX,11
  MOV   BX,DS
  MOV   ES,BX
  MOV   DI,1000h{WORD PTR BankStart}
  ADD   DI,OFFSET AtariSeg
  MOV   CX,512{WORD PTR BankSize}
  MOV   BYTE PTR DebugLoad,1
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  JMP   @GetOut


  { Handle Pitfall II }

@Pitfall2:

  CMP   AL,0CDh
  JB    @PF2Copy

  PUSH  AX
  PUSH  BX
  PUSH  CX
  PUSH  DX

  AND   AX,0FFh
  AND   DX,0FFh

{  PUSH  OFFSET AtariSeg
  PUSH  DS}

  DB    _32BIT_OPERAND
  PUSH  WORD PTR ASeg

{
  DB    _32BIT_OPERAND
  PUSH  WORD PTR AtariSeg
}
  PUSH  AX
  PUSH  BX
  PUSH  CX
  PUSH  DX
  SUB   DI,OFFSET AtariSeg
  PUSH  DI
  CALL  HandlePitfall2

  POP   DX
  POP   CX
  POP   BX
  POP   AX

  POP   SI
  POP   DS
  JMP   @NoDebug
@PF2Copy:

  MOV   BX,DS
  MOV   ES,BX
  MOV   SI,80h
  CMP   AL,0CCh
  JNE   @PF2C1
  MOV   SI,1080h
@PF2C1:
  MOV   DI,1080h
  ADD   DI,OFFSET AtariSeg
  MOV   CX,1E0h
  PUSH  DS
  MOV   BX,WORD PTR ROMBackup[2]
  ADD   SI,WORD PTR ROMBackup
  MOV   DS,BX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   DS
  ADD   SI,80h
  ADD   DI,80h
  MOV   CX,1E0h
  PUSH  DS
  MOV   BX,WORD PTR ROMBackup[2]
  MOV   DS,BX
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   DS

  MOV   BYTE PTR DebugLoad,1
  JMP   @GetOut
{
  POP   SI
  POP   DS
  MOV   BYTE PTR DebugLoad,1
  JMP   @NoDebug
}
(*
  CMP   AL,0CEh
  JE    @PF2Read
  MOV   AL,BYTE PTR AtariSeg[BX]
  MOV   BYTE PTR AtariSeg[BX - 40h],AL
  XOR   BX,800h
  MOV   BYTE PTR AtariSeg[BX],AL
  MOV   BYTE PTR AtariSeg[BX - 40h],AL
  XOR   BX,800h
  POP   SI
  POP   DS
  JMP   @NoDebug
@PF2Read:
  AND   BX,03Fh
  INC   WORD PTR PF2ReadCount[BX]
  MOV   CX,WORD PTR PF2ReadCount[BX]
  CMP   CX,39Bh
  JB    @NoPF2Roll
  SUB   CX,CX
  MOV   WORD PTR PF2ReadCount[BX],CX
@NoPF2Roll:
{  AND   CX,3F00h}
  SHL   CX,10
  MOV   SI,CX
  ADD   SI,BX
  MOV   AX,WORD PTR PF2Read[2]
  MOV   ES,AX
  ADD   SI,WORD PTR PF2Read
  MOV   AL,ES:[SI]
  MOV   BYTE PTR AtariSeg[BX + 1000h],AL
  MOV   BYTE PTR AtariSeg[BX + 1800h],AL
*)
  POP   SI
  POP   DS
  JMP   @NoDebug

(*
  SUB   AL,060h
  DEC   AL
  MOV   BYTE PTR CurrentBank,AL
  SUB   AH,AH
  SHL   AX,10
  MOV   BX,DS
  MOV   ES,BX
  MOV   DI,WORD PTR BankStart
  ADD   DI,80h

  MOV   CX,WORD PTR BankSize
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  ADD   SI,80h
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW

  MOV   CX,WORD PTR BankSize
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  ADD   SI,880h
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW

  JMP   @GetOut
*)
  { Handle 16K Atari super chip }

@SuperChip:

  CMP   AL,5Fh
  JB    @SwitchSC

  { Copy RAM write area to the read area }

  MOV   AL,BYTE PTR AtariSeg[BX]
  MOV   BYTE PTR AtariSeg[BX + 80h],AL
  JMP   @GetOut

  { Switch the bank, but don't copy over the RAM area }

@SwitchSC:
  SUB   AL,040h
{  DEC   AL}
  MOV   BYTE PTR CurrentBank,AL
  SUB   AH,AH
  SHL   AX,12{10}
  MOV   BX,DS
  MOV   ES,BX
  MOV   DI,WORD PTR BankStart
  ADD   DI,100h
  ADD   DI,OFFSET AtariSeg
  MOV   CX,WORD PTR BankSize
  MOV   BYTE PTR DebugLoad,1
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  ADD   SI,100h
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  JMP   @GetOut

  { Handle Parker Brothers special bank switching }

@ParkerBros:
  SUB   AL,0E0h
  MOV   BL,AL
  AND   AL,7
  INC   AL
  AND   BX,18h
  SHL   BX,7
  ADD   BX,1000h
  MOV   WORD PTR BankStart,BX
  JMP   @OneToFour

  { Handle M-Network bank switching }

@MNetwork:
  SUB   AL,0D0h
{
  CMP   BYTE PTR CurrentBank,8
  JB    @NoCopyHiROM
  CMP   AL,8
  JAE   @NoCopyHiROM

  MOV   CX,DS
  MOV   ES,CX
  MOV   DI,1800h
  MOV   CX,512
  PUSH  DS
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,3800h
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   DS

@NoCopyHiROM:
}
  CMP   AL,0Ch
  JAE   @NoSaveBankNum
  MOV   BYTE PTR CurrentBank,AL
@NoSaveBankNum:

  CMP   AL,7
  JB    @LoadROM
  CMP   AL,0Ch
  JNE   @Not1kWrite
  CMP   BYTE PTR CurrentBank,7
  JNE   @GetOut
  MOV   AL,BYTE PTR AtariSeg[BX]
  MOV   BYTE PTR AtariSeg[BX + 1024],AL
  JMP   @GetOut
@Not1kWrite:
  CMP   AL,0Dh
  JNE   @Not256Write
{  CMP   BYTE PTR CurrentBank,8
  JB    @GetOut}
  MOV   AL,BYTE PTR AtariSeg[BX]
  MOV   BYTE PTR AtariSeg[BX + 256],AL
  JMP   @GetOut
@Not256Write:
  MOV   CX,256
  MOV   DX,4000h
  MOV   DI,1000h
  CMP   AL,8
  JB    @Not256
  MOV   BYTE PTR MNetworkRAM,AL
  SHR   CX,2
  MOV   DH,AL
  SUB   DH,8
  SUB   DL,DL
  ADD   DX,4400h
  MOV   DI,1800h
@Not256:
  ADD   DI,OFFSET AtariSeg
  MOV   BX,DS
  MOV   ES,BX

  { Load a 1k/256-byte RAM bank }

  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,DX
  CLD
  PUSH  SI
  PUSH  CX
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   CX
  POP   SI
  DB    _32BIT_OPERAND
  REP   MOVSW
  JMP   @GetOut
@LoadROM:
  SUB   AH,AH
  SHL   AX,11
  MOV   BX,DS
  MOV   ES,BX
  MOV   DI,1000h
  ADD   DI,OFFSET AtariSeg
  MOV   CX,512
  MOV   BYTE PTR DebugLoad,1
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  JMP   @GetOut

  { Handle CBS RAM-Plus bank switching }

@CBS:
  CMP   AL,30h
  JB    @Switch

  { Copy RAM write area to the read area }

  MOV   AL,BYTE PTR AtariSeg[BX]
  MOV   BYTE PTR AtariSeg[BX + 100h],AL
  JMP   @GetOut

  { Switch the bank, but don't copy over the RAM area }

@Switch:
  SUB   AL,020h
  DEC   AL
  MOV   BYTE PTR CurrentBank,AL
  SUB   AH,AH
  SHL   AX,10
  MOV   BX,DS
  MOV   ES,BX
  MOV   DI,WORD PTR BankStart
  ADD   DI,200h
  ADD   DI,OFFSET AtariSeg
  MOV   CX,WORD PTR BankSize
  MOV   BYTE PTR DebugLoad,1
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  ADD   SI,200h
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  JMP   @GetOut

  { Copy in the new bank }

@OneToFour:
  DEC   AL
  MOV   BYTE PTR CurrentBank,AL
  SUB   AH,AH
  SHL   AX,10
  MOV   BX,DS
  MOV   ES,BX
  MOV   DI,WORD PTR BankStart
  ADD   DI,OFFSET AtariSeg
  MOV   CX,WORD PTR BankSize

  CMP   BYTE PTR Cart,ctPitfall2
  JNE   @NotP2
  MOV   CX,01E0h
  ADD   AX,80h
  ADD   DI,80h

  MOV   BYTE PTR DebugLoad,1
  PUSH  DS
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   DS

  MOV   CX,01E0h
  ADD   DI,80h
  ADD   AX,800h

  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW

  JMP   @GetOut
@NotP2:
  MOV   BYTE PTR DebugLoad,1
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
@GetOut:
  POP   SI
  POP   DS
  TEST  BYTE PTR Debugger,0FFh
  JZ    @NoDebug
  MOV   BX,WORD PTR OldStart
  CMP   BX,1000h
  JL    @NoDebug

  CMP   BYTE PTR Cart,ctTigerVision
  JNE   @CheckMNetwork
  CMP   BX,1800h
  JAE   @NoDebug
  JMP   @DoDebug
@CheckMNetwork:
  CMP   BYTE PTR Cart,ctMNetwork
  JNE   @CheckParkerBros
  CMP   BX,1800h
  JAE   @NoDebug
@CheckParkerBros:
  CMP   BYTE PTR Cart,ctParkerBros
  JNE   @DoDebug
  CMP   BX,WORD PTR BankStart
  JL    @NoDebug
  MOV   AX,WORD PTR BankStart
  ADD   AX,1024
  CMP   BX,AX
  JGE   @NoDebug
@DoDebug:
  TEST  BYTE PTR DebugLoad,0FFh
  JZ    @NoDebug
{  CMP   BYTE PTR CurrentBank,7}
{  JAE   @NoDebug}
  MOV   AL,BYTE PTR AtariSeg[BX]
  MOV   BYTE PTR OldByte,AL
  MOV   BYTE PTR AtariSeg[BX],BreakInstruction
@NoDebug:
  POP   DI
  POP   CX
  POP   AX
  POP   BX
  POP   DX
End; { SwitchBank }


Procedure ResetClock;
Begin
  Time0 := Clock;
End; { ResetClock }


Procedure Read_Real; Assembler;
Asm
  MOV   DX,WORD PTR Config.LPT1Port
  ADD   DX,2
  TEST  BYTE PTR AtariSeg[SWACNT1],1
  JZ    @Input
  MOV   AL,0Bh
  OUT   DX,AL
  SUB   DX,2
  JMP   @LO1
@LO1:
  JMP   @LO2
@LO2:
  JMP   @LO3
@LO3:
  MOV   AL,BYTE PTR AtariSeg[SWCHA1]
  OUT   DX,AL
  JMP   @GetOut
@Input:
  MOV   AL,2Bh
  OUT   DX,AL
  SUB   DX,2
  JMP   @LI1
@LI1:
  JMP   @LI2
@LI2:
  JMP   @LI3
@LI3:
  IN    AL,DX
@GetOut:
  MOV   BYTE PTR AtariSeg[SWCHA1],AL
  MOV   BYTE PTR AtariSeg[SWCHA2],AL

  { Look at fire buttons }

  MOV   DX,201h
  SUB   AL,AL
  OUT   DX,AL

  JMP   @RR1
@RR1:
  JMP   @RR2
@RR2:
  JMP   @RR3
@RR3:

  IN    AL,DX
  SHR   AL,4
  XOR   AL,0Fh
  TEST  BYTE PTR Latched,1
  JNZ   @Latched
  XOR   AL,0FFh
  ROR   AL,1
  MOV   AH,AL
  AND   AH,80h
  MOV   BYTE PTR Input_Byte[INPUT4],AH
  ROR   AL,1{2}
  AND   AL,80h
  MOV   BYTE PTR Input_Byte[INPUT5],AL
  JMP   @NextTest

@Latched:
  TEST  AL,1
  JZ    @Button2
  AND   BYTE PTR Input_Byte[INPUT4],7Fh
@Button2:
  TEST  AL,2{4}
  JZ    @NextTest
  AND   BYTE PTR Input_Byte[INPUT5],7Fh
@NextTest:

  { Copy info }

  MOV   AL,BYTE PTR AtariSeg[SWCHB1]
  AND   AL,7
  OR    AL,BYTE PTR ColorOrBW
  OR    AL,BYTE PTR Difficulty1
  OR    AL,BYTE PTR Difficulty2
  OR    AL,3
  AND   AL,0CFh

  OR    AL,14h      { Bits 2 and 4 are always 1 }
  MOV   AH,AL       { Bit 5 mirrors bit 6       }
  SHR   AH,1
  AND   AH,20h
  OR    AL,AH

  MOV   BYTE PTR AtariSeg[SWCHB1],AL
  MOV   BYTE PTR AtariSeg[SWCHB2],AL

  { Check function keys And CBS Booster-Grip keys }

  TEST  BYTE PTR Key[kF1],0FFh
  JZ    @CheckF2
{$IFDEF LOWRES}
  PUSH  160
{$ELSE}
  PUSH  320
{$ENDIF}
  PUSH  WORD PTR MaxRows
  PUSH  DS
  PUSH  OFFSET Difficulty1
  PUSH  DS
  PUSH  OFFSET Difficulty2
  PUSH  DS
  PUSH  OFFSET AutoCenter
  CALL  GameStatus
  CALL  ResetClock
@CheckF2:
  TEST  BYTE PTR Key[kF2],0FFh
  JZ    @CheckF4
  AND   BYTE PTR AtariSeg[SWCHB1],0FEh
@CheckF4:
  TEST  BYTE PTR Key[kF4],0FFh
  JZ    @CheckF5
  AND   BYTE PTR AtariSeg[SWCHB1],0FDh
@CheckF5:
  TEST  BYTE PTR Key[kF5],0FFh
  JZ    @PreCheckF6
  TEST  BYTE PTR ColorOrBWChange,0FFh
  JZ    @CheckF6
  XOR   BYTE PTR ColorOrBW,8
  MOV   BYTE PTR ColorOrBWChange,0
  JMP   @CheckF6
@PreCheckF6:
  MOV   BYTE PTR ColorOrBWChange,1
@CheckF6:
  TEST  BYTE PTR Key[kF6],0FFh
  JZ    @PreCheckF7
  TEST  BYTE PTR Difficulty1Change,0FFh
  JZ    @CheckF7
  XOR   BYTE PTR Difficulty1,40h
  MOV   BYTE PTR Difficulty1Change,0
  JMP   @CheckF7
@PreCheckF7:
  MOV   BYTE PTR Difficulty1Change,1
@CheckF7:
  TEST  BYTE PTR Key[kF7],0FFh
  JZ    @PreCheckF10
  TEST  BYTE PTR Difficulty2Change,0FFh
  JZ    @CheckF10
  XOR   BYTE PTR Difficulty2,80h
  MOV   BYTE PTR Difficulty2Change,0
  JMP   @CheckF10
@PreCheckF10:
  MOV   BYTE PTR Difficulty2Change,1
@CheckF10:
  TEST  BYTE PTR Key[kF10],0FFh
  JZ    @PreCheckUp
  TEST  BYTE PTR AutoCenterChange,0FFh
  JZ    @CheckUp
  XOR   BYTE PTR AutoCenter,1
  MOV   BYTE PTR AutoCenterChange,0
  JMP   @CheckUp
@PreCheckUp:
  MOV   BYTE PTR AutoCenterChange,1
@CheckUp:
End; { Read_Real }


Procedure CheckKBController; Assembler;
Asm
  CMP   BYTE PTR Controller,crKeyboard
  JE    @CheckKB
  CMP   BYTE PTR Controller,crVTP
  JE    @CheckKB
  JMP   @GetOut
@CheckKB:

  TEST  BYTE PTR Config.UseRealControllers,0FFh
  JZ    @NotReal
  CALL  Read_Real
{  TEST  BYTE PTR KBWrite,0FFh
  JNZ   @GetOut}

{
  CALL  JoyStatus
  OR    BYTE PTR Input_Byte[INPUT0],80h
  OR    BYTE PTR Input_Byte[INPUT1],80h
  OR    BYTE PTR Input_Byte[INPUT2],80h
  OR    BYTE PTR Input_Byte[INPUT3],80h
  CMP   DX,4097
  JNZ   @KB1
  AND   BYTE PTR Input_Byte[INPUT0],7Fh
@KB1:
  CMP   CX,4097
  JNZ   @KB2
  AND   BYTE PTR Input_Byte[INPUT1],7Fh
@KB2:
  CMP   DI,4097
  JNZ   @KB3
  AND   BYTE PTR Input_Byte[INPUT2],7Fh
@KB3:
  CMP   SI,4097
  JNZ   @KB4
  AND   BYTE PTR Input_Byte[INPUT3],7Fh
@KB4:
}



  OR    BYTE PTR Input_Byte[INPUT0],80h
  OR    BYTE PTR Input_Byte[INPUT1],80h
  OR    BYTE PTR Input_Byte[INPUT2],80h
  OR    BYTE PTR Input_Byte[INPUT3],80h

  MOV   DX,0201h
  SUB   AL,AL
  OUT   DX,AL

  MOV   CX,1000
@_KB1:
  LOOP  @_KB1

{
  JMP   @_KB1
@_KB1:
  JMP   @_KB2
@_KB2:
  JMP   @_KB3
@_KB3:
}

  IN    AL,DX

  TEST  AL,2
  JZ    @KB1
  AND   BYTE PTR Input_Byte[INPUT0],7Fh
@KB1:
  TEST  AL,1
  JZ    @KB2
  AND   BYTE PTR Input_Byte[INPUT1],7Fh
@KB2:
  TEST  AL,8
  JZ    @KB3
  AND   BYTE PTR Input_Byte[INPUT2],7Fh
@KB3:
  TEST  AL,4
  JZ    @KB4
  AND   BYTE PTR Input_Byte[INPUT3],7Fh
@KB4:


  JMP   @GetOut
@NotReal:

  MOV   BL,BYTE PTR AtariSeg[SWCHA1]
  MOV   AX,1001h
  MOV   CX,4
  MOV   BH,BYTE PTR AtariSeg[VBLANK]
@KeyLoop1:
  TEST  BL,AL
  JNZ   @NoTest

  CMP   BYTE PTR Controller,crVTP
  JE    @Row4

  TEST  BYTE PTR KeyColumn[0],AH
  JZ    @Off1
  TEST  BH,80h
  JNZ   @Off1
  AND   BYTE PTR Input_Byte[INPUT0],7Fh
  JMP   @Row2
@Off1:
  OR    BYTE PTR Input_Byte[INPUT0],80h
@Row2:

  TEST  BYTE PTR KeyColumn[1],AH
  JZ    @Off2
  TEST  BH,80h
  JNZ   @Off2
  AND   BYTE PTR Input_Byte[INPUT1],7Fh
  JMP   @Row3
@Off2:
  OR    BYTE PTR Input_Byte[INPUT1],80h
@Row3:

  TEST  BYTE PTR KeyColumn[2],AH
  JZ    @Off3
  AND   BYTE PTR Input_Byte[INPUT4],7Fh
  JMP   @Row4
@Off3:
  OR    BYTE PTR Input_Byte[INPUT4],80h
@Row4:

  TEST  BYTE PTR KeyColumn[0],AL
  JZ    @Off4
  TEST  BH,80h
  JNZ   @Off4
  AND   BYTE PTR Input_Byte[INPUT2],7Fh
  JMP   @Row5
@Off4:
  OR    BYTE PTR Input_Byte[INPUT2],80h
@Row5:

  TEST  BYTE PTR KeyColumn[1],AL
  JZ    @Off5
  TEST  BH,80h
  JNZ   @Off5
  AND   BYTE PTR Input_Byte[INPUT3],7Fh
  JMP   @Row6
@Off5:
  OR    BYTE PTR Input_Byte[INPUT3],80h
@Row6:

  TEST  BYTE PTR KeyColumn[2],AL
  JZ    @Off6
  AND   BYTE PTR Input_Byte[INPUT5],7Fh
  JMP   @NoTest
@Off6:
  OR    BYTE PTR Input_Byte[INPUT5],80h

@NoTest:
  ADD    AL,AL
  ADD    AH,AH
  DEC    CX
  JNZ    @KeyLoop1
@GetOut:
End; { CheckKBController }


Procedure NewPalette;
Begin
  If Palette = 0 Then SetPalette(Pal) Else SetPalette(Pal1);
  Repeat Until Key[kF3] = 0;
End; { NewPalette }


Procedure Handle_Input; Assembler;
{ ---------------------------------------------------------------------- }
{ Any variables this accesses must either be global or contained here!!! }
{ ---------------------------------------------------------------------- }
{ Joy ---- BL }
{ X ------ CX }
{ Y ------ DX }
{  Joy := JoyStatus(X,Y);}
Asm
  TEST  BYTE PTR Key[kF3],0FFh
  JZ    @CheckEqual
  XOR   BYTE PTR Palette,1
  CALL  NewPalette
@CheckEqual:
  TEST  BYTE PTR Key[kEQUAL],0FFh
  JZ    @CheckMinus
  CMP   WORD PTR VUserAdd,-40
  JLE   @CheckMinus
  DEC   WORD PTR VUserAdd
@CheckMinus:
  TEST  BYTE PTR Key[kMINUS],0FFh
  JZ    @CheckReal
  CMP   WORD PTR VUserAdd,40
  JGE   @CheckReal
  INC   WORD PTR VUserAdd
@CheckReal:
  TEST  BYTE PTR Config.UseRealControllers,0FFh
  JZ    @NotReal
  CALL  Read_Real
  CMP   BYTE PTR Cart,ctCBS
  JNE   @NotRealCBS
  CALL  JoyStatus
  AND   WORD PTR Input_Byte[INPUT0],7F7Fh
  CMP   DX,20
  JAE   @CheckCBS2
  OR    BYTE PTR Input_Byte[INPUT0],80h
@CheckCBS2:
  CMP   CX,20
  JAE   @NotRealCBS
  OR    BYTE PTR Input_Byte[INPUT1],80h
@NotRealCBS:
  JMP   @GetOut
@NotReal:

  SUB   BX,BX
{  MOV   CX,50
  MOV   DX,50}

  { If the keyboard controllers are being used, don't check the joysticks }

  CMP   BYTE PTR Controller,crKeyboard
  JE    @CheckDone2

  { Check joysticks }

  TEST  BYTE PTR Config.UseJoystick1,0FFh
  JNZ   @CheckJoy
{  OR    BYTE PTR AtariSeg[SWCHA1],0FFh}
  JMP   @CheckDone2
@CheckJoy:
  CALL  JoyStatus
  MOV   AL,BL

  { Look at fire buttons }

  TEST  BYTE PTR Latched,1
  JNZ   @Latched
  XOR   AL,0FFh

  MOV   BYTE PTR Input_Byte[INPUT4],0
  TEST  AL,BYTE PTR Config.Player1Fire
  JZ    @Button2NotLatched
  OR    BYTE PTR Input_Byte[INPUT4],80h
@Button2NotLatched:
  CMP   BYTE PTR Controller,crVTP
  JE    @NextTest
  MOV   BYTE PTR Input_Byte[INPUT5],0
  TEST  AL,BYTE PTR Config.Player2Fire
  JZ    @NextTest
  OR    BYTE PTR Input_Byte[INPUT5],80h
(*
  ROR   AL,1
  MOV   AH,AL
  AND   AH,80h
  MOV   BYTE PTR Input_Byte[INPUT4],AH

  CMP   BYTE PTR Controller,crVTP
  JE    @NextTest
  ROR   AL,2
  AND   AL,80h
  MOV   BYTE PTR Input_Byte[INPUT5],AL
*)
  JMP   @NextTest

@Latched:
  TEST  AL,BYTE PTR Config.Player1Fire
  JZ    @Button2
  AND   BYTE PTR Input_Byte[INPUT4],7Fh
@Button2:

  CMP   BYTE PTR Controller,crVTP
  JE    @NextTest
  TEST  AL,BYTE PTR Config.Player2Fire
  JZ    @NextTest
  AND   BYTE PTR Input_Byte[INPUT5],7Fh
@NextTest:

  { Emulate Indy 500 controllers }

  CMP   BYTE PTR Controller,crVTP
  JE    @CheckJoysticks
  CMP   BYTE PTR Controller,crDriving
  JNE   @CheckJoysticks

  { Player 1 }

  CMP   CX,WORD PTR JoyMinX
  JGE   @LeftFalseI500
  DEC   WORD PTR Indy500
  JMP   @CheckDoneI500
@LeftFalseI500:
  CMP   CX,WORD PTR JoyMaxX
  JLE   @CheckDoneI500
  INC   WORD PTR Indy500
@CheckDoneI500:

  { Player 2 }

  CMP   SI,WORD PTR JoyMinX2
  JGE   @LeftFalseI500A
  DEC   WORD PTR Indy500[2]
  JMP   @CheckDoneI500A
@LeftFalseI500A:
  CMP   SI,WORD PTR JoyMaxX2
  JLE   @CheckDoneI500A
  INC   WORD PTR Indy500[2]
@CheckDoneI500A:

  PUSH  SI
  OR    BYTE PTR AtariSeg[SWCHA1],0FFh
  MOV   SI,WORD PTR Indy500
  AND   SI,3
  MOV   AL,BYTE PTR Indy500Trans[SI]
  MOV   SI,WORD PTR Indy500[2]
  AND   SI,3
  MOV   AH,BYTE PTR Indy500Trans[SI]
  ROR   AH,4
  AND   AL,AH
  AND   BYTE PTR AtariSeg[SWCHA1],AL
  POP   SI
  JMP   @CheckDone2

@CheckJoysticks:

  CMP   BYTE PTR Controller,crPaddle
  JE    @CheckDone2

  { Check player 1's joystick }

  MOV   AH,BYTE PTR AtariSeg[SWACNT1]
{
  TEST  AH,10h
  JNZ   @CheckDown
}
  CMP   DX,WORD PTR JoyMinY
  JGE   @UpFalse
  AND   BYTE PTR AtariSeg[SWCHA1],0EFh
  JMP   @CheckDown
@UpFalse:
  OR    BYTE PTR AtariSeg[SWCHA1],10h
@CheckDown:
{
  TEST  AH,20h
  JNZ   @CheckLeft
}
  CMP   DX,WORD PTR JoyMaxY
  JLE   @DownFalse
  AND   BYTE PTR AtariSeg[SWCHA1],0DFh
  JMP   @CheckLeft
@DownFalse:
  OR    BYTE PTR AtariSeg[SWCHA1],20h
@CheckLeft:
{
  TEST  AH,40h
  JNZ   @CheckRight
}
  CMP   CX,WORD PTR JoyMinX
  JGE   @LeftFalse
  AND   BYTE PTR AtariSeg[SWCHA1],0BFh
  JMP   @CheckRight
@LeftFalse:
  OR    BYTE PTR AtariSeg[SWCHA1],40h
@CheckRight:
{
  TEST  AH,80h
  JNZ   @CheckDone
}
  CMP   CX,WORD PTR JoyMaxX
  JLE   @RightFalse
  AND   BYTE PTR AtariSeg[SWCHA1],07Fh
  JMP   @CheckDone
@RightFalse:
  OR    BYTE PTR AtariSeg[SWCHA1],80h
@CheckDone:

  { Check player 2's joystick }

  CMP   BYTE PTR Controller,crVTP
  JE    @CheckDone2
  TEST  BYTE PTR Config.UseJoystick2,0FFh
  JZ    @CheckDone2

  MOV   AH,BYTE PTR AtariSeg[SWACNT1]
  TEST  AH,1
  JNZ   @CheckDown2
  CMP   DI,WORD PTR JoyMinY2
  JGE   @UpFalse2
  AND   BYTE PTR AtariSeg[SWCHA1],0FEh
  JMP   @CheckDown2
@UpFalse2:
  OR    BYTE PTR AtariSeg[SWCHA1],1
@CheckDown2:
  TEST  AH,2
  JNZ   @CheckLeft2
  CMP   DI,WORD PTR JoyMaxY2
  JLE   @DownFalse2
  AND   BYTE PTR AtariSeg[SWCHA1],0FDh
  JMP   @CheckLeft2
@DownFalse2:
  OR    BYTE PTR AtariSeg[SWCHA1],2
@CheckLeft2:
  TEST  AH,4
  JNZ   @CheckRight2
  CMP   SI,WORD PTR JoyMinX2
  JGE   @LeftFalse2
  AND   BYTE PTR AtariSeg[SWCHA1],0FBh
  JMP   @CheckRight2
@LeftFalse2:
  OR    BYTE PTR AtariSeg[SWCHA1],4
@CheckRight2:
  TEST  AH,8
  JNZ   @CheckDone2
  CMP   SI,WORD PTR JoyMaxX2
  JLE   @RightFalse2
  AND   BYTE PTR AtariSeg[SWCHA1],0F7h
  JMP   @CheckDone2
@RightFalse2:
  OR    BYTE PTR AtariSeg[SWCHA1],8
@CheckDone2:

  { Copy info }

  MOV   AL,BYTE PTR AtariSeg[SWCHA1]
  MOV   BYTE PTR AtariSeg[SWCHA2],AL

  MOV   AL,BYTE PTR AtariSeg[SWCHB1]
  AND   AL,7
  OR    AL,BYTE PTR ColorOrBW
  OR    AL,BYTE PTR Difficulty1
  OR    AL,BYTE PTR Difficulty2
  OR    AL,3
  AND   AL,0CFh

  CMP   BYTE PTR Cart,ctCBS
  JE    @BoosterGrip

  { Handle joystick select/reset functions }

  TEST  BL,BYTE PTR Config.JoystickReset
  JZ    @Button3
  AND   AL,0FEh
@Button3:
  TEST  BL,BYTE PTR Config.JoystickSelect
  JZ    @ButtonDone
  AND   AL,0FDh
  JMP   @ButtonDone

  { Handle joystick Booster-Grip buttons }

@BoosterGrip:

  TEST  BYTE PTR Config.UseJoystick1,0FFh
  JZ    @ButtonDone
  MOV   BYTE PTR Key[kLBRACE],0
  MOV   BYTE PTR Key[kRBRACE],0

{  OR    BYTE PTR Input_Byte[INPUT0],80h}
  TEST  BL,BYTE PTR Config.JoystickReset {2}
  JZ    @Button3A
{  OR    BYTE PTR Input_Byte[INPUT0],80h}
{  AND   BYTE PTR Input_Byte[INPUT0],07Fh}
  MOV   BYTE PTR Key[kLBRACE],1
@Button3A:
{  OR    BYTE PTR Input_Byte[INPUT1],80h}
  TEST  BL,BYTE PTR Config.JoystickSelect {8}
  JZ    @ButtonDone
{  OR    BYTE PTR Input_Byte[INPUT1],80h}
{  AND   BYTE PTR Input_Byte[INPUT1],07Fh}
  MOV   BYTE PTR Key[kRBRACE],1
@ButtonDone:

  OR    AL,14h      { Bits 2 and 4 are always 1 }
  MOV   AH,AL       { Bit 5 mirrors bit 6       }
  SHR   AH,1
  AND   AH,20h
  OR    AL,AH


  MOV   BYTE PTR AtariSeg[SWCHB1],AL
  MOV   BYTE PTR AtariSeg[SWCHB2],AL

  { Check function keys And CBS Booster-Grip keys }

  CMP   BYTE PTR Cart,ctCBS
  JNE   @CheckF1

  TEST  BYTE PTR AtariSeg[VBLANK],80h
  JNZ   @CheckF1

{  OR    BYTE PTR Input_Byte[INPUT0],80h}
  AND   BYTE PTR Input_Byte[INPUT0],07Fh
  TEST  BYTE PTR Key[kLBRACE],0FFh
  JZ    @CheckRBrace
  OR    BYTE PTR Input_Byte[INPUT0],80h
{  AND   BYTE PTR Input_Byte[INPUT0],07Fh}
@CheckRBrace:
{  OR    BYTE PTR Input_Byte[INPUT1],80h}
  AND   BYTE PTR Input_Byte[INPUT1],07Fh
  TEST  BYTE PTR Key[kRBRACE],0FFh
  JZ    @CheckF1
  OR    BYTE PTR Input_Byte[INPUT1],80h
{  AND   BYTE PTR Input_Byte[INPUT1],07Fh}
@CheckF1:
  TEST  BYTE PTR Key[kF1],0FFh
  JZ    @CheckF2
{$IFDEF LOWRES}
  PUSH  160
{$ELSE}
  PUSH  320
{$ENDIF}
  PUSH  WORD PTR MaxRows
  PUSH  DS
  PUSH  OFFSET Difficulty1
  PUSH  DS
  PUSH  OFFSET Difficulty2
  PUSH  DS
  PUSH  OFFSET AutoCenter
  CALL  GameStatus
  CALL  ResetClock
@CheckF2:
  TEST  BYTE PTR Key[kF2],0FFh
  JZ    @CheckF4
  AND   BYTE PTR AtariSeg[SWCHB1],0FEh
@CheckF4:
  TEST  BYTE PTR Key[kF4],0FFh
  JZ    @CheckF5
  AND   BYTE PTR AtariSeg[SWCHB1],0FDh
@CheckF5:
  TEST  BYTE PTR Key[kF5],0FFh
  JZ    @PreCheckF6
  TEST  BYTE PTR ColorOrBWChange,0FFh
  JZ    @CheckF6
  XOR   BYTE PTR ColorOrBW,8
  MOV   BYTE PTR ColorOrBWChange,0
  JMP   @CheckF6
@PreCheckF6:
  MOV   BYTE PTR ColorOrBWChange,1
@CheckF6:
  TEST  BYTE PTR Key[kF6],0FFh
  JZ    @PreCheckF7
  TEST  BYTE PTR Difficulty1Change,0FFh
  JZ    @CheckF7
  XOR   BYTE PTR Difficulty1,40h
  MOV   BYTE PTR Difficulty1Change,0
  JMP   @CheckF7
@PreCheckF7:
  MOV   BYTE PTR Difficulty1Change,1
@CheckF7:
  TEST  BYTE PTR Key[kF7],0FFh
  JZ    @PreCheckF10
  TEST  BYTE PTR Difficulty2Change,0FFh
  JZ    @CheckF10
  XOR   BYTE PTR Difficulty2,80h
  MOV   BYTE PTR Difficulty2Change,0
  JMP   @CheckF10
@PreCheckF10:
  MOV   BYTE PTR Difficulty2Change,1
@CheckF10:
  TEST  BYTE PTR Key[kF10],0FFh
  JZ    @PreCheckUp
  TEST  BYTE PTR AutoCenterChange,0FFh
  JZ    @CheckUp
  XOR   BYTE PTR AutoCenter,1
  MOV   BYTE PTR AutoCenterChange,0
  JMP   @CheckUp
@PreCheckUp:
  MOV   BYTE PTR AutoCenterChange,1
@CheckUp:

  { Check keyboard }

  CMP   BYTE PTR Controller,crKeyboard
  JE    @KeyCont
  TEST  BYTE PTR Config.UseJoystick1,0FFh
  JNZ   @CheckP2Fire{@KeyCont}

  { Player 1 fire button }

  TEST  BYTE PTR Latched,1
  JNZ   @Latched1

  MOV   AL,BYTE PTR Key[kSPACE]
  OR    AL,BYTE PTR Key[kEENTER]
  DB    0Fh,94h,0C0h    { SETZ AL }
  ROR   AL,1
  MOV   BYTE PTR Input_Byte[INPUT4],AL
  JMP   @CheckP2Fire
@Latched1:
  MOV   AL,BYTE PTR Key[kSPACE]
  OR    AL,BYTE PTR Key[kEENTER]
  JZ    @CheckP2Fire
{  MOV   BYTE PTR Input_Byte[INPUT4],0}
  AND   BYTE PTR Input_Byte[INPUT4],7Fh
@CheckP2Fire:

  { Player 2 fire button }

  TEST  BYTE PTR Config.UseJoystick2,0FFh
  JNZ   @CheckI500Keys
  CMP   BYTE PTR Controller,crVTP
  JE    @CheckKeys
  TEST  BYTE PTR Latched,1
  JNZ   @Latched1A
  TEST  BYTE PTR Key[kENTER],0FFh
  DB    0Fh,94h,0C0h    { SETZ AL }
  ROR   AL,1
  MOV   BYTE PTR Input_Byte[INPUT5],AL
  JMP   @CheckI500Keys
@Latched1A:
  TEST  BYTE PTR Key[kENTER],0FFh
  JZ    @CheckI500Keys
{  MOV   BYTE PTR Input_Byte[INPUT5],0}
  AND   BYTE PTR Input_Byte[INPUT5],7Fh

@CheckI500Keys:

  { Emulate Indy 500 controllers }

  CMP   BYTE PTR Controller,crDriving
  JNE   @CheckKeys

  { Player 1 }

  TEST  BYTE PTR Config.UseJoystick1,0FFh
  JNZ   @CheckKeys
  MOV   AL,BYTE PTR Key[kLF]
  OR    AL,BYTE PTR Key[kP4]
  JZ    @LeftFalseI500K
  DEC   WORD PTR Indy500
  JMP   @CheckDoneI500K
@LeftFalseI500K:
  MOV   AL,BYTE PTR Key[kRT]
  OR    AL,BYTE PTR Key[kP6]
  JZ    @CheckDoneI500K
  INC   WORD PTR Indy500
@CheckDoneI500K:

  { Player 2 }

  TEST  BYTE PTR Key[kJ],0FFh
  JZ    @LeftFalseI500KA
  DEC   WORD PTR Indy500[2]
  JMP   @CheckDoneI500KA
@LeftFalseI500KA:
  TEST  BYTE PTR Key[kL],0FFh
  JZ    @CheckDoneI500KA
  INC   WORD PTR Indy500[2]
@CheckDoneI500KA:

  PUSH  SI
  OR    BYTE PTR AtariSeg[SWCHA1],0FFh
  MOV   SI,WORD PTR Indy500
  AND   SI,3
  MOV   AL,BYTE PTR Indy500Trans[SI]
  MOV   SI,WORD PTR Indy500[2]
  AND   SI,3
  MOV   AH,BYTE PTR Indy500Trans[SI]
  ROR   AH,4
  AND   AL,AH
  AND   BYTE PTR AtariSeg[SWCHA1],AL
  POP   SI
  JMP   @GetOut

@CheckKeys:

  { Player 1 }

  CMP   BYTE PTR Controller,crPaddle
  JE    @CheckDone1A
  TEST  BYTE PTR Config.UseJoystick1,0FFh
  JNZ   @CheckDone1

  MOV   AH,BYTE PTR AtariSeg[SWACNT1]

{  OR    BYTE PTR AtariSeg[SWCHA1],0F0h}
  TEST  AH,10h
  JNZ   @CheckDown1
  MOV   AL,BYTE PTR Key[kUP]
  OR    AL,BYTE PTR Key[kP8]
  JZ    @Up1Off
  AND   BYTE PTR AtariSeg[SWCHA1],0EFh
  OR    BYTE PTR AtariSeg[SWCHA1],20h
  JMP   @CheckLeft1
@Up1Off:
  OR    BYTE PTR AtariSeg[SWCHA1],10h
@CheckDown1:
  TEST  AH,20h
  JNZ   @CheckLeft1
  MOV   AL,BYTE PTR Key[kDN]
  OR    AL,BYTE PTR Key[kP2]
  JZ    @Down1Off
  AND   BYTE PTR AtariSeg[SWCHA1],0DFh
  OR    BYTE PTR AtariSeg[SWCHA1],10h
  JMP   @CheckLeft1
@Down1Off:
  OR    BYTE PTR AtariSeg[SWCHA1],20h
@CheckLeft1:
  TEST  AH,40h
  JNZ   @CheckRight1
  MOV   AL,BYTE PTR Key[kLF]
  OR    AL,BYTE PTR Key[kP4]
  JZ    @Left1Off
  AND   BYTE PTR AtariSeg[SWCHA1],0BFh
  OR    BYTE PTR AtariSeg[SWCHA1],80h
  JMP   @CheckDone1
@Left1Off:
  OR    BYTE PTR AtariSeg[SWCHA1],40h
@CheckRight1:
  TEST  AH,80h
  JNZ   @CheckDone1
  MOV   AL,BYTE PTR Key[kRT]
  OR    AL,BYTE PTR Key[kP6]
  JZ    @Right1Off
  AND   BYTE PTR AtariSeg[SWCHA1],07Fh
  OR    BYTE PTR AtariSeg[SWCHA1],40h
  JMP   @CheckDone1
@Right1Off:
  OR    BYTE PTR AtariSeg[SWCHA1],80h
@CheckDone1:
  MOV   AL,BYTE PTR AtariSeg[SWCHA1]
  MOV   BYTE PTR AtariSeg[SWCHA2],AL

  { Player 2 }

  TEST  BYTE PTR Config.UseJoystick2,0FFh
  JNZ   @KeyCont
  CMP   BYTE PTR Controller,crVTP
  JE    @KeyCont

  MOV   AH,BYTE PTR AtariSeg[SWACNT1]

{  OR    BYTE PTR AtariSeg[SWCHA1],0Fh}
  TEST  AH,1
  JNZ   @CheckDown1A
  TEST  BYTE PTR Key[kI],0FFh
  JZ    @Up2Off
  AND   BYTE PTR AtariSeg[SWCHA1],0FEh
  OR    BYTE PTR AtariSeg[SWCHA1],2
  JMP   @CheckLeft1A
@Up2Off:
  OR    BYTE PTR AtariSeg[SWCHA1],1
@CheckDown1A:
  TEST  AH,2
  JNZ   @CheckLeft1A
  TEST  BYTE PTR Key[kK],0FFh
  JZ    @Down2Off
  AND   BYTE PTR AtariSeg[SWCHA1],0FDh
  OR    BYTE PTR AtariSeg[SWCHA1],1
  JMP   @CheckLeft1A
@Down2Off:
  OR    BYTE PTR AtariSeg[SWCHA1],2
@CheckLeft1A:
  TEST  AH,4
  JNZ   @CheckRight1A
  TEST  BYTE PTR Key[kJ],0FFh
  JZ    @Left2Off
  AND   BYTE PTR AtariSeg[SWCHA1],0FBh
  OR    BYTE PTR AtariSeg[SWCHA1],8
  JMP   @CheckDone1A
@Left2Off:
  OR    BYTE PTR AtariSeg[SWCHA1],4
@CheckRight1A:
  TEST  AH,8
  JNZ   @CheckDone1A
  TEST  BYTE PTR Key[kL],0FFh
  JZ    @Right2Off
  AND   BYTE PTR AtariSeg[SWCHA1],0F7h
  OR    BYTE PTR AtariSeg[SWCHA1],4
  JMP   @CheckDone1A
@Right2Off:
  OR    BYTE PTR AtariSeg[SWCHA1],8
@CheckDone1A:
  MOV   AL,BYTE PTR AtariSeg[SWCHA1]
  MOV   BYTE PTR AtariSeg[SWCHA2],AL

  { Check keyboard controllers }

@KeyCont:
  CMP   BYTE PTR Controller,crKeyboard
  JE    @CheckKBCont
  CMP   BYTE PTR Controller,crVTP
  JE    @CheckKBCont
  JMP   @GetOut
@CheckKBCont:
  DB    _32BIT_OPERAND
  SUB   AX,AX
  MOV   BL,0FFh

  { Left controller }

  CMP   BYTE PTR Controller,crVTP
  JE    @Check4
  TEST  BYTE PTR Key[kN1],BL
  JZ    @CheckQ
  OR    AX,10h
@CheckQ:
  TEST  BYTE PTR Key[kQ],BL
  JZ    @CheckA
  OR    AX,20h
@CheckA:
  TEST  BYTE PTR Key[kA],BL
  JZ    @CheckZ
  OR    AX,40h
@CheckZ:
  TEST  BYTE PTR Key[kZ],BL
  JZ    @Check2
  OR    AX,80h
@Check2:

  TEST  BYTE PTR Key[kN2],BL
  JZ    @CheckW
  OR    AX,1000h
@CheckW:
  TEST  BYTE PTR Key[kW],BL
  JZ    @CheckS
  OR    AX,2000h
@CheckS:
  TEST  BYTE PTR Key[kS],BL
  JZ    @CheckX
  OR    AX,4000h
@CheckX:
  TEST  BYTE PTR Key[kX],BL
  JZ    @Check3
  OR    AX,8000h
@Check3:

  TEST  BYTE PTR Key[kN3],BL
  JZ    @CheckE
  DB    _32BIT_OPERAND
  OR    AX,0
  DW    10h
@CheckE:
  TEST  BYTE PTR Key[kE],BL
  JZ    @CheckD
  DB    _32BIT_OPERAND
  OR    AX,0
  DW    20h
@CheckD:
  TEST  BYTE PTR Key[kD],BL
  JZ    @CheckC
  DB    _32BIT_OPERAND
  OR    AX,0
  DW    40h
@CheckC:
  TEST  BYTE PTR Key[kC],BL
  JZ    @Check4
  DB    _32BIT_OPERAND
  OR    AX,0
  DW    80h
@Check4:

  { Right controller }

  TEST  BYTE PTR Key[kN4],BL
  JZ    @CheckR
  OR    AX,1
@CheckR:
  TEST  BYTE PTR Key[kR],BL
  JZ    @CheckF
  OR    AX,2
@CheckF:
  TEST  BYTE PTR Key[kF],BL
  JZ    @CheckV
  OR    AX,4
@CheckV:
  TEST  BYTE PTR Key[kV],BL
  JZ    @Check5
  OR    AX,8
@Check5:

  TEST  BYTE PTR Key[kN5],BL
  JZ    @CheckT
  OR    AX,100h
@CheckT:
  TEST  BYTE PTR Key[kT],BL
  JZ    @CheckG
  OR    AX,200h
@CheckG:
  TEST  BYTE PTR Key[kG],BL
  JZ    @CheckB
  OR    AX,400h
@CheckB:
  TEST  BYTE PTR Key[kB],BL
  JZ    @Check6
  OR    AX,800h
@Check6:

  TEST  BYTE PTR Key[kN6],BL
  JZ    @CheckY
  DB    _32BIT_OPERAND
  OR    AX,0
  DW    1
@CheckY:
  TEST  BYTE PTR Key[kY],BL
  JZ    @CheckH
  DB    _32BIT_OPERAND
  OR    AX,0
  DW    2
@CheckH:
  TEST  BYTE PTR Key[kH],BL
  JZ    @CheckN
  DB    _32BIT_OPERAND
  OR    AX,0
  DW    4
@CheckN:
  TEST  BYTE PTR Key[kN],BL
  JZ    @CheckKBDone
  DB    _32BIT_OPERAND
  OR    AX,0
  DW    8

@CheckKBDone:
  DB    _32BIT_OPERAND
  MOV   WORD PTR KeyColumn,AX

  MOV   BYTE PTR KBWrite,0
  CALL  CheckKBController

@GetOut:
End; { Handle_Input }


Procedure GetMouseInfo;
Const PadSize = 800;
Var
  MX,MY,MB : Word;{Integer;}
  Paddle   : Array[0..3] Of LongInt;
  JB       : Byte;
  Mask1    : Byte;
  Mask2    : Byte;
  Mask3    : Byte;

  Procedure Swap(Var L1,L2: LongInt);
  Var L: LongInt;
  Begin
    L  := L1;
    L1 := L2;
    L2 := L;
  End; { Swap }

Begin
  If Config.UseRealControllers Then
  Begin
    Paddle[0] := 0;
    Paddle[1] := 0;
    Paddle[2] := 0;
    Paddle[3] := 0;
    Asm
      CALL  JoyStatus
      MOV   WORD PTR Paddle[0],DX
      MOV   WORD PTR Paddle[4],CX
      MOV   WORD PTR Paddle[8],DI
      MOV   WORD PTR Paddle[12],SI
    End; { Asm }
    Paddle[0] := Round(Paddle[0] * (PadMax / Config.PaddleMax));
    Paddle[1] := Round(Paddle[1] * (PadMax / Config.PaddleMax));
    Paddle[2] := Round(Paddle[2] * (PadMax / Config.PaddleMax));
    Paddle[3] := Round(Paddle[3] * (PadMax / Config.PaddleMax));
    If Paddle[0] > PadMax Then Paddle[0] := PadMax;
    If Paddle[1] > PadMax Then Paddle[1] := PadMax;
    If Paddle[2] > PadMax Then Paddle[2] := PadMax;
    If Paddle[3] > PadMax Then Paddle[3] := PadMax;
{    MX := Round(MX * (640 / 1500));
    MY := Round(MY * (640 / 1500));}
    PaddleGround0 := Round(3.1{2.05} * 6.4 * Paddle[0]);
    PaddleGround1 := Round(3.1{2.05} * 6.4 * Paddle[1]);
    PaddleGround2 := Round(3.1{2.05} * 6.4 * Paddle[2]);
    PaddleGround3 := Round(3.1{2.05} * 6.4 * Paddle[3]);
{    If (MB And 1) <> 0 Then AtariSeg[SWCHA1] := AtariSeg[SWCHA1] And $7F;}
  End
  Else
  Begin
    GetMousePosition(Word(MX),Word(MY),Word(MB));
    PaddleGround0 := Round(3.1{2.05} * 6.4 * (PadSize - MX * (PadSize / 640)));

{    PaddleGround0 := Round(14440 * ((640 - MX) / 640));}

    If Config.UseJoystick1 Then
    Begin
      Paddle[0] := 0;
      Paddle[1] := 0;
      Paddle[2] := 0;
      Paddle[3] := 0;
      Asm
        CALL  JoyStatus
        MOV   WORD PTR Paddle[0],DX
        MOV   WORD PTR Paddle[4],CX
        MOV   WORD PTR Paddle[8],DI
        MOV   WORD PTR Paddle[12],SI
        MOV   BYTE PTR JB,BL
      End; { Asm }
      If Paddle[1] > JoyMaxX Then Paddle[1] := JoyMaxX;
      If Paddle[1] < JoyMinX Then Paddle[1] := JoyMinX;
      PaddleGround1 := Round(3.1 * 6.4 *
       (PadSize - ((Paddle[1] - JoyMinX) * PadSize / (JoyMaxX - JoyMinX))));
    End
    Else PaddleGround1 := PadMax;
    If Config.UseJoystick2 Then
    Begin
      If Paddle[3] > JoyMaxX2 Then Paddle[3] := JoyMaxX2;
      If Paddle[3] < JoyMinX2 Then Paddle[3] := JoyMinX2;
      PaddleGround2 := Round(3.1 * 6.4 *
       (PadSize - ((Paddle[3] - JoyMinX2) * PadSize / (JoyMaxX2 - JoyMinX2))));
    End
    Else PaddleGround2 := PadMax;
    PaddleGround3 := PadMax;
    Case Config.MousePaddle Of
      0: Begin
           Mask1 := $7F;
           Mask2 := $BF;
           Mask3 := $F7;
         End;
      1: Begin
           Swap(PaddleGround0,PaddleGround1);
           Mask1 := $BF;
           Mask2 := $7F;
           Mask3 := $F7;
         End;
      2: Begin
           Swap(PaddleGround0,PaddleGround2);
           Swap(PaddleGround0,PaddleGround1);
           Mask1 := $F7;
           Mask2 := $7F;
           Mask3 := $BF;
         End;
      3: Begin
           Swap(PaddleGround0,PaddleGround3);
           Swap(PaddleGround0,PaddleGround2);
           Swap(PaddleGround0,PaddleGround1);
           Mask1 := $FB;
           Mask2 := $7F;
           Mask3 := $BF;
         End;
    End; { Case }
    AtariSeg[SWCHA1] := AtariSeg[SWCHA1] Or $CC;
    If (MB And 1) <> 0 Then AtariSeg[SWCHA1] := AtariSeg[SWCHA1] And Mask1;
    If (JB And 1) <> 0 Then AtariSeg[SWCHA1] := AtariSeg[SWCHA1] And Mask2;
    If (JB And 4) <> 0 Then AtariSeg[SWCHA1] := AtariSeg[SWCHA1] And Mask3;
  End;
{  For MY := 0 To 199 Do Mem[$A000:MY * 320 + (MX Div 2)] := $F;}
(*
  GetMousePosition(Word(MX),Word(MY),Word(MB));
  PaddleGround := Round(3.1{2.05} * 6.4 * (640 - MX));
  If (MB And 1) <> 0 Then AtariSeg[SWCHA1] := AtariSeg[SWCHA1] And $7F;

{  For MY := 0 To 199 Do Mem[$A000:MY * 320 + (MX Div 2)] := $F;}
*)
End; { GetMouseInfo }


Procedure SlowDown;
Var
  T{,I} : LongInt;
  R     : Double;

Begin
{  R := Time0 + (TimeErr / 1000) + (1000 / Config.FrameRate);}
  R := Time0{ - TimeErr} + (1000{500} / Config.FrameRate);
{  I := Round(R);}
  Repeat
    T := Clock;
  Until (T >= R) Or (T < Time0);
  Time0   := R;{T;}
{  TimeErr := Round(1000 * (T - R)) Mod 1000;}
{  TimeErr := T - R;}
End; { SlowDown }


Procedure Handle_Timer; Assembler;
Asm
  PUSH   AX
  PUSH   CX
  PUSH   DX
  PUSH   DI
  PUSH   BX

  DB     _32BIT_OPERAND           { EAX = # of elapsed clock cycles }
  MOV    AX,WORD PTR TimerElapsed

  DB     _32BIT_OPERAND
  SUB    BX,BX

  DB     _32BIT_OPERAND
  ADD    AX,WORD PTR TimerX

  MOV    BX,68
  ADD    BX,WORD PTR TIA_Count
  MOV    BL,BYTE PTR Div3[BX]
  SUB    BH,BH
  ADD    BX,WORD PTR AddCycle
{  DEC    BX
  DEC    BX}

  DB     _32BIT_OPERAND
  ADD    AX,BX

 { ------------------------ }

  DB     _32BIT_OPERAND
  SUB    BX,BX
  MOV    CL,BYTE PTR TimerShift
  DB     _32BIT_OPERAND
  MOV    DX,AX
  DB     _32BIT_OPERAND
  SHR    DX,CL
  MOV    BL,BYTE PTR OrigTimer
  DB     _32BIT_OPERAND
  SUB    BX,DX
  DB     _32BIT_OPERAND
  DEC    BX
  DB     _32BIT_OPERAND
  OR     BX,BX
  JL     @Depleted
  MOV    BYTE PTR AtariSeg[INTTIM1],BL
  MOV    BYTE PTR AtariSeg[INTTIM2],BL
  MOV    BYTE PTR AtariSeg[INTTIM3],0
  JMP    @GetOut
@Depleted:
{  MOV    BYTE PTR AtariSeg[INTTIM3],0
  CMP    BYTE PTR TimerDone,1
  JE     @NoTimerInterrupt}
  MOV    BYTE PTR AtariSeg[INTTIM3],80h
@NoTimerInterrupt:
{  MOV    BYTE PTR TimerDone,1}
  DB     _32BIT_OPERAND
  SUB    BX,BX
  MOV    BL,BYTE PTR OrigTimer
  MOV    CL,BYTE PTR TimerShift
  DB     _32BIT_OPERAND
  SHL    BX,CL
  DB     _32BIT_OPERAND
  SUB    BX,AX
  DB     _32BIT_OPERAND
  DEC    BX

  { If we're at s/l. MaxScan and the timer has been depleted, then  }
  { the emulator must have not been able to resolve the timer.  Set }
  { the timer to make sure that zero is periodically returned when  }
  { the timer is depleted.                                          }

  MOV    DX,WORD PTR MaxScan
  CMP    WORD PTR TIA_Scan,DX
  JNE    @NoFixTimer
  CMP    BYTE PTR FixTimer,1
  JE     @NoFixTimer
  DEC    BYTE PTR FixTimer
{  MOV    BYTE PTR FixTimer,1}
@NoFixTimer:

  CMP    BYTE PTR FixTimer,1
  JNZ    @NotFixed
  MOV    BL,BYTE PTR FixTimerNum
  SUB    Byte PTR FixTimerNum,7
@NotFixed:

(*
  DB     _32BIT_OPERAND   { Added 8-10-97 }
  DEC    BX
*)

  MOV    BYTE PTR AtariSeg[INTTIM1],BL
  MOV    BYTE PTR AtariSeg[INTTIM2],BL

  DB     _32BIT_OPERAND
  MOV    DX,BX
  DB     _32BIT_OPERAND
  INC    DX
  DB     _32BIT_OPERAND
  INC    DX
  DB     _32BIT_OPERAND
  OR     DX,DX
  JGE    @GetOut
  MOV    BYTE PTR TimerDone,1
(*
  DB     _32BIT_OPERAND           { EBX = # of cycles required to   }
  MOV    BX,WORD PTR TimerSize    {       deplete the timer         }
  DB     _32BIT_OPERAND
  CMP    AX,BX
  JAE    @Depleted
  DB     _32BIT_OPERAND
  SUB    DX,DX
  DB     _32BIT_OPERAND
  MOV    CX,WORD PTR TimerInterval
  DB     _32BIT_OPERAND
  DIV    CX
  MOV    BL,BYTE PTR OrigTimer
  SUB    BL,AL

  MOV    BYTE PTR AtariSeg[INTTIM1],BL
  MOV    BYTE PTR AtariSeg[INTTIM2],BL
  JMP    @GetOut
@Depleted:
  DB     _32BIT_OPERAND
  MOV    CX,BX
  DB     _32BIT_OPERAND
  ADD    CX,WORD PTR TimerInterval
  DB     _32BIT_OPERAND
  CMP    CX,AX
  JBE    @Rollover
  MOV    BYTE PTR AtariSeg[INTTIM1],0  { Force the timer to hold zero for }
  MOV    BYTE PTR AtariSeg[INTTIM2],0  { one cycle                        }
  JMP    @GetOut
@Rollover:
  INC    AX
  SUB    CX,AX
  MOV    BYTE PTR AtariSeg[INTTIM1],CL { The timer changes each cycle }
  MOV    BYTE PTR AtariSeg[INTTIM2],CL
*)
@GetOut:





  POP    BX
  POP    DI
  POP    DX
  POP    CX
  POP    AX
End; { Handle_Timer }


Procedure TurnPlayer0Off(After,Always: Word);
Var Player0Size128Add: Word;
Begin
  Asm
    PUSH  SI
    PUSH  DI
    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    MOV   AL,BYTE PTR OldNUSIZ0
    AND   AL,7
    JZ    @Cont

    TEST  BYTE PTR Always,0FFh
    JNZ   @Cont

    CMP   AL,1
    JE    @Cont


    CMP   AL,6
    JE    @Cont


    JMP   @GetOut
@Cont:
    MOV   AX,WORD PTR OldPlayer0Size128
    MOV   WORD PTR Player0Size128,AX
  { ---------------------------------------- }
    MOV   WORD PTR Player0Size128Add,0
    MOV   DX,WORD PTR TIA_Count

    MOV   BX,WORD PTR AddCycle
    MOV   CX,BX
    ADD   BX,BX
    ADD   BX,CX

{    CMP   WORD PTR ObjectPix[Missile0Set * 2],DX
    JL    @M0AddContinue}
    TEST  WORD PTR After,0FFFFh
    JNZ   @After
    MOV   DI,DX
    ADD   DI,BX
    JMP   @Continue
@After:
    MOV   DI,DX
    SUB   DX,BX
@Continue:
{    CMP   WORD PTR ObjectPix[Missile0Set * 2],DX
    JGE   @M0AddContinue}
  { ---------------------------------------- }


    ADD   DX,5
    SUB   DI,3



  @M0AddLeft:
    MOV   SI,WORD PTR Player0Size128
    MOV   AX,WORD PTR ObjectLoc[Player0Set * 2]
    AND   SI,0700h
    MOV   CX,WORD PTR _Player0Size
    SHR   SI,7

    CMP   AX,DI
    JGE   @M0AddContinue
    ADD   CX,AX
{    CMP   CX,DX}
    CMP   AX,DX
    JL    @Ck2LM0
    MOV   BX,WORD PTR Add1A[SI]
    MOV   WORD PTR Player0Size128Add,BX
    JMP   @M0AddContinue
  @Ck2LM0:
    ADD   AX,WORD PTR Sep1[SI]
    CMP   AX,DI
    JGE   @M0AddContinue
    ADD   CX,WORD PTR Sep1[SI]
{    CMP   CX,DX}
    CMP   AX,DX
    JL    @Ck3LM0
    MOV   BX,WORD PTR Add2A[SI]
    MOV   WORD PTR Player0Size128Add,BX
    JMP   @M0AddContinue
  @Ck3LM0:
    ADD   AX,WORD PTR Sep2[SI]
    CMP   AX,DI
    JGE   @M0AddContinue
    ADD   CX,WORD PTR Sep2[SI]
{    CMP   CX,DX}
    CMP   AX,DX
    JL    @M0AddContinue
    MOV   BX,WORD PTR Add3A[SI]
    MOV   WORD PTR Player0Size128Add,BX
  @M0AddContinue:
    MOV   AX,WORD PTR Player0Size128Add
    ADD   WORD PTR Player0Size128,AX
@GetOut:
    POP   DX
    POP   CX
    POP   BX
    POP   AX
    POP   DI
    POP   SI
  End; { Asm }
End; { TurnPlayer0Off }


Procedure TurnPlayer1Off(After,Always: Word);
Var Player1Size128Add: Word;
Begin
  Asm
    PUSH  SI
    PUSH  DI
    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    MOV   AL,BYTE PTR OldNUSIZ0
    AND   AL,7
    JZ    @Cont

    TEST  BYTE PTR Always,0FFh
    JNZ   @Cont

    CMP   AL,1
    JE    @Cont


    CMP   AL,6
    JE    @Cont


    JMP   @GetOut
@Cont:
    MOV   AX,WORD PTR OldPlayer1Size128
    MOV   WORD PTR Player1Size128,AX
  { ---------------------------------------- }
    MOV   WORD PTR Player1Size128Add,0
    MOV   DX,WORD PTR TIA_Count
    MOV   BX,WORD PTR AddCycle
    MOV   CX,BX
    ADD   BX,BX
    ADD   BX,CX
{    CMP   WORD PTR ObjectPix[Missile0Set * 2],DX
    JL    @M0AddContinue}
    TEST  WORD PTR After,0FFFFh
    JNZ   @After
    MOV   DI,DX
    ADD   DI,BX
    JMP   @Continue
@After:
    MOV   DI,DX
    SUB   DX,BX
@Continue:
{    CMP   WORD PTR ObjectPix[Missile0Set * 2],DX
    JGE   @M0AddContinue}
  { ---------------------------------------- }

    ADD   DX,4
    SUB   DI,3

  @M0AddLeft:
    MOV   SI,WORD PTR Player1Size128
    MOV   AX,WORD PTR ObjectLoc[Player1Set * 2]
    AND   SI,0700h
    MOV   CX,WORD PTR _Player1Size
    SHR   SI,7

    CMP   AX,DI
    JGE   @M0AddContinue
    ADD   CX,AX
    CMP   CX,DX
    JL    @Ck2LM0
    MOV   BX,WORD PTR Add1A[SI]
    MOV   WORD PTR Player1Size128Add,BX
    JMP   @M0AddContinue
  @Ck2LM0:
    ADD   AX,WORD PTR Sep1[SI]
    CMP   AX,DI
    JGE   @M0AddContinue
    ADD   CX,WORD PTR Sep1[SI]
    CMP   CX,DX
    JL    @Ck3LM0
    MOV   BX,WORD PTR Add2A[SI]
    MOV   WORD PTR Player1Size128Add,BX
    JMP   @M0AddContinue
  @Ck3LM0:
    ADD   AX,WORD PTR Sep2[SI]
    CMP   AX,DI
    JGE   @M0AddContinue
    ADD   CX,WORD PTR Sep2[SI]
    CMP   CX,DX
    JL    @M0AddContinue
    MOV   BX,WORD PTR Add3A[SI]
    MOV   WORD PTR Player1Size128Add,BX
  @M0AddContinue:
    MOV   AX,WORD PTR Player1Size128Add
    ADD   WORD PTR Player1Size128,AX
@GetOut:
    POP   DX
    POP   CX
    POP   BX
    POP   AX
    POP   DI
    POP   SI
  End; { Asm }
End; { TurnPlayer1Off }


Procedure Handle_IO; Assembler;
{ ---------------------------------------------------------------------- }
{ On entry:                                                              }
{ BX = Save_BX                                                           }
{ ---------------------------------------------------------------------- }
Label LVSYNC,LVBLANK,LWSYNC,LRSYNC,LAUDV0,LAUDC0,LAUDF0,LNUSIZ0,LNUSIZ1,
      LAUDV1,LAUDC1,LAUDF1,LHMM0,LHMP0,LHMP1,
      LRESP0,LRESP1,LRESM0,LRESM1,LRESBL,LGRP0,LGRP1,LENABL,LCTRLPF,
      LHMCLR,LSWCHA1,LSWACNT1,LSWCHB1,LSWBCNT1,
      LINTTIM1,LINTTIM3,LTIM1T1,LTIM2T1,LTIM3T1,LTIM4T1,LSWCHA2,LSWACNT2,LSWCHB2,
      LSWBCNT2,LINTTIM2,LTIM1T2,LTIM2T2,LTIM3T2,LTIM4T2,GetOut;
Asm
    PUSH   AX
    PUSH   CX
    PUSH   DX
    PUSH   DI

  TEST  BYTE PTR Handle_IO_Set,0FFh
  JNZ   @L2
  MOV   AX,OFFSET GetOut
  MOV   CX,TIM4T2
  SUB   BX,BX
@L1:
  MOV   WORD PTR Handle_IO_Loc[BX],AX
  ADD   BX,2
  LOOP  @L1

  MOV   WORD PTR Handle_IO_Loc[GRP0    * 2],OFFSET LGRP0
  MOV   WORD PTR Handle_IO_Loc[GRP1    * 2],OFFSET LGRP1
  MOV   WORD PTR Handle_IO_Loc[ENABL   * 2],OFFSET LENABL

  MOV   WORD PTR Handle_IO_Loc[AUDV0   * 2],OFFSET LAUDV0
  MOV   WORD PTR Handle_IO_Loc[AUDC0   * 2],OFFSET LAUDC0
  MOV   WORD PTR Handle_IO_Loc[AUDF0   * 2],OFFSET LAUDF0
  MOV   WORD PTR Handle_IO_Loc[AUDV1   * 2],OFFSET LAUDV1
  MOV   WORD PTR Handle_IO_Loc[AUDC1   * 2],OFFSET LAUDC1
  MOV   WORD PTR Handle_IO_Loc[AUDF1   * 2],OFFSET LAUDF1

  MOV   WORD PTR Handle_IO_Loc[CTRLPF  * 2],OFFSET LCTRLPF

  MOV   WORD PTR Handle_IO_Loc[HMP0    * 2],OFFSET LHMP0
  MOV   WORD PTR Handle_IO_Loc[HMP1    * 2],OFFSET LHMP1
  MOV   WORD PTR Handle_IO_Loc[HMM0    * 2],OFFSET LHMM0

  MOV   WORD PTR Handle_IO_Loc[NUSIZ0  * 2],OFFSET LNUSIZ0
  MOV   WORD PTR Handle_IO_Loc[NUSIZ1  * 2],OFFSET LNUSIZ1

  MOV   WORD PTR Handle_IO_Loc[VSYNC   * 2],OFFSET LVSYNC
  MOV   WORD PTR Handle_IO_Loc[VBLANK  * 2],OFFSET LVBLANK
  MOV   WORD PTR Handle_IO_Loc[WSYNC   * 2],OFFSET LWSYNC
  MOV   WORD PTR Handle_IO_Loc[RSYNC   * 2],OFFSET LRSYNC
  MOV   WORD PTR Handle_IO_Loc[RESP0   * 2],OFFSET LRESP0
  MOV   WORD PTR Handle_IO_Loc[RESP1   * 2],OFFSET LRESP1
  MOV   WORD PTR Handle_IO_Loc[RESM0   * 2],OFFSET LRESM0
  MOV   WORD PTR Handle_IO_Loc[RESM1   * 2],OFFSET LRESM1
  MOV   WORD PTR Handle_IO_Loc[RESBL   * 2],OFFSET LRESBL
  MOV   WORD PTR Handle_IO_Loc[HMCLR   * 2],OFFSET LHMCLR
  MOV   WORD PTR Handle_IO_Loc[SWCHA1  * 2],OFFSET LSWCHA1
  MOV   WORD PTR Handle_IO_Loc[SWACNT1 * 2],OFFSET LSWACNT1
  MOV   WORD PTR Handle_IO_Loc[SWCHB1  * 2],OFFSET LSWCHB1
  MOV   WORD PTR Handle_IO_Loc[SWBCNT1 * 2],OFFSET LSWBCNT1
  MOV   WORD PTR Handle_IO_Loc[INTTIM1 * 2],OFFSET LINTTIM1
  MOV   WORD PTR Handle_IO_Loc[INTTIM3 * 2],OFFSET LINTTIM3
  MOV   WORD PTR Handle_IO_Loc[TIM1T1  * 2],OFFSET LTIM1T1
  MOV   WORD PTR Handle_IO_Loc[TIM2T1  * 2],OFFSET LTIM2T1
  MOV   WORD PTR Handle_IO_Loc[TIM3T1  * 2],OFFSET LTIM3T1
  MOV   WORD PTR Handle_IO_Loc[TIM4T1  * 2],OFFSET LTIM4T1
  MOV   WORD PTR Handle_IO_Loc[SWCHA2  * 2],OFFSET LSWCHA2
  MOV   WORD PTR Handle_IO_Loc[SWACNT2 * 2],OFFSET LSWACNT2
  MOV   WORD PTR Handle_IO_Loc[SWCHB2  * 2],OFFSET LSWCHB2
  MOV   WORD PTR Handle_IO_Loc[SWBCNT2 * 2],OFFSET LSWBCNT2
  MOV   WORD PTR Handle_IO_Loc[INTTIM2 * 2],OFFSET LINTTIM2
  MOV   WORD PTR Handle_IO_Loc[TIM1T2  * 2],OFFSET LTIM1T2
  MOV   WORD PTR Handle_IO_Loc[TIM2T2  * 2],OFFSET LTIM2T2
  MOV   WORD PTR Handle_IO_Loc[TIM3T2  * 2],OFFSET LTIM3T2
  MOV   WORD PTR Handle_IO_Loc[TIM4T2  * 2],OFFSET LTIM4T2
  MOV   BYTE PTR Handle_IO_Set,1
  MOV   BX,WORD PTR Save_BX
@L2:
  CMP   BX,TIM4T2
  JA    GetOut
  CMP   BX,2Ch
  JA    @NotTIA
  MOV   BYTE PTR Write_TIA,1
@NotTIA:
  ADD   BX,BX
  JMP   WORD PTR Handle_IO_Loc[BX]

LHMP0:
  TEST  BYTE PTR DoHMOVE,0FFh
  JZ    @HMP01
  MOV   BX,WORD PTR TIA_Count
  MOV   CX,WORD PTR AddCycle
  ADD   BX,CX
  ADD   BX,CX
  ADD   BX,CX
  CMP   BX,8
  JGE   @HMP01
  MOV   AL,BYTE PTR AtariSeg[HMP0]
  SHL   AX,8
  SAR   AX,12
{
  CMP   BX,-59+64
  JL    @LHMP02
  SUB   AX,AX
  JMP   @LHMP03
@LHMP02:
  MOV   CX,64
  ADD   BX,59
  SUB   CX,BX
  IMUL  CX
  MOV   BX,63
  IDIV  BX
  OR    AX,AX
  JNS   @LHMP04
  SUB   DX,8000h
  SBB   AX,0
  JMP   @LHMP03
@LHMP04:
  ADC   DX,8000h
  ADC   AX,0
@LHMP03:
}
{  CMP   BX,-59+64
  JL    @MoveP0
  JMP   GetOut
@MoveP0:}
{  MOV   CX,67
  ADD   BX,59
  SUB   CX,BX
  IMUL  CX
  MOV   BX,67
  IDIV  BX
}

  ADD   BX,59
  SHL   BX,4
  AND   AX,0Fh
  ADD   BX,AX
  ADD   BX,BX
  MOV   AX,WORD PTR SetAdjust[BX]
{
  MOV   CL,BYTE PTR AtariSeg[NUSIZ0]
  AND   CL,7
  CMP   CL,5
  JNE   @Check7A
  CMP   AX,2
  JNE   @Move0
  DEC   AX
  JMP   @Move0
@Check7A:
  CMP   CL,7
  JNE   @Move0
  CMP   AX,1
  JNE   @Move0
  SUB   AX,2
@Move0:
}

  SUB   WORD PTR ObjectLoc[Player0Set * 2],AX
  CMP   WORD PTR ObjectLoc[Player0Set * 2],0{-68}
  JGE   @HMP01
  ADD   WORD PTR ObjectLoc[Player0Set * 2],160{228}
@HMP01:
  JMP   GetOut

LHMP1:
  TEST  BYTE PTR DoHMOVE,0FFh
  JZ    @HMP11
  MOV   BX,WORD PTR TIA_Count
  MOV   CX,WORD PTR AddCycle
  ADD   BX,CX
  ADD   BX,CX
  ADD   BX,CX
  CMP   BX,8
  JGE   @HMP11
  MOV   AL,BYTE PTR AtariSeg[HMP1]
  SHL   AX,8
  SAR   AX,12
{
  CMP   BX,-59+64
  JL    @LHMP12
  SUB   AX,AX
  JMP   @LHMP13
@LHMP12:
  MOV   CX,64
  ADD   BX,59
  SUB   CX,BX
  IMUL  CX
  MOV   BX,63
  IDIV  BX
  OR    AX,AX
  JNS   @LHMP14
  SUB   DX,8000h
  SBB   AX,0
  JMP   @LHMP13
@LHMP14:
  ADC   DX,8000h
  ADC   AX,0
@LHMP13:
}
{  CMP   BX,-59+64
  JL    @MoveP1
  JMP   GetOut
@MoveP1:}
{
  MOV   CX,67
  ADD   BX,59
  SUB   CX,BX
  IMUL  CX
  MOV   BX,67
  IDIV  BX
}

  ADD   BX,59
  SHL   BX,4
  AND   AX,0Fh
  ADD   BX,AX
  ADD   BX,BX
  MOV   AX,WORD PTR SetAdjust[BX]
{
  MOV   CL,BYTE PTR AtariSeg[NUSIZ0]
  AND   CL,7
  CMP   CL,5
  JNE   @Check7B
  CMP   AX,2
  JNE   @Move1
  DEC   AX
  JMP   @Move1
@Check7B:
  CMP   CL,7
  JNE   @Move1
  CMP   AX,1
  JNE   @Move1
  SUB   AX,2
@Move1:
}
  SUB   WORD PTR ObjectLoc[Player1Set * 2],AX
  CMP   WORD PTR ObjectLoc[Player1Set * 2],0{-68}
  JGE   @HMP11
  ADD   WORD PTR ObjectLoc[Player1Set * 2],160{228}
@HMP11:
  JMP   GetOut

LHMM0:

  MOV   AX,WORD PTR HMOVECount
  ADD   AX,63 - 9
  CMP   AX,WORD PTR TIA_Count
  JNE   @HMM01
  MOV   AL,BYTE PTR TIA_Regs[HMM0]
  AND   AL,0F0h
  CMP   AL,70h
  JNE   @HMM01
  MOV   AL,BYTE PTR AtariSeg[HMM0]
  AND   AL,0F0h
  CMP   AL,60h
  JNE   @HMM01
  MOV   BYTE PTR M0Bug,1
  MOV   BYTE PTR M0BugCount,0
@HMM01:
  JMP   GetOut

LNUSIZ0:

  MOV   AL,BYTE PTR TIA_Regs[NUSIZ0]
  MOV   BYTE PTR OldNUSIZ0,AL
{
  PUSH  0
  PUSH  0
  CALL  TurnPlayer0Off
}
  JMP   GetOut

LNUSIZ1:

  MOV   AL,BYTE PTR TIA_Regs[NUSIZ1]
  MOV   BYTE PTR OldNUSIZ1,AL
{
  PUSH  0
  PUSH  0
  CALL  TurnPlayer1Off
}
  JMP   GetOut

LAUDC0:

  PUSH  AX
  PUSH  DX
  PUSH  CX
  PUSH  DI
  MOV   AL,BYTE PTR AtariSeg[AUDC0]
  AND   AX,0Fh
  PUSH  0
  PUSH  AX
  CALL  SetVoice
  POP   DI
  POP   CX
  POP   DX
  POP   AX
  JMP   GetOut

LAUDV0:

  PUSH  AX
  PUSH  DX
  PUSH  CX
  PUSH  DI
  MOV   AL,BYTE PTR AtariSeg[AUDV0]
  AND   AX,0Fh
  PUSH  0
  PUSH  AX
  CALL  SetVolume
  POP   DI
  POP   CX
  POP   DX
  POP   AX
  JMP   GetOut

LAUDF0:

  PUSH  AX
  PUSH  DX
  PUSH  CX
  PUSH  DI
  MOV   AL,BYTE PTR AtariSeg[AUDF0]
  AND   AX,1Fh
  PUSH  0
  PUSH  AX
  CALL  SetFrequency
  POP   DI
  POP   CX
  POP   DX
  POP   AX
  JMP   GetOut

LAUDC1:

  PUSH  AX
  PUSH  DX
  PUSH  CX
  PUSH  DI
  MOV   AL,BYTE PTR AtariSeg[AUDC1]
  AND   AX,0Fh
  PUSH  1
  PUSH  AX
  CALL  SetVoice
  POP   DI
  POP   CX
  POP   DX
  POP   AX
  JMP   GetOut

LAUDV1:

  PUSH  AX
  PUSH  DX
  PUSH  CX
  PUSH  DI
  MOV   AL,BYTE PTR AtariSeg[AUDV1]
  AND   AX,0Fh
  PUSH  1
  PUSH  AX
  CALL  SetVolume
  POP   DI
  POP   CX
  POP   DX
  POP   AX
  JMP   GetOut

LAUDF1:

  PUSH  AX
  PUSH  DX
  PUSH  CX
  PUSH  DI
  MOV   AL,BYTE PTR AtariSeg[AUDF1]
  AND   AX,1Fh
  PUSH  1
  PUSH  AX
  CALL  SetFrequency
  POP   DI
  POP   CX
  POP   DX
  POP   AX
  JMP   GetOut

LCTRLPF:
  MOV   AL,BYTE PTR AtariSeg[CTRLPF]
  MOV   AH,BYTE PTR TIA_Regs[CTRLPF]
  MOV   BYTE PTR CTRLPFLatch,AL
  MOV   BYTE PTR AtariSeg[CTRLPF],AH
  MOV   AX,WORD PTR TIA_Scan
  MOV   WORD PTR CTRLPFScan,AX
  MOV   AX,WORD PTR TIA_Count
  MOV   WORD PTR CTRLPFCount,AX
  JMP   GetOut

LVSYNC:

{
  MOV   BX,DI
  SUB   BX,OFFSET AtariSeg
  ADD   BX,WORD PTR Bytes[SI]
  MOV   WORD PTR OldStart,BX
  MOV   AL,BYTE PTR AtariSeg[BX]
  MOV   BYTE PTR OldByte,AL
  MOV   BYTE PTR AtariSeg[BX],0FFh
}
(*
  MOV   AL,BYTE PTR AtariSeg[VSYNC]  { This works for Bowling and Codebreaker, but turns off CubiColor }
  TEST  AL,07Fh
  JNZ   @NotGoingOff
*)
{
  CMP   WORD PTR TIA_Scan,190
  JGE   @Cont}
{  MOV   AL,BYTE PTR AtariSeg[VSYNC]}  { This turns off Bowling and Codebreaker }
{  TEST  AL,2}{07Eh}
{  JNZ   @NotGoingOff}{JZ @NotGoingOff}
{  CMP   WORD PTR TIA_Scan,0
  JE    @Cont}
{  CMP   WORD PTR TIA_Scan,200
  JB    @NotGoingOff}

{  TEST  BYTE PTR AtariSeg[VBLANK],2
  JNZ   @Cont
  CMP   WORD PTR TIA_Scan,20
  JB    @Cont}

  MOV   BYTE PTR VBLANKOff,0


{  TEST  BYTE PTR AtariSeg[VBLANK],2
  JNZ   @NotGoingOff}
  MOV   AX,WORD PTR MaxRows
  CMP   WORD PTR TIA_Scan,AX
  JG    @NotGoingOff
  MOV   AL,BYTE PTR AtariSeg[VSYNC]
  TEST  AL,2
  JNZ   @NotGoingOff
  TEST  BYTE PTR TIA_Regs[VSYNC],2
  JZ    GetOut
{
  TEST  BYTE PTR TIA_Regs[VSYNC],2
  JZ    @NotGoingOff
}


{  MOV   BYTE PTR VBLANKOff,0}

{
  MOV   BX,WORD PTR TIA_Scan
  CMP   BX,50
  JGE   @NoAdd
  CMP   BX,27
  JG    @Add2
  CMP   BX,-40
  JL    @Add1
  JMP   @NoAdd
@Add2:
  MOV   WORD PTR VAddAdjust,1
  JMP   @Add3
@Add1:
  MOV   WORD PTR VAddAdjust,-1
@Add3:
  MOV   AX,WORD PTR VAddAdjust
  CMP   WORD PTR VAdd,60
  JGE   @NoAdd
  CMP   WORD PTR VAdd,-60
  JLE   @NoAdd
  ADD   WORD PTR VAdd,AX
@NoAdd:
}
  JMP   GetOut
@NotGoingOff:
{  TEST  BYTE PTR AtariSeg[VBLANK],2
  JNZ   @Cont
  MOV   CX,WORD PTR TIA_Scan
  CMP   CX,0
  JL    @Cont
  CMP   CX,WORD PTR MaxRows
  JGE   @Cont
  JMP   GetOut
@Cont:}




{  MOV   AL,BYTE PTR AtariSeg[VSYNC]
  MOV   BYTE PTR TIA_Regs[VSYNC],AL}
  CALL  Handle_TIA
  MOV   BYTE PTR Write_TIA,0
  MOV   AX,WORD PTR TIA_Scan

  CMP   WORD PTR LastVBLANK,100
  JGE   @NoSetVBLANK
  MOV   WORD PTR LastVBLANK,AX
@NoSetVBLANK:
(*
  { Display to the end of the screen }

  TEST  BYTE PTR AtariSeg[VBLANK],2
  JNZ   @BlankRest

  MOV   WORD PTR TIA_Count,160
  CALL  Handle_TIA
@DispLoop:
  INC   WORD PTR TIA_Scan
  MOV   AX,WORD PTR TIA_Scan
  CMP   AX,WORD PTR MaxRows
  JGE   @ResetVSYNC
  CMP   WORD PTR TIA_Scan,0
  JGE   @NotMove
  MOV   WORD PTR TIA_Scan,0
@NotMove:

  MOV   BX,WORD PTR TIA_Scan
  MOV   AX,BX
  SHL   AX,6
  ADD   AH,BL
{$IFDEF LOWRES}
  SHR   AX,1
{$ENDIF}
  MOV   WORD PTR Addr,AX
  MOV   WORD PTR LineStart,AX
  MOV   BYTE PTR DoHMOVE,0


  MOV   WORD PTR Old_TIA_Count,-68
  MOV   WORD PTR TIA_Count,160
  CALL  Handle_TIA
  JMP   @DispLoop
@BlankRest:

  MOV   BX,WORD PTR MaxRows
  MOV   AX,BX
  SHL   AX,6
  ADD   AH,BL
{$IFDEF LOWRES}
  SHR   AX,1
{$ENDIF}

  CMP   AX,WORD PTR Addr
  JBE   @ResetVSYNC
  SUB   AX,WORD PTR Addr
  INC   AX
  MOV   CX,AX
  SUB   AX,AX
  CLD
  PUSH  DI
  MOV   BX,0A000h
  MOV   ES,BX
  MOV   DI,WORD PTR Addr
  REP   STOSB
  POP   DI
@ResetVSYNC:
*)

  { Handle slowdown if necessary }

  TEST  BYTE PTR AtariSeg[VSYNC],2
  JZ    @DoSlow
  TEST  BYTE PTR TIA_Regs[VSYNC],2
  JNZ   @NoSlowDown
@DoSlow:
  CMP   WORD PTR Config.FrameRate,0
  JZ    @NoSlowDown
  CALL  SlowDown
@NoSlowDown:

  MOV   AL,BYTE PTR AtariSeg[VSYNC]
  MOV   BYTE PTR TIA_Regs[VSYNC],AL

  MOV   WORD PTR TIA_Scan,-40
  CMP   BYTE PTR Config.MaxRows,215
  JB    @NotPAL
  CMP   BYTE PTR Palette,1
  JNE   @NotPAL
  MOV   WORD PTR TIA_Scan,-68
@NotPAL:
  MOV   AX,WORD PTR VAdd
  ADD   WORD PTR TIA_Scan,AX
  MOV   AX,WORD PTR VUserAdd
  ADD   WORD PTR TIA_Scan,AX
  MOV   WORD PTR LineStart,0
  MOV   WORD PTR Addr,0

  JMP   GetOut



(*
  TEST  BYTE PTR AtariSeg[VBLANK],2
  JNZ   @Cont
  CMP   WORD PTR TIA_Scan,222
  JAE   @Cont
  MOV   AL,BYTE PTR AtariSeg[VSYNC]
  TEST  AL,2
  JZ   @NotGoingOff
  CMP   WORD PTR TIA_Scan,0
  JL    @Cont1
  MOV   CX,WORD PTR MaxRows
  CMP   WORD PTR TIA_Scan,CX{200}
  JGE   @Cont1
  JMP   @NotGoingOff
@Cont1:
  TEST  BYTE PTR AtariSeg[VBLANK],2
  JZ    @NotGoingOff


{  TEST  BYTE PTR AtariSeg[VBLANK],2
  JZ    @Cont
  CMP   WORD PTR TIA_Scan,215
  JAE   @Cont}
  TEST  BYTE PTR TIA_Regs[VSYNC],2
  JNZ   @NotGoingOff
{  TEST  BYTE PTR AtariSeg[VBLANK],2
  JZ    @NotGoingOff}
{  CMP   WORD PTR TIA_Scan,200
  JB    @NotGoingOff}
{  CMP   WORD PTR TIA_Scan,215
  JB    @NotGoingOff}


{  TEST  BYTE PTR TIA_Regs[VSYNC],2
  JZ    @NotGoingOff}



{  TEST  BYTE PTR TIA_Regs[VSYNC],2
  JZ    @NotGoingOff}

@Cont:

{  CMP   WORD PTR TIA_Scan,190
  JB    @NotGoingOff}
{  TEST  BYTE PTR AtariSeg[VBLANK],2
  JZ    @NotGoingOff}

  MOV   BX,WORD PTR TIA_Scan
  CMP   BX,100
  JL    @NoAdd
  CMP   BX,222
  JL    @Add2
  CMP   BX,230
  JG    @Add1
  JMP   @NoAdd
@Add2:
{  CMP   WORD PTR VAddAdjust,-1
  JE    @NoAdd}
  MOV   WORD PTR VAddAdjust,1
  JMP   @Add3
@Add1:
{  CMP   WORD PTR VAddAdjust,1
  JE    @NoAdd}
  MOV   WORD PTR VAddAdjust,-1
@Add3:
  MOV   AX,WORD PTR VAddAdjust
  CMP   WORD PTR VAdd,60
  JGE   @NoAdd
  CMP   WORD PTR VAdd,-60
  JLE   @NoAdd
  ADD   WORD PTR VAdd,AX
@NoAdd:

  MOV   AL,BYTE PTR AtariSeg[VSYNC]
  MOV   BYTE PTR TIA_Regs[VSYNC],AL
  CALL  Handle_TIA
  MOV   BYTE PTR Write_TIA,0


  MOV   WORD PTR TIA_Scan,-37

  MOV   AX,WORD PTR VAdd
  ADD   WORD PTR TIA_Scan,AX

  MOV   WORD PTR LineStart,0
  MOV   WORD PTR Addr,0

  { Handle slowdown if necessary }

  CMP   WORD PTR Config.FrameRate,0
  JZ    @NoSlowDown
  CALL  SlowDown
@NoSlowDown:
  JMP   GetOut
@NotGoingOff:
  MOV   BYTE PTR TIA_Regs[VSYNC],AL
{  TEST  AL,2
  JZ    @LVSYNC1
  CALL  Handle_TIA
  MOV   BYTE PTR Write_TIA,0
@LVSYNC1:}
  JMP   GetOut
*)
LENABL:

  MOV   AL,BYTE PTR AtariSeg[ENABL]
  MOV   BL,BYTE PTR TIA_Regs[ENABL]
  MOV   BYTE PTR AtariSeg[ENABL],BL
  MOV   BYTE PTR BallLatch,AL
(*
  MOV   BL,BYTE PTR BallLatch
  MOV   BYTE PTR AtariSeg[ENABL],BL
  MOV   BYTE PTR BallLatch,AL
  TEST  BYTE PTR AtariSeg[VDELBL],1
  JNZ   @DelayedBL
@NotDelayedBL:
  MOV   BYTE PTR AtariSeg[ENABL],AL
@DelayedBL:
  MOV   AL,BYTE PTR AtariSeg[ENABL]
*)
  JMP   GetOut

LGRP0:
  MOV   AL,BYTE PTR AtariSeg[GRP0]
  MOV   BL,BYTE PTR TIA_Regs[GRP0]
  MOV   BYTE PTR AtariSeg[GRP0],BL
  MOV   BYTE PTR GRP0Latch,AL
  JMP   GetOut

LGRP1:
  MOV   AL,BYTE PTR AtariSeg[GRP1]
  MOV   BL,BYTE PTR TIA_Regs[GRP1]
  MOV   BYTE PTR AtariSeg[GRP1],BL
  MOV   BYTE PTR GRP1Latch,AL
  JMP   GetOut

LVBLANK:

  TEST  BYTE PTR AtariSeg[VBLANK],2
  JZ    @NotLast
  TEST  BYTE PTR TIA_Regs[VBLANK],2
  JNZ   @NotLast

  MOV   BX,WORD PTR TIA_Scan
  CMP   BX,100
  JL    @NotLast
{  CMP   WORD PTR LastVBLANK,100
  JGE   @SAveLast
  TEST  BYTE PTR AtariSeg[VSYNC],2
  JZ    @SaveLast
@SaveLast:
}
  MOV   WORD PTR LastVBLANK,BX
@NotLast:




  MOV   AH,BYTE PTR AtariSeg[VBLANK]
  TEST  AH,80h
  JZ    @NoGround1

  CMP   BYTE PTR Cart,ctCBS
  JE    @NoGround1

  MOV   WORD PTR Input_Byte[INPUT0],0
  MOV   WORD PTR Input_Byte[INPUT2],0
@NoGround1:
  TEST  BYTE PTR TIA_Regs[VBLANK],80h
  JZ    @NoGround
  DB    _32BIT_OPERAND
  SUB   BX,BX

  DB    _32BIT_OPERAND
  MOV   WORD PTR PaddleGround0,BX
  DB    _32BIT_OPERAND
  MOV   WORD PTR PaddleGround1,BX
  DB    _32BIT_OPERAND
  MOV   WORD PTR PaddleGround2,BX
  DB    _32BIT_OPERAND
  MOV   WORD PTR PaddleGround3,BX
  CMP   BYTE PTR Cart,ctCBS
  JE    @NoGround2
  MOV   WORD PTR Input_Byte[INPUT0],0
  MOV   WORD PTR Input_Byte[INPUT2],0
@NoGround2:
{
  PUSH  DS
  MOV   DS,WORD PTR Global_Save_DS[_Base]
}

  CMP   BYTE PTR Controller,crPaddle
  JNE   @NoGround
  PUSH  AX
  CALL  GetMouseInfo
  POP   AX
{
  DB    _32BIT_OPERAND
  MOV   BX,WORD PTR PaddleGround0
  DB    _32BIT_OPERAND
  MOV   CX,WORD PTR PaddleGround1
  DB    _32BIT_OPERAND
  MOV   DX,WORD PTR PaddleGround2
  DB    _32BIT_OPERAND
  MOV   DI,WORD PTR PaddleGround3
  DB    _32BIT_OPERAND
  MOV   WORD PTR PaddleGround0[_Base],BX
  DB    _32BIT_OPERAND
  MOV   WORD PTR PaddleGround1[_Base],CX
  DB    _32BIT_OPERAND
  MOV   WORD PTR PaddleGround2[_Base],DX
  DB    _32BIT_OPERAND
  MOV   WORD PTR PaddleGround3[_Base],DI
}
{
  DB    _32BIT_OPERAND
  MOV   WORD PTR PaddleGround,BX
  MOV   WORD PTR Input_Byte[INPUT0],0
  MOV   WORD PTR Input_Byte[INPUT2],0
  CALL  GetMouseInfo
}
{
  DB    _32BIT_OPERAND
  MOV   BX,WORD PTR PaddleGround
  DB    _32BIT_OPERAND
  MOV   WORD PTR PaddleGround,BX
}
@NoGround:
  AND   AH,40h
  ROL   AH,2
  MOV   BYTE PTR Latched,AH
  TEST  AH,1
  JZ    @NotLatched
@NotLatched:


  TEST  BYTE PTR AtariSeg[VBLANK],2
  JNZ   @NotOff
  TEST  BYTE PTR TIA_Regs[VBLANK],2
  JZ    @NotOff
{  CMP   WORD PTR TIA_Scan,-11
  JL    @Resync
  CMP   WORD PTR TIA_Scan,11
  JG    @NotOff
  SUB   CX,CX
  JMP   @RS2}

  CMP   WORD PTR TIA_Scan,-11
  JGE   @NotOff
{  CMP   WORD PTR TIA_Scan,-45
  JL    @NotOff}


(*  TEST  BYTE PTR AtariSeg[VBLANK],2
  JNZ   @NotOff
  TEST  BYTE PTR TIA_Regs[VBLANK],2
  JZ    @NotOff
{  CMP   WORD PTR TIA_Scan,100
  JGE   @Resync}

  CMP   WORD PTR TIA_Scan,223
  JE    @Below
  CMP   WORD PTR TIA_Scan,200
  JGE   @Resync

@Below:
  CMP   WORD PTR TIA_Scan,-25
  JL    @NotOff
  CMP   WORD PTR TIA_Scan,25
  JG    @NotOff*)
@Resync:
{  MOV   CX,WORD PTR TIA_Scan}
{  MOV   CX,WORD PTR VAdd
  CMP   CX,0
  JL    @RS1
  ADD   CX,8
  AND   CX,0FFF0h
  JMP   @RS2
@RS1:
  NEG   CX
  ADD   CX,8
  AND   CX,0FFF0h
  NEG   CX
@RS2:}
{
  MOV   CX,WORD PTR TIA_Scan
  ADD   CX,WORD PTR VAdd
}

{
  SUB   CX,CX
  CMP   WORD PTR TIA_Scan,-11
  JGE   @RS1
  MOV   CX,WORD PTR TIA_Scan
  NEG   CX
  SHR   CX,3
  MOV   BX,WORD PTR TIA_Scan
  NEG   BX
  AND   BX,0FFF0h
  NEG   BX
  ADD   CX,BX
@RS1:}
  MOV   BYTE PTR TopVBLANK,0
(*  MOV   AX,WORD PTR TIA_Scan
  MOV   BH,AL
  SUB   BL,BL
  SHL   AX,6
  ADD   AX,BX
  MOV   BX,WORD PTR Addr
  SUB   BX,AX
  MOV   WORD PTR TIA_Scan,CX{0}
  MOV   WORD PTR Addr,BX*)
@NotOff:


  { Auto-cetnering routine }

  TEST  BYTE PTR AtariSeg[VBLANK],2
  JNZ   @NoAdd
  TEST  BYTE PTR TIA_Regs[VBLANK],2
  JZ    @NoAdd
  TEST  BYTE PTR VBLANKOff,0FFh
  JNZ   @NoAdd
  MOV   BYTE PTR VBLANKOff,1

  MOV   CX,WORD PTR MaxRows
  SHR   CX,1
  MOV   DX,CX
  MOV   BX,WORD PTR LastVBLANK
  SUB   BX,WORD PTR TIA_Scan
  MOV   AX,WORD PTR MaxRows
  CMP   BX,AX
  JLE   @NoWiden
  ADD   AX,10
  CMP   BX,AX
  JGE   @Average
  MOV   CX,0
  MOV   DX,10

  ADD   DX,WORD PTR VUserAdd
  ADD   CX,WORD PTR VUserAdd

  MOV   BX,WORD PTR TIA_Scan
  CMP   BX,DX
  JG    @Add2
  CMP   BX,CX
  JL    @Add1
  JMP   @NoAdd
@Average:
  SUB   CX,2
  ADD   DX,3
@NoWiden:

  ADD   DX,WORD PTR VUserAdd
  ADD   CX,WORD PTR VUserAdd

  MOV   BX,WORD PTR LastVBLANK
  ADD   BX,WORD PTR TIA_Scan
  SHR   BX,1
  CMP   BX,DX
  JG    @Add2
  CMP   BX,CX
  JL    @Add1
  JMP   @NoAdd
{
  MOV   BX,WORD PTR TIA_Scan
  CMP   BX,10
  JG    @Add2
  CMP   BX,0
  JL    @Add1
  JMP   @NoAdd
}
@Add2:
  MOV   WORD PTR VAddAdjust,-1
  JMP   @Add3
@Add1:
  MOV   WORD PTR VAddAdjust,1
@Add3:
  MOV   AX,WORD PTR VAddAdjust
  CMP   WORD PTR VAdd,20
  JGE   @NoAdd
  CMP   WORD PTR VAdd,-20
  JLE   @NoAdd

  TEST  BYTE PTR AutoCenter,0FFh
  JZ    @NoAdd

  ADD   WORD PTR VAdd,AX
@NoAdd:








  JMP   GetOut

LWSYNC:
    DB    _32BIT_OPERAND
    SUB   AX,AX
    MOV   BX,160
    SUB   BX,WORD PTR TIA_Count
    MOV   AL,BYTE PTR Div3[BX]
    SUB   AX,WORD PTR AddCycle
    JLE   @GetOut




    CMP   BYTE PTR Controller,crPaddle
    JNE   @NoPaddle

    TEST  BYTE PTR AtariSeg[VBLANK],80h
    JNZ   @NoPaddle

    TEST  BYTE PTR Input_Byte[INPUT0],80h
    JNZ   @NoPaddle0
    DB    _32BIT_OPERAND
    SUB   WORD PTR PaddleGround0,AX
    JNC   @NoPaddle0
    MOV   BYTE PTR Input_Byte[INPUT0],80h
@NoPaddle0:

    TEST  BYTE PTR Input_Byte[INPUT1],80h
    JNZ   @NoPaddle1
    DB    _32BIT_OPERAND
    SUB   WORD PTR PaddleGround1,AX
    JNC   @NoPaddle1
    MOV   BYTE PTR Input_Byte[INPUT1],80h
@NoPaddle1:

    TEST  BYTE PTR Input_Byte[INPUT2],80h
    JNZ   @NoPaddle2
    DB    _32BIT_OPERAND
    SUB   WORD PTR PaddleGround2,AX
    JNC   @NoPaddle2
    MOV   BYTE PTR Input_Byte[INPUT2],80h
@NoPaddle2:

    TEST  BYTE PTR Input_Byte[INPUT3],80h
    JNZ   @NoPaddle3
    DB    _32BIT_OPERAND
    SUB   WORD PTR PaddleGround3,AX
    JNC   @NoPaddle3
    MOV   BYTE PTR Input_Byte[INPUT3],80h
@NoPaddle3:
@NoPaddle:




@GetOut:
(*
    MOV   BX,160
    SUB   BX,WORD PTR TIA_Count
    MOV   BL,BYTE PTR Div3[BX]
    SUB   BX,WORD PTR AddCycle
    JLE   @GetOut
*)

{
    JG    @EOLOk
    ADD   BX,228
@EOLOk:
}
{    CMP   WORD PTR TimerInterval,0
    JE    @GetOut}
(*
    TEST  BYTE PTR TimerDone,0FFh
    JNZ   @LTimerDone
    MOV   SI,WORD PTR TimerInterval
    ADD   WORD PTR TimerValue,BX
@DoAgain:
    MOV   BX,WORD PTR TimerValue
    CMP   BX,SI
    JL    @GetOut
    MOV   WORD PTR TimerValue,0
    SUB   BX,SI
    SUB   WORD PTR AtariSeg[INTTIM1],1
    JC    @Done
    ADD   WORD PTR TimerValue,BX
    JMP   @DoAgain
@Done:
    MOV   BYTE PTR TimerDone,1
@LTimerDone:
    SUB   BYTE PTR AtariSeg[INTTIM1],BL
@GetOut:
*)
  MOV   AX,160
  MOV   WORD PTR TIA_Count,AX
  MOV   BYTE PTR Write_TIA,2
  JMP   GetOut

LRSYNC:
{
  MOV   WORD PTR TIA_Count,160
  CALL  Handle_TIA
  MOV   AL,BYTE PTR AtariSeg[RSYNC]
  MOV   BYTE PTR TIA_Regs[RSYNC],AL
  SUB   WORD PTR Addr,320
  MOV   BYTE PTR Write_TIA,0
  MOV   WORD PTR TIA_Count,-68
  MOV   WORD PTR Old_TIA_Count,-68
}
  JMP   GetOut

LRESP0:

  MOV   AX,WORD PTR ResetOfs
  MOV   WORD PTR ResetOffset[0],AX
  ADD   WORD PTR ResetOfs,3

  MOV   AX,WORD PTR ObjectLoc[Player0Set * 2]
  MOV   WORD PTR OldObjectLoc[Player0Set * 2],AX

  OR    BYTE PTR ObjectSet,Player0Set
  JMP   GetOut

LRESP1:

  MOV   AX,WORD PTR ResetOfs
  MOV   WORD PTR ResetOffset[2],AX
  ADD   WORD PTR ResetOfs,3

  MOV   AX,WORD PTR ObjectLoc[Player1Set * 2]
  MOV   WORD PTR OldObjectLoc[Player1Set * 2],AX

  OR    BYTE PTR ObjectSet,Player1Set
  JMP   GetOut

LRESM0:

  TEST  BYTE PTR AtariSeg[RESMP0],2
  JZ    @Missile0Ok
  MOV   AL,BYTE PTR ObjectLoc[Player0Set * 2]
  MOV   AH,BYTE PTR _Player0Size
  SHR   AH,1
  ADD   AL,AH

  SUB   AH,AH
  CMP   AX,160
  JB    @M0Ok1A
  SUB   AX,160
@M0Ok1A:
  MOV   WORD PTR ObjectLoc[Missile0Set * 2],AX
  JMP   GetOut
@Missile0Ok:

  MOV   AX,WORD PTR ResetOfs
  MOV   WORD PTR ResetOffset[4],AX
  ADD   WORD PTR ResetOfs,3

  OR    BYTE PTR ObjectSet,Missile0Set
  JMP   GetOut

LRESM1:

  TEST  BYTE PTR AtariSeg[RESMP1],2
  JZ    @Missile1Ok
  MOV   AL,BYTE PTR ObjectLoc[Player1Set * 2]
  MOV   AH,BYTE PTR _Player1Size
  SHR   AH,1
  ADD   AL,AH

  SUB   AH,AH
  CMP   AX,160
  JB    @M1Ok1A
  SUB   AX,160
@M1Ok1A:
  MOV   WORD PTR ObjectLoc[Missile1Set * 2],AX
  JMP   GetOut
@Missile1Ok:

  MOV   AX,WORD PTR ResetOfs
  MOV   WORD PTR ResetOffset[6],AX
  ADD   WORD PTR ResetOfs,3

  OR    BYTE PTR ObjectSet,Missile1Set
  JMP   GetOut

LRESBL:

  MOV   AX,WORD PTR ResetOfs
  MOV   WORD PTR ResetOffset[8],AX
  ADD   WORD PTR ResetOfs,3

  OR    BYTE PTR ObjectSet,BallSet
  JMP   GetOut

LHMCLR:
  DB    _32BIT_OPERAND
  SUB   AX,AX
  DB    _32BIT_OPERAND
  MOV   WORD PTR AtariSeg[HMP0],AX
  MOV   BYTE PTR AtariSeg[HMBL],AL
  DB    _32BIT_OPERAND
  MOV   WORD PTR TIA_Regs[HMP0],AX
  MOV   BYTE PTR TIA_Regs[HMBL],AL
  MOV   BYTE PTR Write_TIA,0

  MOV   AX,WORD PTR HMOVECount
  ADD   AX,60 - 9
  CMP   AX,WORD PTR TIA_Count
  JNE   @HMM01A
  TEST  BYTE PTR DoHMOVE,0FFh
  JZ    @HMM01A
  MOV   BYTE PTR M0Bug,1
  MOV   BYTE PTR M0BugCount,0
@HMM01A:
  JMP   GetOut

  JMP   GetOut

LSWCHA1:

{  MOV   BYTE PTR UseKBControllers,1}
  MOV   AL,BYTE PTR AtariSeg[SWACNT1]
  MOV   BL,BYTE PTR AtariSeg[SWCHA1]
  MOV   BH,BYTE PTR AtariSeg[SWCHA2]
  MOV   CX,BX
  MOV   AH,AL
  NOT   AL
  AND   BH,AL
  AND   BL,AH
  OR    BH,BL
  MOV   BYTE PTR AtariSeg[SWCHA2],BH
  AND   CL,AH
  AND   CH,AL
  OR    CL,CH
  MOV   BYTE PTR AtariSeg[SWCHA1],CL


  { If we're writing to this port, we must be attempting to use the  }
  { keyboard controllers.  Turn on the respective bits of INPUT0/1/4 }

  MOV   BYTE PTR KBWrite,1
  CALL  CheckKBController
  JMP   GetOut

LSWACNT1:

  MOV   AL,BYTE PTR AtariSeg[SWACNT1]
  MOV   BYTE PTR AtariSeg[SWACNT2],AL
  JMP   GetOut

LSWCHB1:

  MOV   AL,BYTE PTR AtariSeg[SWCHB2]
  MOV   BYTE PTR AtariSeg[SWCHB1],AL
  JMP   GetOut

LSWBCNT1:

  MOV   AL,BYTE PTR AtariSeg[SWBCNT2]
  MOV   BYTE PTR AtariSeg[SWBCNT1],AL
  JMP   GetOut

LINTTIM1:
  JMP   GetOut

LINTTIM3:

  MOV   AL,BYTE PTR AtariSeg[INTTIM3]
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
  MOV   BYTE PTR AtariSeg[INTTIM2],AL
  JMP   GetOut

LTIM1T1:

  MOV   AL,BYTE PTR AtariSeg[TIM1T1]
  MOV   BYTE PTR AtariSeg[TIM1T2],AL
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
  MOV   BYTE PTR TimerDone,0
  MOV   WORD PTR TimerInterval,1
  MOV   WORD PTR TimerShift,0
  MOV   AX,WORD PTR AddCycle
  NEG   AX
  MOV   WORD PTR TimerValue,AX
  DB    _32BIT_OPERAND
  SUB   AX,AX

  DB    _32BIT_OPERAND
  SUB   BX,BX
  MOV   BL,BYTE PTR AddCycle
  DB    _32BIT_OPERAND
  SUB   AX,BX

  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerElapsed,AX

  MOV   AL,BYTE PTR AtariSeg[INTTIM1]
  MOV   BYTE PTR OrigTimer,AL
  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerSize,AX
  MOV   BX,WORD PTR TIA_Count
  ADD   BX,68
  MOV   AL,BYTE PTR Div3[BX]
  SUB   AH,AH
  ADD   AX,WORD PTR AddCycle
  NEG   AX
  DB    _32BIT_OPERAND
  CBW
  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerX,AX

  JMP   GetOut

LTIM2T1:

  MOV   AL,BYTE PTR AtariSeg[TIM2T1]
  MOV   BYTE PTR AtariSeg[TIM2T2],AL
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
  MOV   BYTE PTR TimerDone,0
  MOV   WORD PTR TimerInterval,8
  MOV   WORD PTR TimerShift,3
  MOV   AX,WORD PTR AddCycle
  NEG   AX
  MOV   WORD PTR TimerValue,AX
  DB    _32BIT_OPERAND
  SUB   AX,AX

  DB    _32BIT_OPERAND
  SUB   BX,BX
  MOV   BL,BYTE PTR AddCycle
  DB    _32BIT_OPERAND
  SUB   AX,BX

  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerElapsed,AX

  MOV   AL,BYTE PTR AtariSeg[INTTIM1]
  MOV   BYTE PTR OrigTimer,AL
  DB    _32BIT_OPERAND
  SHL   AX,3
  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerSize,AX
  MOV   BX,WORD PTR TIA_Count
  ADD   BX,68
  MOV   AL,BYTE PTR Div3[BX]
  SUB   AH,AH
  ADD   AX,WORD PTR AddCycle
  NEG   AX
  DB    _32BIT_OPERAND
  CBW
  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerX,AX

  JMP   GetOut

LTIM3T1:

  MOV   AL,BYTE PTR AtariSeg[TIM3T1]
  MOV   BYTE PTR AtariSeg[TIM3T2],AL
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
  MOV   BYTE PTR TimerDone,0
  MOV   WORD PTR TimerInterval,64
  MOV   WORD PTR TimerShift,6
  MOV   AX,WORD PTR AddCycle
  NEG   AX
  MOV   WORD PTR TimerValue,AX
  DB    _32BIT_OPERAND
  SUB   AX,AX

  DB    _32BIT_OPERAND
  SUB   BX,BX
  MOV   BL,BYTE PTR AddCycle
  DB    _32BIT_OPERAND
  SUB   AX,BX

  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerElapsed,AX

  MOV   AL,BYTE PTR AtariSeg[INTTIM1]
  MOV   BYTE PTR OrigTimer,AL
  DB    _32BIT_OPERAND
  SHL   AX,6
  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerSize,AX
  MOV   BX,WORD PTR TIA_Count
  ADD   BX,68
  MOV   AL,BYTE PTR Div3[BX]
  SUB   AH,AH
  ADD   AX,WORD PTR AddCycle
  NEG   AX
  DB    _32BIT_OPERAND
  CBW
  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerX,AX

  JMP   GetOut

LTIM4T1:

  MOV   AL,BYTE PTR AtariSeg[TIM4T1]
  MOV   BYTE PTR AtariSeg[TIM4T2],AL
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
  MOV   BYTE PTR TimerDone,0
  MOV   WORD PTR TimerInterval,1024
  MOV   WORD PTR TimerShift,10
  MOV   AX,WORD PTR AddCycle
  NEG   AX
  MOV   WORD PTR TimerValue,AX
  DB    _32BIT_OPERAND
  SUB   AX,AX

  DB    _32BIT_OPERAND
  SUB   BX,BX
  MOV   BL,BYTE PTR AddCycle
  DB    _32BIT_OPERAND
  SUB   AX,BX

  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerElapsed,AX

  MOV   AL,BYTE PTR AtariSeg[INTTIM1]
  MOV   BYTE PTR OrigTimer,AL
  DB    _32BIT_OPERAND
  SHL   AX,10
  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerSize,AX
  MOV   BX,WORD PTR TIA_Count
  ADD   BX,68
  DB    _32BIT_OPERAND
  SUB   AX,AX
  MOV   AL,BYTE PTR Div3[BX]
  ADD   AX,WORD PTR AddCycle
  NEG   AX
  DB    _32BIT_OPERAND
  CBW
  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerX,AX

  JMP   GetOut

LSWCHA2:

{  MOV   BYTE PTR UseKBControllers,1}
  MOV   AL,BYTE PTR AtariSeg[SWACNT1]
  MOV   BL,BYTE PTR AtariSeg[SWCHA2]
  MOV   BH,BYTE PTR AtariSeg[SWCHA1]
  MOV   CX,BX
  MOV   AH,AL
  NOT   AL
  AND   BH,AL
  AND   BL,AH
  OR    BH,BL
  MOV   BYTE PTR AtariSeg[SWCHA1],BH
  AND   CL,AH
  AND   CH,AL
  OR    CL,CH
  MOV   BYTE PTR AtariSeg[SWCHA2],CL

  { If we're writing to this port, we must be attempting to use the  }
  { keyboard controllers.  Turn on the respective bits of INPUT0/1/4 }

  MOV   BYTE PTR KBWrite,1
  CALL  CheckKBController
  JMP   GetOut

LSWACNT2:

  MOV   AL,BYTE PTR AtariSeg[SWACNT2]
  MOV   BYTE PTR AtariSeg[SWACNT1],AL
  JMP   GetOut

LSWCHB2:

  MOV   AL,BYTE PTR AtariSeg[SWCHB1]
  MOV   BYTE PTR AtariSeg[SWCHB2],AL
  JMP   GetOut

LSWBCNT2:

  MOV   AL,BYTE PTR AtariSeg[SWBCNT1]
  MOV   BYTE PTR AtariSeg[SWBCNT2],AL
  JMP   GetOut

LINTTIM2:

  MOV   AL,BYTE PTR AtariSeg[INTTIM2]
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
  MOV   BYTE PTR AtariSeg[INTTIM3],AL
  JMP   GetOut

LTIM1T2:

  MOV   AL,BYTE PTR AtariSeg[TIM1T2]
  MOV   BYTE PTR AtariSeg[TIM1T1],AL
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
  MOV   BYTE PTR TimerDone,0
  MOV   WORD PTR TimerInterval,1
  MOV   WORD PTR TimerShift,0
  MOV   AX,WORD PTR AddCycle
  NEG   AX
  MOV   WORD PTR TimerValue,AX
  DB    _32BIT_OPERAND
  SUB   AX,AX

  DB    _32BIT_OPERAND
  SUB   BX,BX
  MOV   BL,BYTE PTR AddCycle
  DB    _32BIT_OPERAND
  SUB   AX,BX

  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerElapsed,AX

  MOV   AL,BYTE PTR AtariSeg[INTTIM1]
  MOV   BYTE PTR OrigTimer,AL
  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerSize,AX
  MOV   BX,WORD PTR TIA_Count
  ADD   BX,68
  MOV   AL,BYTE PTR Div3[BX]
  SUB   AH,AH
  ADD   AX,WORD PTR AddCycle
  NEG   AX
  DB    _32BIT_OPERAND
  CBW
  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerX,AX

  JMP   GetOut

LTIM2T2:

  MOV   AL,BYTE PTR AtariSeg[TIM2T2]
  MOV   BYTE PTR AtariSeg[TIM2T1],AL
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
  MOV   BYTE PTR TimerDone,0
  MOV   WORD PTR TimerInterval,8
  MOV   WORD PTR TimerShift,3
  MOV   AX,WORD PTR AddCycle
  NEG   AX
  MOV   WORD PTR TimerValue,AX
  DB    _32BIT_OPERAND
  SUB   AX,AX

  DB    _32BIT_OPERAND
  SUB   BX,BX
  MOV   BL,BYTE PTR AddCycle
  DB    _32BIT_OPERAND
  SUB   AX,BX

  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerElapsed,AX

  MOV   AL,BYTE PTR AtariSeg[INTTIM1]
  MOV   BYTE PTR OrigTimer,AL
  DB    _32BIT_OPERAND
  SHL   AX,3
  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerSize,AX
  MOV   BX,WORD PTR TIA_Count
  ADD   BX,68
  MOV   AL,BYTE PTR Div3[BX]
  SUB   AH,AH
  ADD   AX,WORD PTR AddCycle
  NEG   AX
  DB    _32BIT_OPERAND
  CBW
  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerX,AX

  JMP   GetOut

LTIM3T2:

  MOV   AL,BYTE PTR AtariSeg[TIM3T2]
  MOV   BYTE PTR AtariSeg[TIM3T1],AL
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
  MOV   BYTE PTR TimerDone,0
  MOV   WORD PTR TimerInterval,64
  MOV   WORD PTR TimerShift,6
  MOV   AX,WORD PTR AddCycle
  NEG   AX
  MOV   WORD PTR TimerValue,AX
  DB    _32BIT_OPERAND
  SUB   AX,AX

  DB    _32BIT_OPERAND
  SUB   BX,BX
  MOV   BL,BYTE PTR AddCycle
  DB    _32BIT_OPERAND
  SUB   AX,BX

  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerElapsed,AX

  MOV   AL,BYTE PTR AtariSeg[INTTIM1]
  MOV   BYTE PTR OrigTimer,AL
  DB    _32BIT_OPERAND
  SHL   AX,6
  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerSize,AX
  MOV   BX,WORD PTR TIA_Count
  ADD   BX,68
  MOV   AL,BYTE PTR Div3[BX]
  SUB   AH,AH
  ADD   AX,WORD PTR AddCycle
  NEG   AX
  DB    _32BIT_OPERAND
  CBW
  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerX,AX

  JMP   GetOut

LTIM4T2:

  MOV   AL,BYTE PTR AtariSeg[TIM4T2]
  MOV   BYTE PTR AtariSeg[TIM4T1],AL
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
  MOV   BYTE PTR TimerDone,0
  MOV   WORD PTR TimerInterval,1024
  MOV   WORD PTR TimerShift,10
  MOV   AX,WORD PTR AddCycle
  NEG   AX
  MOV   WORD PTR TimerValue,AX
  DB    _32BIT_OPERAND
  SUB   AX,AX

  DB    _32BIT_OPERAND
  SUB   BX,BX
  MOV   BL,BYTE PTR AddCycle
  DB    _32BIT_OPERAND
  SUB   AX,BX

  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerElapsed,AX

  MOV   AL,BYTE PTR AtariSeg[INTTIM1]
  MOV   BYTE PTR OrigTimer,AL
  DB    _32BIT_OPERAND
  SHL   AX,10
  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerSize,AX
  MOV   BX,WORD PTR TIA_Count
  ADD   BX,68
  DB    _32BIT_OPERAND
  SUB   AX,AX
  MOV   AL,BYTE PTR Div3[BX]
  ADD   AX,WORD PTR AddCycle
  NEG   AX
  DB    _32BIT_OPERAND
  CBW
  DB    _32BIT_OPERAND
  MOV   WORD PTR TimerX,AX

GetOut:
    POP    DI
    POP    DX
    POP    CX
    POP    AX
End; { Handle_IO }


Procedure Handle_IO_After; Assembler;
{ ------------------------------------------------------------------------- }
{ On entry:                                                                 }
{ BX = Save_BX                                                       }
{ ------------------------------------------------------------------------- }
Label LVBLANK,LGRP0,LGRP1,LENAM0,LENAM1,LENABL,LRESMP0,LRESMP1,LVDELP0,LVDELP1,
      LNUSIZ0,LNUSIZ1,LCOLUP0,LCOLUP1,LCOLUPF,LCOLUBK,LCTRLPF,LREFP0,LREFP1,

      LRESP0,LRESP1,

      LCXCLR,LHMOVE,LWSYNC,GetOut;
Asm
  TEST  BYTE PTR Handle_IO_Set_After,0FFh
  JNZ   @L2

  MOV   AX,OFFSET GetOut
  MOV   CX,CXCLR
  SUB   BX,BX
@L1:
  MOV   WORD PTR Handle_IO_Loc_After[BX],AX
  ADD   BX,2
  LOOP  @L1

  MOV   WORD PTR Handle_IO_Loc_After[VBLANK  * 2],OFFSET LVBLANK
  MOV   WORD PTR Handle_IO_Loc_After[GRP0    * 2],OFFSET LGRP0
  MOV   WORD PTR Handle_IO_Loc_After[GRP1    * 2],OFFSET LGRP1
  MOV   WORD PTR Handle_IO_Loc_After[ENAM0   * 2],OFFSET LENAM0
  MOV   WORD PTR Handle_IO_Loc_After[ENAM1   * 2],OFFSET LENAM1
  MOV   WORD PTR Handle_IO_Loc_After[ENABL   * 2],OFFSET LENABL
  MOV   WORD PTR Handle_IO_Loc_After[RESMP0  * 2],OFFSET LRESMP0
  MOV   WORD PTR Handle_IO_Loc_After[RESMP1  * 2],OFFSET LRESMP1

  MOV   WORD PTR Handle_IO_Loc_After[NUSIZ0  * 2],OFFSET LNUSIZ0
  MOV   WORD PTR Handle_IO_Loc_After[NUSIZ1  * 2],OFFSET LNUSIZ1
  MOV   WORD PTR Handle_IO_Loc_After[COLUP0  * 2],OFFSET LCOLUP0
  MOV   WORD PTR Handle_IO_Loc_After[COLUP1  * 2],OFFSET LCOLUP1
  MOV   WORD PTR Handle_IO_Loc_After[COLUPF  * 2],OFFSET LCOLUPF
  MOV   WORD PTR Handle_IO_Loc_After[COLUBK  * 2],OFFSET LCOLUBK
  MOV   WORD PTR Handle_IO_Loc_After[CTRLPF  * 2],OFFSET LCTRLPF
  MOV   WORD PTR Handle_IO_Loc_After[REFP0   * 2],OFFSET LREFP0
  MOV   WORD PTR Handle_IO_Loc_After[REFP1   * 2],OFFSET LREFP1
  MOV   WORD PTR Handle_IO_Loc_After[HMOVE   * 2],OFFSET LHMOVE
  MOV   WORD PTR Handle_IO_Loc_After[CXCLR   * 2],OFFSET LCXCLR
  MOV   WORD PTR Handle_IO_Loc_After[WSYNC   * 2],OFFSET LWSYNC

  MOV   WORD PTR Handle_IO_Loc_After[VDELP0  * 2],OFFSET LVDELP0
  MOV   WORD PTR Handle_IO_Loc_After[VDELP1  * 2],OFFSET LVDELP1

  MOV   WORD PTR Handle_IO_Loc_After[RESP0   * 2],OFFSET LRESP0
  MOV   WORD PTR Handle_IO_Loc_After[RESP1   * 2],OFFSET LRESP1

  MOV   BYTE PTR Handle_IO_Set_After,1
  MOV   BX,WORD PTR Save_BX
@L2:
  CMP   BX,CXCLR
  JA    GetOut
  ADD   BX,BX
  JMP   WORD PTR Handle_IO_Loc_After[BX]

LRESP0:
    MOV   WORD PTR ResetPlayer0Size128,0
    MOV   BL,BYTE PTR TIA_Regs[NUSIZ0]
    AND   BX,7
    SHL   BX,1

    MOV   AX,WORD PTR OldObjectLoc[Player0Set * 2]
    MOV   CX,WORD PTR TIA_Count
    ADD   CX,WORD PTR TIA_Delay[RESP0]
    CMP   CX,AX
    JL    @TurnP0Off
    ADD   AX,WORD PTR PlayerSize[BX]
    CMP   CX,AX
{    JL    @NoTurnP0Off}
@TurnP0Off:
    MOV   AX,WORD PTR Add1A[BX]
    MOV   WORD PTR ResetPlayer0Size128,AX
@NoTurnP0Off:
    JMP   GetOut

LRESP1:
    MOV   WORD PTR ResetPlayer1Size128,0
    MOV   BL,BYTE PTR TIA_Regs[NUSIZ1]
    AND   BX,7
    SHL   BX,1

    MOV   AX,WORD PTR OldObjectLoc[Player1Set * 2]
    MOV   CX,WORD PTR TIA_Count
    ADD   CX,WORD PTR TIA_Delay[RESP1]
    CMP   CX,AX
    JL    @TurnP1Off
    ADD   AX,WORD PTR PlayerSize[BX]
    CMP   CX,AX
{    JL    @NoTurnP1Off}
@TurnP1Off:
    MOV   AX,WORD PTR Add1A[BX]
    MOV   WORD PTR ResetPlayer1Size128,AX
@NoTurnP1Off:
    JMP   GetOut

LWSYNC:
    TEST  BYTE PTR M0Bug,0FFh
    JZ    @NoM0Bug
    INC   BYTE PTR M0BugCount
    AND   BYTE PTR M0BugCount,3
    MOV   AL,BYTE PTR AtariSeg[ENAM0]
    CMP   BYTE PTR M0BugCount,3
    JNE   @LWSYNC1
    SUB   AL,AL
@LWSYNC1:
    AND   BYTE PTR DispJump,0EFh
    TEST  AL,2
    JZ    @LWSYNC2
    TEST  BYTE PTR AtariSeg[RESMP0],2
    JNZ   @LWSYNC2
    OR    BYTE PTR DispJump,10h
@LWSYNC2:

    MOV   BL,BYTE PTR TIA_Regs[NUSIZ0]
    CMP   BYTE PTR M0BugCount,2
    JNE   @LWSYNC3
    MOV   AL,BL
    SHR   AL,4
    AND   AL,3
    INC   AL
    CMP   AL,4
    JB    @LWSYNC4
    MOV   AL,3
@LWSYNC4:
    SHL   AL,4
    AND   BL,0CFh
    OR    BL,AL
@LWSYNC3:
    MOV   AL,BL
    MOV   AH,AL
    SHR   AL,1
    AND   AX,0718h
    OR    AL,AH
    AND   AH,0
    SHL   AX,7
    MOV   WORD PTR Missile0SizeNum,AX

    MOV   SI,BX
    SHR   SI,4
    AND   SI,3
    MOV   CL,BYTE PTR MissileSize[SI]
    SUB   CH,CH
    MOV   WORD PTR Missile0Size,CX
    MOV   DX,CX
    DEC   CX
    SHR   CX,1
    MOV   WORD PTR Missile0Adjust,CX
    SUB   DX,160
    MOV   WORD PTR Missile0Size160,DX

    MOV   BL,BYTE PTR M0BugCount
    SUB   BH,BH
    ADD   BX,BX
    MOV   AX,WORD PTR M0BugMove[BX]
{    SUB   WORD PTR ObjectLoc[Missile0Set * 2],15}
    SUB   WORD PTR ObjectLoc[Missile0Set * 2],AX
    CMP   WORD PTR ObjectLoc[Missile0Set * 2],0
    JGE   @NoM0Bug
    ADD   WORD PTR ObjectLoc[Missile0Set * 2],160
@NoM0Bug:
    CMP   WORD PTR TIA_Count,8
    JL    @NoClearHMOVE
    MOV   BYTE PTR DoHMOVE,0
    MOV   BYTE PTR OldDoHMOVE,0
@NoClearHMOVE:
    JMP   GetOut

LVDELP0:
  TEST  BYTE PTR AtariSeg[VDELP0],1
  JNZ   GetOut
  MOV   BL,BYTE PTR GRP0Latch
  MOV   BYTE PTR AtariSeg[GRP0],BL
  MOV   BYTE PTR TIA_Regs[GRP0],BL

  AND   BYTE PTR DispJump,0DFh
  TEST  BL,0FFh
  JZ    @LVDELP0A
  OR    BYTE PTR DispJump,20h
@LVDELP0A:
  JMP   GetOut

LVDELP1:
  TEST  BYTE PTR AtariSeg[VDELP1],1
  JNZ   GetOut
  MOV   BL,BYTE PTR GRP1Latch
  MOV   BYTE PTR AtariSeg[GRP1],BL
  MOV   BYTE PTR TIA_Regs[GRP1],BL

  AND   BYTE PTR DispJump,0F7h
  TEST  BL,0FFh
  JZ    @LVDELP1A
  OR    BYTE PTR DispJump,8
@LVDELP1A:
  JMP   GetOut

LCXCLR:
  DB    _32BIT_OPERAND
  SUB   AX,AX
  DB    _32BIT_OPERAND
  MOV   WORD PTR Input_Byte[0],AX
  DB    _32BIT_OPERAND
  MOV   WORD PTR Input_Byte[4],AX
  MOV   AL,BYTE PTR AtariSeg[CXCLR]
  MOV   BYTE PTR TIA_Regs[CXCLR],AL
  JMP   GetOut

LVBLANK:
  TEST  BYTE PTR AtariSeg[VBLANK],80h
  JNZ   @NoCheckControllers
  CMP   BYTE PTR Controller,crKeyboard
  JE    @CheckControllers
  CMP   BYTE PTR Controller,crVTP
  JE    @CheckControllers
  JMP   @NoCheckControllers
@CheckControllers:
  CALL  Handle_Input
@NoCheckControllers:
{  AND   BYTE PTR DispJump,0FDh
  TEST  BYTE PTR AtariSeg[ENABL],2
  JZ    @LVBLANKA
  OR    BYTE PTR DispJump,2
@LVBLANKA:}
  TEST  BYTE PTR AtariSeg[VBLANK],80h
  JZ    @NoGround
  CMP   BYTE PTR Cart,ctCBS
  JE    @NoGround
  MOV   WORD PTR Input_Byte[INPUT0],0
  MOV   WORD PTR Input_Byte[INPUT2],0
@NoGround:

  MOV   BX,WORD PTR TIA_Scan
  TEST  BYTE PTR AtariSeg[VBLANK],2
  JZ    @NoClear
{  CMP   BX,WORD PTR LastScan
  JGE   @ClearExit
  CMP   BX,200
  JGE   @ClearExit
  MOV   DX,WORD PTR LastScan
  CMP   DX,200
  JL    @ContBlank
  MOV   DX,200

@ContBlank:
  SUB   DX,BX
  MOV   AX,0A000h
  MOV   ES,AX
  MOV   DI,BX
  MOV   AX,DI
  SHL   DI,6
  SHL   AX,8
  ADD   DI,AX
  DB    _32BIT_OPERAND
  SUB   AX,AX
  CLD
@ClearLoop:}
{  MOV   CX,80
  DB    _32BIT_OPERAND
  REP   STOSW
  DEC   DX
  JNZ   @ClearLoop}
@ClearExit:
  MOV   WORD PTR LastScan,BX
@NoClear:



  JMP   GetOut

LGRP0:
{
  MOV   AX,WORD PTR TIA_Count
  ADD   AX,WORD PTR TIA_Delay[GRP0]
  MOV   WORD PTR GRP0Write,AX
}

  TEST  BYTE PTR AtariSeg[VDELP0],1
  JNZ   @DelayedP0
@NotDelayedP0:
  MOV   AL,BYTE PTR GRP0Latch
  MOV   BYTE PTR AtariSeg[GRP0],AL
  MOV   BYTE PTR TIA_Regs[GRP0],AL
@DelayedP0:
  MOV   BL,BYTE PTR GRP1Latch
  MOV   BYTE PTR AtariSeg[GRP1],BL
  MOV   BYTE PTR TIA_Regs[GRP1],BL
{  MOV   BL,BYTE PTR TIA_Regs[GRP1]}
  AND   BYTE PTR DispJump,0F7h
  TEST  BL,0FFh
  JZ    @LGRP0B
  OR    BYTE PTR DispJump,8
@LGRP0B:
  AND   BYTE PTR DispJump,0DFh
  TEST  BYTE PTR TIA_Regs[GRP0],0FFh  { New }
  JZ    @LGRP0A
  OR    BYTE PTR DispJump,20h
@LGRP0A:
  JMP   GetOut

LGRP1:
{
  MOV   AX,WORD PTR TIA_Count
  ADD   AX,WORD PTR TIA_Delay[GRP1]
  MOV   WORD PTR GRP1Write,AX
}

  TEST  BYTE PTR AtariSeg[VDELP1],1
  JNZ   @DelayedP1
@NotDelayedP1:
  MOV   AL,BYTE PTR GRP1Latch
  MOV   BYTE PTR AtariSeg[GRP1],AL
  MOV   BYTE PTR TIA_Regs[GRP1],AL
@DelayedP1:
  MOV   BL,BYTE PTR GRP0Latch
  MOV   BYTE PTR AtariSeg[GRP0],BL
  MOV   BYTE PTR TIA_Regs[GRP0],BL
{  MOV   BL,BYTE PTR TIA_Regs[GRP0]}
  AND   BYTE PTR DispJump,0DFh
  TEST  BL,0FFh
  JZ    @LGRP1B
  OR    BYTE PTR DispJump,20h
@LGRP1B:
  MOV   BL,BYTE PTR BallLatch
  MOV   BYTE PTR AtariSeg[ENABL],BL
  MOV   BYTE PTR TIA_Regs[ENABL],BL

  AND   BYTE PTR DispJump,0FDh
  TEST  BL,2h
  JZ    @LGRP1C
  OR    BYTE PTR DispJump,2h
@LGRP1C:

  AND   BYTE PTR DispJump,0F7h
  TEST  BYTE PTR TIA_Regs[GRP1],0FFh
  JZ    @LGRP1A
  OR    BYTE PTR DispJump,8
@LGRP1A:
  JMP   GetOut

LENAM0:

  AND   BYTE PTR DispJump,0EFh
  TEST  BYTE PTR AtariSeg[ENAM0],2
  JZ    @LENAM0A
  TEST  BYTE PTR AtariSeg[RESMP0],2
  JNZ   @LENAM0A
  OR    BYTE PTR DispJump,10h
@LENAM0A:
  JMP   GetOut

LENAM1:
  AND   BYTE PTR DispJump,0FBh
  TEST  BYTE PTR AtariSeg[ENAM1],2
  JZ    @LENAM1A
  TEST  BYTE PTR AtariSeg[RESMP1],2
  JNZ   @LENAM1A
  OR    BYTE PTR DispJump,4
@LENAM1A:
  JMP   GetOut

LENABL:

  TEST  BYTE PTR AtariSeg[VDELBL],1
  JNZ   @DelayedBL
  MOV   AL,BYTE PTR BallLatch
  MOV   BYTE PTR AtariSeg[ENABL],AL
  MOV   BYTE PTR TIA_Regs[ENABL],AL
@DelayedBL:
  AND   BYTE PTR DispJump,0FDh
  TEST  BYTE PTR AtariSeg[ENABL],2
  JZ    @LENABLA
  OR    BYTE PTR DispJump,2
@LENABLA:
  JMP   GetOut

LRESMP0:

  TEST  BYTE PTR AtariSeg[RESMP0],2
  JZ    @Missile0Ok
  MOV   AL,BYTE PTR ObjectLoc[Player0Set * 2]
  MOV   AH,BYTE PTR _Player0Size
  SHR   AH,1
  ADD   AL,AH

  SUB   AH,AH
  CMP   AX,160
  JB    @M0Ok1B
  SUB   AX,160
@M0Ok1B:
  MOV   WORD PTR ObjectLoc[Missile0Set * 2],AX
@Missile0Ok:

  AND   BYTE PTR DispJump,0EFh
  TEST  BYTE PTR AtariSeg[ENAM0],2
  JZ    @LRESMP0A
  TEST  BYTE PTR AtariSeg[RESMP0],2
  JNZ   @LRESMP0A
  OR    BYTE PTR DispJump,10h
@LRESMP0A:
  JMP   GetOut

LRESMP1:

  TEST  BYTE PTR AtariSeg[RESMP1],2
  JZ    @Missile1Ok
  MOV   AL,BYTE PTR ObjectLoc[Player1Set * 2]
  MOV   AH,BYTE PTR _Player1Size
  SHR   AH,1
  ADD   AL,AH

  SUB   AH,AH
  CMP   AX,160
  JB    @M1Ok1B
  SUB   AX,160
@M1Ok1B:
  MOV   WORD PTR ObjectLoc[Missile1Set * 2],AX
@Missile1Ok:

  AND   BYTE PTR DispJump,0FBh
  TEST  BYTE PTR AtariSeg[ENAM1],2
  JZ    @LRESMP1A
  TEST  BYTE PTR AtariSeg[RESMP1],2
  JNZ   @LRESMP1A
  OR    BYTE PTR DispJump,4
@LRESMP1A:
  JMP   GetOut

LNUSIZ0:
(*
  MOV   AL,BYTE PTR TIA_Regs[NUSIZ0]
  MOV   AH,BYTE PTR OldNUSIZ0
  MOV   DX,1
  MOV   CX,1
  CMP   AH,5
  JNE   @P0Not5A
  INC   CX
  JMP   @P0CheckNew
@P0Not5A:
  CMP   AH,7
  JNE   @P0CheckNew
{  ADD   CX,3}
@P0CheckNew:
  CMP   AL,5
  JNE   @P0Not5B
  INC   DX
  JMP   @P0CheckDone
@P0Not5B:
  CMP   AL,7
  JNE   @P0CheckDone
{  ADD   DX,3}
@P0CheckDone:
  SUB   DX,CX
  ADD   WORD PTR ObjectLoc[Player0Set * 2],DX
*)
  MOV   BL,BYTE PTR TIA_Regs[NUSIZ0]

  MOV   AL,BL
  MOV   AH,AL
  SHR   AL,1
  AND   AX,0718h
  OR    AL,AH
  AND   AH,0
  SHL   AX,7
  MOV   WORD PTR Missile0SizeNum,AX

  MOV   SI,BX
  SHR   SI,4
  AND   SI,3
  MOV   CL,BYTE PTR MissileSize[SI]
  SUB   CH,CH
  MOV   WORD PTR Missile0Size,CX
  MOV   DX,CX

  DEC   CX
  SHR   CX,1
  MOV   WORD PTR Missile0Adjust,CX

  SUB   DX,160
  MOV   WORD PTR Missile0Size160,DX
  AND   BX,7
  ADD   BX,BX
  MOV   AX,BX
  SHL   AX,7
  MOV   CL,BYTE PTR TIA_Regs[REFP0]
  SHL   CL,4
  AND   CL,80h
  OR    AL,CL
  MOV   WORD PTR Player0Size128,AX
  MOV   WORD PTR OldPlayer0Size128,AX

  CMP   WORD PTR ResetPlayer0Size128,0
  JE    @NoReset0Add
  MOV   AX,WORD PTR Add1A[BX]
  MOV   WORD PTR ResetPlayer0Size128,AX
  ADD   WORD PTR Player0Size128,AX
@NoReset0Add:

  MOV   AX,WORD PTR _PlayerSize[BX]
  MOV   WORD PTR _Player0Size,AX
  MOV   AX,WORD PTR PlayerSize[BX]
  MOV   WORD PTR Player0Size,AX
  SUB   AX,160
  MOV   WORD PTR Player0Size160,AX
{
  PUSH  1
  PUSH  0
  CALL  TurnPlayer0Off
}
  CMP   WORD PTR ObjectLoc[Missile0Set * 2],0
  JGE   @CheckBlank0{GetOut}

  MOV   AL,BYTE PTR OldNUSIZ0
  SHR   AX,4
  AND   AX,3
  CMP   AX,3
  JE    @NSZ0
  SUB   AX,AX
@NSZ0:
  NEG   AX
  SUB   AX,6
  CMP   WORD PTR ObjectLoc[Missile0Set * 2],AX
  JNE   @CheckBlank0{GetOut}

  MOV   BL,BYTE PTR AtariSeg[NUSIZ0]
  SHR   BX,4
  AND   BX,3
  MOV   CX,-9
  CMP   BX,3
  JE    @NSZ0A
  ADD   CX,3
{  SUB   BX,BX}
@NSZ0A:
{  NEG   BX
  SUB   BX,6}
  MOV   WORD PTR ObjectLoc[Missile0Set * 2],CX

@CheckBlank0:
(*
    CMP   WORD PTR ResetPlayer0Size128,0
    JNE   @NoTurnP0OffNSZ
    MOV   BL,BYTE PTR TIA_Regs[NUSIZ0]
    AND   BX,7
    MOV   AL,BYTE PTR OldNUSIZ0
    AND   AX,7
    CMP   BL,5
    JNE   @Check7P0
    CMP   AL,0
    JNE   @NoTurnP0OffNSZ
    JMP   @ContNSZ0
@Check7P0:
    CMP   BL,7
    JNE   @NoTurnP0OffNSZ
    CMP   AL,0
    JE    @ContNSZ0
    CMP   AL,1
    JE    @ContNSZ0
    CMP   AL,5
    JE    @ContNSZ0
    JMP   @NoTurnP0OffNSZ
@ContNSZ0:
    SHL   BX,1

    MOV   AX,WORD PTR OldObjectLoc[Player0Set * 2]
    MOV   CX,WORD PTR TIA_Count
    ADD   CX,WORD PTR TIA_Delay[NUSIZ0]
    CMP   CX,AX
    JL    @NoTurnP0OffNSZ
    ADD   AX,WORD PTR PlayerSize[BX]
    CMP   CX,AX
    JGE   @NoTurnP0OffNSZ
@TurnP0OffNSZ:
    MOV   AX,WORD PTR Add1A[BX]
    MOV   WORD PTR ResetPlayer0Size128,AX
    ADD   WORD PTR Player0Size128,AX
@NoTurnP0OffNSZ:
*)


  JMP   GetOut

LNUSIZ1:
(*
  MOV   AL,BYTE PTR TIA_Regs[NUSIZ1]
  MOV   AH,BYTE PTR OldNUSIZ1
  MOV   DX,1
  MOV   CX,1
  CMP   AH,5
  JNE   @P1Not5A
  INC   CX
  JMP   @P1CheckNew
@P1Not5A:
  CMP   AH,7
  JNE   @P1CheckNew
{  ADD   CX,3}
@P1CheckNew:
  CMP   AL,5
  JNE   @P1Not5B
  INC   DX
  JMP   @P1CheckDone
@P1Not5B:
  CMP   AL,7
  JNE   @P1CheckDone
{  ADD   DX,3}
@P1CheckDone:
  SUB   DX,CX
  ADD   WORD PTR ObjectLoc[Player1Set * 2],DX
*)
  MOV   BL,BYTE PTR TIA_Regs[NUSIZ1]

  MOV   AL,BL
  MOV   AH,AL
  SHR   AL,1
  AND   AX,0718h
  OR    AL,AH
  AND   AH,0
  SHL   AX,7
  MOV   WORD PTR Missile1SizeNum,AX

  MOV   SI,BX
  SHR   SI,4
  AND   SI,3
  MOV   CL,BYTE PTR MissileSize[SI]
  SUB   CH,CH
  MOV   WORD PTR Missile1Size,CX
  MOV   DX,CX

  DEC   CX
  SHR   CX,1
  MOV   WORD PTR Missile1Adjust,CX

  SUB   DX,160
  MOV   WORD PTR Missile1Size160,DX
  AND   BX,7
  ADD   BX,BX
  MOV   AX,BX
  SHL   AX,7
  MOV   CL,BYTE PTR TIA_Regs[REFP1]
  SHL   CL,4
  AND   CL,80h
  OR    AL,CL
  MOV   WORD PTR Player1Size128,AX
  MOV   WORD PTR OldPlayer1Size128,AX

  CMP   WORD PTR ResetPlayer1Size128,0
  JE    @NoReset1Add
  MOV   AX,WORD PTR Add1A[BX]
  MOV   WORD PTR ResetPlayer1Size128,AX
  ADD   WORD PTR Player1Size128,AX
@NoReset1Add:

  MOV   AX,WORD PTR _PlayerSize[BX]
  MOV   WORD PTR _Player1Size,AX
  MOV   AX,WORD PTR PlayerSize[BX]
  MOV   WORD PTR Player1Size,AX
  SUB   AX,160
  MOV   WORD PTR Player1Size160,AX
{
  PUSH  1
  PUSH  0
  CALL  TurnPlayer1Off
}
  CMP   WORD PTR ObjectLoc[Missile1Set * 2],0
  JGE   @CheckBlank1{GetOut}

  MOV   AL,BYTE PTR OldNUSIZ1
  SHR   AX,4
  AND   AX,3
  CMP   AX,3
  JE    @NSZ1
  SUB   AX,AX
@NSZ1:
  NEG   AX
  SUB   AX,6
  CMP   WORD PTR ObjectLoc[Missile1Set * 2],AX
  JNE   @CheckBlank1{GetOut}

  MOV   BL,BYTE PTR AtariSeg[NUSIZ1]
  SHR   BX,4
  AND   BX,3
  MOV   CX,-9
  CMP   BX,3
  JE    @NSZ1A
  ADD   CX,3
{  SUB   BX,BX}
@NSZ1A:
{  NEG   BX
  SUB   BX,6}
  MOV   WORD PTR ObjectLoc[Missile1Set * 2],CX

@CheckBlank1:
(*
    CMP   WORD PTR ResetPlayer1Size128,0
    JNE   @NoTurnP1OffNSZ
    MOV   BL,BYTE PTR TIA_Regs[NUSIZ1]
    AND   BX,7
    MOV   AL,BYTE PTR OldNUSIZ1
    AND   AX,7
    CMP   BL,5
    JNE   @Check7P1
    CMP   AL,0
    JNE   @NoTurnP1OffNSZ
    JMP   @ContNSZ1
@Check7P1:
    CMP   BL,7
    JNE   @NoTurnP1OffNSZ
    CMP   AL,0
    JE    @ContNSZ1
    CMP   AL,1
    JE    @ContNSZ1
    CMP   AL,5
    JE    @ContNSZ1
    JMP   @NoTurnP1OffNSZ
@ContNSZ1:
    SHL   BX,1

    MOV   AX,WORD PTR OldObjectLoc[Player1Set * 2]
    MOV   CX,WORD PTR TIA_Count
    ADD   CX,WORD PTR TIA_Delay[NUSIZ1]
    CMP   CX,AX
    JL    @NoTurnP1OffNSZ
    ADD   AX,WORD PTR PlayerSize[BX]
    CMP   CX,AX
    JGE   @NoTurnP1OffNSZ
@TurnP1OffNSZ:
    MOV   AX,WORD PTR Add1A[BX]
    MOV   WORD PTR ResetPlayer1Size128,AX
    ADD   WORD PTR Player1Size128,AX
@NoTurnP1OffNSZ:
*)

  JMP   GetOut

LCOLUP0:

  MOV   AL,BYTE PTR TIA_Regs[COLUP0]
  MOV   AH,AL
  MOV   WORD PTR ColorLum[0],AX
  MOV   BX,WORD PTR ColorLum[4]
  MOV   DX,WORD PTR ColorLum[2]
  TEST  BYTE PTR TIA_Regs[CTRLPF],2
  JZ    @LP01

  MOV   CL,BYTE PTR TIA_Regs[CTRLPF]
  AND   CL,0Fh
  CMP   CL,0Fh
  JZ    @LP01

  MOV   WORD PTR CLW,AX
  MOV   WORD PTR CLW[2],AX
  MOV   WORD PTR CRW,DX
  MOV   WORD PTR CRW[2],DX
  JMP   @LP02
@LP01:
  MOV   WORD PTR CLW,BX
  MOV   WORD PTR CLW[2],BX
  MOV   WORD PTR CRW,BX
  MOV   WORD PTR CRW[2],BX
@LP02:
  JMP   GetOut

LCOLUP1:

  MOV   AL,BYTE PTR TIA_Regs[COLUP1]
  MOV   AH,AL
  MOV   WORD PTR ColorLum[2],AX
  MOV   BX,WORD PTR ColorLum[4]
  MOV   CX,WORD PTR ColorLum[0]
  TEST  BYTE PTR TIA_Regs[CTRLPF],2
  JZ    @LP11

  MOV   DL,BYTE PTR TIA_Regs[CTRLPF]
  AND   DL,0Fh
  CMP   DL,0Fh
  JZ    @LP11

  MOV   WORD PTR CLW,CX
  MOV   WORD PTR CLW[2],CX
  MOV   WORD PTR CRW,AX
  MOV   WORD PTR CRW[2],AX
  JMP   @LP12
@LP11:
  MOV   WORD PTR CLW,BX
  MOV   WORD PTR CLW[2],BX
  MOV   WORD PTR CRW,BX
  MOV   WORD PTR CRW[2],BX
@LP12:
  JMP   GetOut

LCOLUPF:

  MOV   AL,BYTE PTR TIA_Regs[COLUPF]
  MOV   AH,AL
  MOV   WORD PTR ColorLum[4],AX
  MOV   CX,WORD PTR ColorLum[0]
  MOV   DX,WORD PTR ColorLum[2]
  TEST  BYTE PTR TIA_Regs[CTRLPF],2
  JZ    @LPF1

  MOV   BL,BYTE PTR TIA_Regs[CTRLPF]
  AND   BL,0Fh
  CMP   BL,0Fh
  JZ    @LPF1

  MOV   WORD PTR CLW,CX
  MOV   WORD PTR CLW[2],CX
  MOV   WORD PTR CRW,DX
  MOV   WORD PTR CRW[2],DX
  JMP   @LPF2
@LPF1:
  MOV   WORD PTR CLW,AX
  MOV   WORD PTR CLW[2],AX
  MOV   WORD PTR CRW,AX
  MOV   WORD PTR CRW[2],AX
@LPF2:
  JMP   GetOut

LCOLUBK:

  MOV   AL,BYTE PTR TIA_Regs[COLUBK]
  MOV   AH,AL
  MOV   WORD PTR ColorLum[6],AX
  JMP   GetOut

LCTRLPF:
{  MOV   AL,BYTE PTR _CTRLPF
  MOV   BYTE PTR TIA_Regs[CTRLPF],AL}

{  MOV   AL,BYTE PTR TIA_Regs[CTRLPF]
  MOV   SI,AX
  SHR   SI,4
  AND   SI,3
  MOV   CL,BYTE PTR MissileSize[SI]
  SUB   CH,CH
  MOV   WORD PTR BallSize,CX

  MOV   DX,CX
  DEC   DX
  SHR   DX,1
  MOV   WORD PTR BallAdjust,DX

  SUB   CX,160
  MOV   WORD PTR BallSize160,CX
  MOV   CX,WORD PTR ColorLum[0]
  MOV   DX,WORD PTR ColorLum[2]
  MOV   BX,WORD PTR ColorLum[4]
  TEST  AL,2
  JZ    @LCPF1
  MOV   WORD PTR CLW,CX
  MOV   WORD PTR CLW[2],CX
  MOV   WORD PTR CRW,DX
  MOV   WORD PTR CRW[2],DX
  JMP   @LCPF2
@LCPF1:
  MOV   WORD PTR CLW,BX
  MOV   WORD PTR CLW[2],BX
  MOV   WORD PTR CRW,BX
  MOV   WORD PTR CRW[2],BX
@LCPF2:}

  CMP   WORD PTR ObjectLoc[BallSet * 2],0
  JGE   GetOut

  MOV   AL,BYTE PTR TIA_Regs[CTRLPF]
  SHR   AX,4
  AND   AX,3
  CMP   AX,3
  JE    @CPF1
  SUB   AX,AX
@CPF1:
  NEG   AX
  SUB   AX,6
  CMP   WORD PTR ObjectLoc[BallSet * 2],AX
  JNE   GetOut

  MOV   BL,BYTE PTR CTRLPFLatch
  SHR   BX,4
  AND   BX,3
  MOV   CX,-9
  CMP   BX,3
  JE    @CPF1A
  ADD   CX,3
{  SUB   BX,BX}
@CPF1A:
{  NEG   BX
  SUB   BX,6}
  MOV   WORD PTR ObjectLoc[BallSet * 2],CX

  JMP   GetOut

LREFP0:

  MOV   CL,BYTE PTR TIA_Regs[REFP0]
  MOV   BL,BYTE PTR TIA_Regs[NUSIZ0]
  AND   BX,7
  ADD   BX,BX
  MOV   AX,BX
  SHL   AX,7
  SHL   CL,4
  AND   CL,80h
  OR    AL,CL
  MOV   WORD PTR Player0Size128,AX
  MOV   WORD PTR OldPlayer0Size128,AX
  MOV   AX,WORD PTR PlayerSize[BX]
  MOV   WORD PTR Player0Size,AX
  SUB   AX,160
  MOV   WORD PTR Player0Size160,AX
  JMP   GetOut

LREFP1:

  MOV   CL,BYTE PTR TIA_Regs[REFP1]
  MOV   BL,BYTE PTR TIA_Regs[NUSIZ1]
  AND   BX,7
  ADD   BX,BX
  MOV   AX,BX
  SHL   AX,7
  SHL   CL,4
  AND   CL,80h
  OR    AL,CL
  MOV   WORD PTR Player1Size128,AX
  MOV   WORD PTR OldPlayer1Size128,AX
  MOV   AX,WORD PTR PlayerSize[BX]
  MOV   WORD PTR Player1Size,AX
  SUB   AX,160
  MOV   WORD PTR Player1Size160,AX
  JMP   GetOut
(*
LVDELBL:

  TEST  BYTE PTR TIA_Regs[VDELBL],1
  DB    0Fh,94h,0C0h   { SETZ  AL }

  AND   BYTE PTR DispJump,0FDh
  TEST  BYTE PTR AtariSeg[ENABL],2
  JZ    @LVDELBLA
{  TEST  AL,1
  JNZ   @LVDELBLA}
  OR    BYTE PTR DispJump,2
@LVDELBLA:
  JMP   GetOut
*)
LHMOVE:

  AND   BYTE PTR DispJump,0EFh
  TEST  BYTE PTR AtariSeg[ENAM0],2
  JZ    @LHMOVEA
  TEST  BYTE PTR AtariSeg[RESMP0],2
  JNZ   @LHMOVEA
  OR    BYTE PTR DispJump,10h
@LHMOVEA:

  MOV   BL,BYTE PTR TIA_Regs[NUSIZ0]

  MOV   AL,BL
  MOV   AH,AL
  SHR   AL,1
  AND   AX,0718h
  OR    AL,AH
  AND   AH,0
  SHL   AX,7
  MOV   WORD PTR Missile0SizeNum,AX

  MOV   SI,BX
  SHR   SI,4
  AND   SI,3
  MOV   CL,BYTE PTR MissileSize[SI]
  SUB   CH,CH
  MOV   WORD PTR Missile0Size,CX
  MOV   DX,CX
  DEC   CX
  SHR   CX,1
  MOV   WORD PTR Missile0Adjust,CX
  SUB   DX,160
  MOV   WORD PTR Missile0Size160,DX


  MOV   BYTE PTR M0Bug,0
  MOV   BYTE PTR DoHMOVE,1
  MOV   BYTE PTR OldDoHMOVE,1
  MOV   AX,WORD PTR TIA_Count
  MOV   WORD PTR HMOVECount,AX

  MOV   AL,BYTE PTR TIA_Regs[HMP0]

  CBW

  SAR   AX,4
  SUB   WORD PTR ObjectLoc[Player0Set * 2],AX
  MOV   CX,160
  OR    AL,AL
  JNS   @P0
  NEG   CX
@P0:
  CMP   BYTE PTR ObjectLoc[Player0Set * 2],160
  JB    @P0Ok
  ADD   WORD PTR ObjectLoc[Player0Set * 2],CX
@P0Ok:
  MOV   AX,WORD PTR OldPlayer0Size128
  MOV   WORD PTR Player0Size128,AX

  MOV   AL,BYTE PTR TIA_Regs[HMP1]

  CBW

  SAR   AX,4
  SUB   WORD PTR ObjectLoc[Player1Set * 2],AX
  MOV   CX,160
  OR    AL,AL
  JNS   @P1
  NEG   CX
@P1:
  CMP   BYTE PTR ObjectLoc[Player1Set * 2],160
  JB    @P1Ok
  ADD   WORD PTR ObjectLoc[Player1Set * 2],CX
@P1Ok:
  MOV   AX,WORD PTR OldPlayer1Size128
  MOV   WORD PTR Player1Size128,AX

  TEST  BYTE PTR AtariSeg[RESMP0],2
  JZ    @Missile0OkA
  MOV   AL,BYTE PTR ObjectLoc[Player0Set * 2]
  MOV   AH,BYTE PTR _Player0Size
  SHR   AH,1
  ADD   AL,AH

  SUB   AH,AH

  CMP   AX,160
  JB    @M0Ok1
  SUB   AX,160
@M0Ok1:
  MOV   WORD PTR ObjectLoc[Missile0Set * 2],AX
  JMP   @M0Ok
@Missile0OkA:
  MOV   AL,BYTE PTR TIA_Regs[HMM0]

  CBW

  SAR   AX,4

  MOV   BX,WORD PTR ObjectLoc[Missile0Set * 2]

  SUB   WORD PTR ObjectLoc[Missile0Set * 2],AX
  MOV   CX,160
  OR    AL,AL
  JNS   @M0
  NEG   CX
@M0:
{  CMP   BYTE PTR ObjectLoc[Missile0Set * 2],160
  JB    @M0Ok
  ADD   WORD PTR ObjectLoc[Missile0Set * 2],CX}

  CMP   WORD PTR ObjectLoc[Missile0Set * 2],160
{  JL    @M0Ok}
  JGE   @AddToM0
  CMP   WORD PTR ObjectLoc[Missile0Set * 2],-68
{  JGE   @M0Ok}
  JL    @AddToM0
  CMP   WORD PTR ObjectLoc[Missile0Set * 2],0
  JGE   @M0Ok
{  CMP   BX,0
  JL    @M0Ok}
  CMP   AX,1
  JL    @M0Ok
  CMP   BX,-8
  JL    @M0Ok
@AddToM0:
  ADD   WORD PTR ObjectLoc[Missile0Set * 2],CX

@M0Ok:

  TEST  BYTE PTR AtariSeg[RESMP1],2
  JZ    @Missile1OkA
  MOV   AL,BYTE PTR ObjectLoc[Player1Set * 2]
  MOV   AH,BYTE PTR _Player1Size
  SHR   AH,1
  ADD   AL,AH

  SUB   AH,AH

  CMP   AX,160
  JB    @M1Ok1
  SUB   AX,160
@M1Ok1:
  MOV   WORD PTR ObjectLoc[Missile1Set * 2],AX
  JMP   @M1Ok
@Missile1OkA:
  MOV   AL,BYTE PTR TIA_Regs[HMM1]

  CBW

  SAR   AX,4

  MOV   BX,WORD PTR ObjectLoc[Missile1Set * 2]

  SUB   WORD PTR ObjectLoc[Missile1Set * 2],AX
  MOV   CX,160
  OR    AL,AL
  JNS   @M1
  NEG   CX
@M1:
{  CMP   BYTE PTR ObjectLoc[Missile1Set * 2],160
  JB    @M1Ok
  ADD   WORD PTR ObjectLoc[Missile1Set * 2],CX}

  CMP   WORD PTR ObjectLoc[Missile1Set * 2],160
{  JL    @M0Ok}
  JGE   @AddToM1
  CMP   WORD PTR ObjectLoc[Missile1Set * 2],-68
  JL    @AddToM1
  CMP   WORD PTR ObjectLoc[Missile1Set * 2],0
  JGE   @M1Ok
{  CMP   BX,0
  JL    @M1Ok}
  CMP   AX,1
  JL    @M1Ok
  CMP   BX,-8
  JL    @M1Ok
@AddToM1:
  ADD   WORD PTR ObjectLoc[Missile1Set * 2],CX
@M1Ok:

  MOV   AL,BYTE PTR TIA_Regs[HMBL]

  CBW

  SAR   AX,4

  MOV   BX,WORD PTR ObjectLoc[BallSet * 2]

  SUB   WORD PTR ObjectLoc[BallSet * 2],AX
  MOV   CX,160
  OR    AL,AL
  JNS   @BL
  NEG   CX
@BL:
  CMP   WORD PTR ObjectLoc[BallSet * 2],160
{  JB    @BLOk}

  JGE   @AddToBL
  CMP   WORD PTR ObjectLoc[BallSet * 2],-68
  JL    @AddToBL
  CMP   WORD PTR ObjectLoc[BallSet * 2],0
  JGE   @BLOk
{  CMP   BX,0
  JL    @M1Ok}
  CMP   AX,1
  JL    @BLOk
  CMP   BX,-8
  JL    @BLOk
@AddToBL:
  ADD   WORD PTR ObjectLoc[BallSet * 2],CX
@BLOk:
{
  MOV   AX,WORD PTR ObjectLoc[Player0Set * 2]
  MOV   WORD PTR GRP0Write,AX

  MOV   AX,WORD PTR ObjectLoc[Player1Set * 2]
  MOV   WORD PTR GRP1Write,AX
}

  { Adjust object positions if the HMOVE occurred a little early }

  CMP   BYTE PTR TIA_Count,154
  JNE   @NoAdjust
  SUB   WORD PTR ObjectLoc[Player0Set * 2],8
  JNC   @AdjP1
  ADD   WORD PTR ObjectLoc[Player0Set * 2],160
@AdjP1:
  SUB   WORD PTR ObjectLoc[Player1Set * 2],8
  JNC   @AdjM0
  ADD   WORD PTR ObjectLoc[Player1Set * 2],160
@AdjM0:
  SUB   WORD PTR ObjectLoc[Missile0Set * 2],8
  JNC   @AdjM1
  ADD   WORD PTR ObjectLoc[Missile0Set * 2],160
@AdjM1:
  SUB   WORD PTR ObjectLoc[Missile1Set * 2],8
  JNC   @AdjBL
  ADD   WORD PTR ObjectLoc[Missile1Set * 2],160
@AdjBL:
  SUB   WORD PTR ObjectLoc[BallSet * 2],8
  JNC   @NoAdjust
  ADD   WORD PTR ObjectLoc[BallSet * 2],160
@NoAdjust:

GetOut:
End; { Handle_IO_After }


Procedure InitEmulator;
Begin
  FixTimer            := 0;
  FixTimerNum         := 0;
  AutoCenter          := 1;
  FillChar(ResetOffset,SizeOf(ResetOffset),#0);
  ResetOfs            := 0;

  VBLANKOff           := False;
  LastVBLANK          := 200;

{  MegaBoyNum          := 0;}

  Missile0SizeNum     := 0;
  Missile1SizeNum     := 0;
  OldPlayer0Size128   := 0;
  OldPlayer1Size128   := 0;
  M0Bug               := False;
  M0BugCount          := 0;
  StarpathWriteValue  := 0;
  VAdd                := 0;
  VAddAdjust          := 0;
  VUserAdd            := 0;
  CTRLPFLatch         := 0;
  CTRLPFScan          := -37;
  CTRLPFCount         := -68;
  Indy500             := 0;
  LastScan            := 0;
  NewScan             := 0;
  PaddleGround0       := PadMax;
  PaddleGround1       := PadMax;
  PaddleGround2       := PadMax;
  PaddleGround3       := PadMax;
  GRP0Latch           := 0;
  GRP1Latch           := 0;
{
  GRP0Write           := -68;
  GRP1Write           := -68;
}
  BallLatch           := 0;
  TIA_Scan            := -40;
  DoHMOVE             := False;
  OldDoHMOVE          := False;
  LineStart           := 0;
  TimerDone           := False;
  TimerInterval       := 1024{0};
  TimerValue          := 0;
  TimerShift          := 10;

  TimerX              := 0;
  TimerSize           := 1024 * 256;
  OrigTimer           := $14;
  TimerElapsed        := 0;

  AtariSeg[INTTIM1]   := $14;
{  AtariSeg[INTTIM2]   := $14;
  AtariSeg[INTTIM3]   := 0;}
  ColorOrBW           := 8;
  Difficulty1         := 0;
  Difficulty2         := 0;
  ColorOrBWChange     := True;
  Difficulty1Change   := True;
  Difficulty2Change   := True;
  AutoCenterChange    := True;
  TopVBLANK           := True;
  AtariSeg[SWCHB1]    := ColorOrBW Or Difficulty1 Or Difficulty2 Or 3;
  AtariSeg[SWCHB2]    := ColorOrBW Or Difficulty1 Or Difficulty2 Or 3;
  TIA_Count           := -68;
  Old_TIA_Count       := -68;
  FillChar(ObjectLoc,SizeOf(ObjectLoc),#0);
  Addr                := 0;
  Latched             := False;
  ReadTime            := 1;
  Write_TIA           := 0;
  Handle_IO_Set       := False;
  Handle_IO_Set_After := False;
  StarpathWrite       := False;
  AddCycle            := 0;
  Player0Size         := 7;
  Player1Size         := 7;
  Player0Size160      := -153;
  Player1Size160      := -153;
  Player0Size128      := 0;
  Player1Size128      := 0;
  ResetPlayer0Size128 := 0;
  ResetPlayer1Size128 := 0;
  Missile0Size        := 1;
  Missile1Size        := 1;
  Missile0Size160     := -159;
  Missile1Size160     := -159;
  BallSize            := 1;
  BallSize160         := -159;
  ObjectSet           := 0;
  Handle_TIA_Jump_Set := False;
  DispJump            := 0;
  FillChar(Input_Byte,SizeOf(Input_Byte),#0);
  Input_Byte[INPUT4]  := $80;
  Input_Byte[INPUT5]  := $80;
  Input_Byte[$E]      := $F;
  Input_Byte[$F]      := $F;
  Missile0Adjust      := 0;
  Missile1Adjust      := 0;
  BallAdjust          := 0;
  FillChar(Handle_IO_Loc,SizeOf(Handle_IO_Loc),#0);
  FillChar(Handle_IO_Loc_After,SizeOf(Handle_IO_Loc_After),#0);
  FillChar(ColorLum,SizeOf(ColorLum),#0);
  FillChar(TIA_Delay,SizeOf(TIA_Delay),#0);
  TIA_Delay[GRP0]  := 1;
  TIA_Delay[GRP1]  := 1;
  TIA_Delay[REFP0] := 1;
  TIA_Delay[REFP1] := 1;
  TIA_Delay[PF0]   := 4;
  TIA_Delay[PF1]   := 4;
  TIA_Delay[PF2]   := 4;

  TIA_Delay[RESP0] := 13;
  TIA_Delay[RESP1] := 13;

  TIA_Delay[NUSIZ0] := 12;
  TIA_Delay[NUSIZ1] := 12;
End; { InitEmulator }


Var
  BCD_A     : Byte;
  BCD_Add   : Byte;
  BCD_Flags : Byte;


Procedure ADC_BCD_A(Flags: Word);
Var
  OldA : Byte;
  Sum  : Word;
  V    : Boolean;
  A1   : Word;
  A2   : Word;

Begin
  OldA := BCD_A;
  A1   := BCDTable[0,BCD_A];
  A2   := BCDTable[0,BCD_Add];
  Sum  := A1 + A2 + (Flags And 1);
  If Sum > 99
   Then BCD_Flags := BCD_Flags Or 1
   Else BCD_Flags := BCD_Flags And $FE;
  BCD_A := BCDTable[1,(Sum And $FF)];
  If BCD_A = 0
   Then BCD_Flags := BCD_Flags Or 2
   Else BCD_Flags := BCD_Flags And $FD;
  BCD_Flags := (BCD_Flags And $7F) Or (BCD_A And $80);
  V         := ((((OldA  Xor BCD_A)   And $80) And
                 ((BCD_A Xor BCD_Add) And $80)) <> 0);
  If V
   Then BCD_Flags := BCD_Flags Or $40
   Else BCD_Flags := BCD_Flags And $BF;
End; { ADC_BCD_A }


Procedure SBC_BCD_A(Flags: Word);
Var
  OldA : Byte;
  Diff : Integer;
  V    : Boolean;
  A1   : Integer;
  A2   : Integer;

Begin
  OldA := BCD_A;
  A1   := BCDTable[0,BCD_A];
  A2   := BCDTable[0,BCD_Add];
  Diff := A1 - A2 - ((Flags And 1){ Xor 1});
  If Diff < 0 Then Inc(Diff,100);
  BCD_A := BCDTable[1,(Diff And $FF)];
  If BCD_A = 0
   Then BCD_Flags := BCD_Flags Or 2
   Else BCD_Flags := BCD_Flags And $FD;
  BCD_Flags := (BCD_Flags And $7F) Or (BCD_A And $80);

  If OldA >= BCD_Add + ((Flags And 1){ Xor 1})
   Then BCD_Flags := BCD_Flags Or 1
   Else BCD_Flags := BCD_Flags And $FE;
  V := ((((OldA  Xor BCD_A)   And $80) And
         ((BCD_A Xor BCD_Add) And $80)) <> 0);
  If V
   Then BCD_Flags := BCD_Flags Or $40
   Else BCD_Flags := BCD_Flags And $BF;
End; { SBC_BCD_A }


Procedure ADC_BCD; Assembler;
{ In:   CL    - accumulator            }
{       DL    - value to add           }
{       Flags - carry is set correctly }
{ Out:  CL    - set on exit            }
{       CH    - set on exit            }
Asm
(*
  PUSHF
  PUSHA
  MOV    BYTE PTR BCD_A,CL
  MOV    BYTE PTR BCD_Add,DL
  MOV    BYTE PTR BCD_Flags,CH
  PUSHF
  CALL   ADC_BCD_A
  POPA
  POPF
  MOV    CL,BYTE PTR BCD_A
  MOV    CH,BYTE PTR BCD_Flags
*)
  PUSHF
  PUSH   DX
  PUSHF
  AND    CH,03Ch
  MOV    BL,CL
  MOV    BH,CL
  SHR    BH,4
  AND    DL,0Fh
  AND    BL,0Fh
  POPF
  ADC    BL,DL
  POP    DX
  PUSH   DX
  SHR    DL,4
(*
  TEST   BL,0F0h      { TEST clears the carry flag }
  JZ     @L6
  STC
@L6:
  ADC    BH,DL
*)
  ADD    BH,DL

  CMP    BL,9
  JBE    @L1
  ADD    BL,6         { Fixup the low nibble }
@L1:
  POP    DX
  POPF
  PUSH   DX

  ADC    DL,CL
  JNZ    @L2
  OR     CH,2         { Set the zero flag }
@L2:
  MOV    DL,BH
  SHL    DL,4
  AND    DL,80h
  OR     CH,DL        { Set the negative flag }

  MOV    DL,BH
  SHL    DL,4
  XOR    DL,CL
  AND    DL,80h
  JZ     @L3
  POP    DX
  PUSH   DX
  XOR    DL,CL
  AND    DL,80h
  JNZ    @L3
  OR     CH,40h       { Set the overflow flag }
@L3:
  POP    DX

  TEST   BL,0F0h
  JZ     @L7
  INC    BH
@L7:
  CMP    BH,9
  JBE    @L4
  ADD    BH,6         { Fixup the high nibble }
@L4:

  TEST   BH,0F0h
  JZ     @L5
  OR     CH,1         { Set the carry flag }
@L5:

  SHL    BH,4
  AND    BL,0Fh
  OR     BL,BH
  MOV    CL,BL        { Set the result }
End; { ADC_BCD }


Procedure SBC_BCD; Assembler;
{ In:   CL    - accumulator            }
{       DL    - value to subtract      }
{       Flags - carry is set correctly }
{ Out:  CL    - set on exit            }
{       CH    - set on exit            }

Asm
(*
  PUSHF
  PUSHA
  MOV    BYTE PTR BCD_A,CL
  MOV    BYTE PTR BCD_Add,DL
  MOV    BYTE PTR BCD_Flags,CH
  PUSHF
  CALL   SBC_BCD_A
  POPA
  POPF
  MOV    CL,BYTE PTR BCD_A
  MOV    CH,BYTE PTR BCD_Flags
*)
  PUSHF
  PUSH   DX
  PUSHF
  AND    CH,03Ch
  MOV    BL,CL
  MOV    BH,CL
  SHR    BH,4
  AND    DL,0Fh
  AND    BL,0Fh
  POPF
  SBB    BL,DL
  TEST   BL,0F0h      { TEST clears the carry flag }
  JZ     @L1
  SUB    BL,6
  AND    BL,0Fh
  STC
@L1:
  POP    DX
  PUSH   DX
  PUSHF
  SHR    DL,4
  POPF
  SBB    BH,DL
  TEST   BH,0F0h
  JZ     @L2
  SUB    BH,6
@L2:
  SHL    BH,4
  OR     BL,BH
  POP    DX
  POPF
  MOV    BH,CL
  SBB    BH,DL
  JC     @L6          { Note the difference! }
  PUSHF
  OR     CH,1
  POPF
@L6:
  JNO    @L7
  OR     CH,40h
@L7:
  OR     BH,BH
  JNZ    @L8
  OR     CH,2
@L8:
  MOV    DL,BH
  AND    DL,80h
  ADD    CH,DL
  MOV    CL,BL
End; { SBC_BCD }

Procedure HandleStarpathRTS; Assembler;
Asm
  PUSH   AX
  PUSH   BX
  PUSH   CX
  PUSH   DX
  PUSH   DI

  DB     _32BIT_OPERAND
  PUSH   WORD PTR ASeg
  DB     _32BIT_OPERAND
  PUSH   WORD PTR ROMBackup
  PUSH   1FF8h
  PUSH   1FF8h
  PUSH   WORD PTR SPBankNum
  PUSH   WORD PTR TIA_Count
  PUSH   WORD PTR TIA_Scan
  PUSH   WORD PTR ROMSize

  CALL   HandleStarpath
  MOV    CL,BYTE PTR SPBank
  MOV    BYTE PTR SPBankNum,CL

  POP    DI
  POP    DX
  POP    CX
  POP    BX
  POP    AX
End; { HandleStarpathRTS }

Procedure ResetMissile0; Assembler;
Asm
  TEST  BYTE PTR AtariSeg[RESMP0],2
  JZ    @Missile0Ok
  MOV   AL,BYTE PTR ObjectLoc[Player0Set * 2]
  MOV   AH,BYTE PTR _Player0Size
  SHR   AH,1
  ADD   AL,AH

  SUB   AH,AH
  CMP   AX,160
  JB    @M0Ok1A
  SUB   AX,160
@M0Ok1A:
  MOV   WORD PTR ObjectLoc[Missile0Set * 2],AX
@Missile0Ok:
End; { ResetMissile0 }


Procedure ResetMissile1; Assembler;
Asm
  TEST  BYTE PTR AtariSeg[RESMP1],2
  JZ    @Missile1Ok
  MOV   AL,BYTE PTR ObjectLoc[Player1Set * 2]
  MOV   AH,BYTE PTR _Player1Size
  SHR   AH,1
  ADD   AL,AH

  SUB   AH,AH
  CMP   AX,160
  JB    @M1Ok1A
  SUB   AX,160
@M1Ok1A:
  MOV   WORD PTR ObjectLoc[Missile1Set * 2],AX
@Missile1Ok:
End; { ResetMissile1 }


Procedure SetPaddlePositions; Assembler;
Asm
  DB    _32BIT_OPERAND
  PUSH  BX
  DB    _32BIT_OPERAND
  MOV   BX,WORD PTR AddCycle

  TEST  BYTE PTR Input_Byte[INPUT0],80h
  JNZ   @NoPaddle0
  DB    _32BIT_OPERAND
  SUB   WORD PTR PaddleGround0,BX
  JNC   @NoPaddle0
  MOV   BYTE PTR Input_Byte[INPUT0],80h
@NoPaddle0:

  TEST  BYTE PTR Input_Byte[INPUT1],80h
  JNZ   @NoPaddle1
  DB    _32BIT_OPERAND
  SUB   WORD PTR PaddleGround1,BX
  JNC   @NoPaddle1
  MOV   BYTE PTR Input_Byte[INPUT1],80h
@NoPaddle1:

  TEST  BYTE PTR Input_Byte[INPUT2],80h
  JNZ   @NoPaddle2
  DB    _32BIT_OPERAND
  SUB   WORD PTR PaddleGround2,BX
  JNC   @NoPaddle2
  MOV   BYTE PTR Input_Byte[INPUT2],80h
@NoPaddle2:

  TEST  BYTE PTR Input_Byte[INPUT3],80h
  JNZ   @NoPaddle3
  DB    _32BIT_OPERAND
  SUB   WORD PTR PaddleGround3,BX
  JNC   @NoPaddle3
  MOV   BYTE PTR Input_Byte[INPUT3],80h
@NoPaddle3:

  DB    _32BIT_OPERAND
  POP   BX

{
  TEST  BYTE PTR Input_Byte[INPUT0],80h
  JNZ   @NoPaddle
  TEST  BYTE PTR AtariSeg[VBLANK],80h
  JNZ   @NoPaddle
  DB    _32BIT_OPERAND
  PUSH  BX
  DB    _32BIT_OPERAND
  MOV   BX,WORD PTR AddCycle
  DB    _32BIT_OPERAND
  SUB   WORD PTR PaddleGround,BX
  JNC   @NoPaddle1
  MOV   BYTE PTR Input_Byte[INPUT0],80h
@NoPaddle1:
  DB    _32BIT_OPERAND
  POP   BX
}
End; { SetPaddlePositions }


Procedure Interpret(Var _Start: Word; Var _P,_A,_X,_Y,_S: Byte);
Var
  P,A,X,Y,S : Byte;
  Start     : Word;

Label DoNothing,EmulateLoop,NoReadTime,DoneReadTime,BackToLoop,GetOut,
      L00,L01,L02,L03,L04,L05,L06,L07,L08,L09,L0A,L0B,L0C,L0D,L0E,L0F,
      L10,L11,L12,L13,L14,L15,L16,L17,L18,L19,L1A,L1B,L1C,L1D,L1E,L1F,
      L20,L21,L22,L23,L24,L25,L26,L27,L28,L29,L2A,L2B,L2C,L2D,L2E,L2F,
      L30,L31,L32,L33,L34,L35,L36,L37,L38,L39,L3A,L3B,L3C,L3D,L3E,L3F,
      L40,L41,L42,L43,L44,L45,L46,L47,L48,L49,L4A,L4B,L4C,L4D,L4E,L4F,
      L50,L51,L52,L53,L54,L55,L56,L57,L58,L59,L5A,L5B,L5C,L5D,L5E,L5F,
      L60,L61,L62,L63,L64,L65,L66,L67,L68,L69,L6A,L6B,L6C,L6D,L6E,L6F,
      L70,L71,L72,L73,L74,L75,L76,L77,L78,L79,L7A,L7B,L7C,L7D,L7E,L7F,
      L80,L81,L82,L83,L84,L85,L86,L87,L88,L89,L8A,L8B,L8C,L8D,L8E,L8F,
      L90,L91,L92,L93,L94,L95,L96,L97,L98,L99,L9A,L9B,L9C,L9D,L9E,L9F,
      LA0,LA1,LA2,LA3,LA4,LA5,LA6,LA7,LA8,LA9,LAA,LAB,LAC,LAD,LAE,LAF,
      LB0,LB1,LB2,LB3,LB4,LB5,LB6,LB7,LB8,LB9,LBA,LBB,LBC,LBD,LBE,LBF,
      LC0,LC1,LC2,LC3,LC4,LC5,LC6,LC7,LC8,LC9,LCA,LCB,LCC,LCD,LCE,LCF,
      LD0,LD1,LD2,LD3,LD4,LD5,LD6,LD7,LD8,LD9,LDA,LDB,LDC,LDD,LDE,LDF,
      LE0,LE1,LE2,LE3,LE4,LE5,LE6,LE7,LE8,LE9,LEA,LEB,LEC,LED,LEE,LEF,
      LF0,LF1,LF2,LF3,LF4,LF5,LF6,LF7,LF8,LF9,LFA,LFB,LFC,LFD,LFE,LFF;

Begin

  { AL - X reg            AH - Y reg    }
  { BL - work             BH - work     }
  { CL - Accumulator      CH - Flags    }
  { DL - work             DH - Stack    }
  { SI - unused           DI - PC Reg   }
  { BP - used             SP - not used }

  P                   := _P;
  A                   := _A;
  X                   := _X;
  Y                   := _Y;
  S                   := _S;
  Start               := _Start;
  Move(AtariSeg,TIA_Regs,SizeOf(TIA_Regs));

  { Load locations here }

  Asm
    JMP   @Fill
@FillStart:
    DW    OFFSET L00
    DW    OFFSET L01
    DW    OFFSET L02
    DW    OFFSET L03
    DW    OFFSET L04
    DW    OFFSET L05
    DW    OFFSET L06
    DW    OFFSET L07
    DW    OFFSET L08
    DW    OFFSET L09
    DW    OFFSET L0A
    DW    OFFSET L0B
    DW    OFFSET L0C
    DW    OFFSET L0D
    DW    OFFSET L0E
    DW    OFFSET L0F

    DW    OFFSET L10
    DW    OFFSET L11
    DW    OFFSET DoNothing
    DW    OFFSET L13
    DW    OFFSET L14
    DW    OFFSET L15
    DW    OFFSET L16
    DW    OFFSET L17
    DW    OFFSET L18
    DW    OFFSET L19
    DW    OFFSET DoNothing
    DW    OFFSET L1B
    DW    OFFSET L1C
    DW    OFFSET L1D
    DW    OFFSET L1E
    DW    OFFSET L1F

    DW    OFFSET L20
    DW    OFFSET L21
    DW    OFFSET DoNothing
    DW    OFFSET L23
    DW    OFFSET L24
    DW    OFFSET L25
    DW    OFFSET L26
    DW    OFFSET L27
    DW    OFFSET L28
    DW    OFFSET L29
    DW    OFFSET L2A
    DW    OFFSET L2B
    DW    OFFSET L2C
    DW    OFFSET L2D
    DW    OFFSET L2E
    DW    OFFSET L2F

    DW    OFFSET L30
    DW    OFFSET L31
    DW    OFFSET DoNothing
    DW    OFFSET L33
    DW    OFFSET L34
    DW    OFFSET L35
    DW    OFFSET L36
    DW    OFFSET L37
    DW    OFFSET L38
    DW    OFFSET L39
    DW    OFFSET DoNothing
    DW    OFFSET L3B
    DW    OFFSET L3C
    DW    OFFSET L3D
    DW    OFFSET L3E
    DW    OFFSET L3F

    DW    OFFSET L40
    DW    OFFSET L41
    DW    OFFSET DoNothing
    DW    OFFSET L43
    DW    OFFSET L44
    DW    OFFSET L45
    DW    OFFSET L46
    DW    OFFSET L47
    DW    OFFSET L48
    DW    OFFSET L49
    DW    OFFSET L4A
    DW    OFFSET L4B
    DW    OFFSET L4C
    DW    OFFSET L4D
    DW    OFFSET L4E
    DW    OFFSET L4F

    DW    OFFSET L50
    DW    OFFSET L51
    DW    OFFSET DoNothing
    DW    OFFSET L53
    DW    OFFSET L54
    DW    OFFSET L55
    DW    OFFSET L56
    DW    OFFSET L57
    DW    OFFSET L58
    DW    OFFSET L59
    DW    OFFSET DoNothing
    DW    OFFSET L5B
    DW    OFFSET L5C
    DW    OFFSET L5D
    DW    OFFSET L5E
    DW    OFFSET L5F

    DW    OFFSET L60
    DW    OFFSET L61
    DW    OFFSET DoNothing
    DW    OFFSET L63
    DW    OFFSET L64
    DW    OFFSET L65
    DW    OFFSET L66
    DW    OFFSET L67
    DW    OFFSET L68
    DW    OFFSET L69
    DW    OFFSET L6A
    DW    OFFSET L6B
    DW    OFFSET L6C
    DW    OFFSET L6D
    DW    OFFSET L6E
    DW    OFFSET L6F

    DW    OFFSET L70
    DW    OFFSET L71
    DW    OFFSET DoNothing
    DW    OFFSET L73
    DW    OFFSET L74
    DW    OFFSET L75
    DW    OFFSET L76
    DW    OFFSET L77
    DW    OFFSET L78
    DW    OFFSET L79
    DW    OFFSET DoNothing
    DW    OFFSET L7B
    DW    OFFSET L7C
    DW    OFFSET L7D
    DW    OFFSET L7E
    DW    OFFSET L7F

    DW    OFFSET L80
    DW    OFFSET L81
    DW    OFFSET L82
    DW    OFFSET L83
    DW    OFFSET L84
    DW    OFFSET L85
    DW    OFFSET L86
    DW    OFFSET L87
    DW    OFFSET L88
    DW    OFFSET DoNothing
    DW    OFFSET L8A
    DW    OFFSET L8B
    DW    OFFSET L8C
    DW    OFFSET L8D
    DW    OFFSET L8E
    DW    OFFSET L8F

    DW    OFFSET L90
    DW    OFFSET L91
    DW    OFFSET DoNothing
    DW    OFFSET L93
    DW    OFFSET L94
    DW    OFFSET L95
    DW    OFFSET L96
    DW    OFFSET L97
    DW    OFFSET L98
    DW    OFFSET L99
    DW    OFFSET L9A
    DW    OFFSET L9B
    DW    OFFSET L9C
    DW    OFFSET L9D
    DW    OFFSET L9E
    DW    OFFSET L9F

    DW    OFFSET LA0
    DW    OFFSET LA1
    DW    OFFSET LA2
    DW    OFFSET LA3
    DW    OFFSET LA4
    DW    OFFSET LA5
    DW    OFFSET LA6
    DW    OFFSET LA7
    DW    OFFSET LA8
    DW    OFFSET LA9
    DW    OFFSET LAA
    DW    OFFSET LAB
    DW    OFFSET LAC
    DW    OFFSET LAD
    DW    OFFSET LAE
    DW    OFFSET LAF

    DW    OFFSET LB0
    DW    OFFSET LB1
    DW    OFFSET DoNothing
    DW    OFFSET LB3
    DW    OFFSET LB4
    DW    OFFSET LB5
    DW    OFFSET LB6
    DW    OFFSET LB7
    DW    OFFSET LB8
    DW    OFFSET LB9
    DW    OFFSET LBA
    DW    OFFSET LBB
    DW    OFFSET LBC
    DW    OFFSET LBD
    DW    OFFSET LBE
    DW    OFFSET LBF

    DW    OFFSET LC0
    DW    OFFSET LC1
    DW    OFFSET LC2
    DW    OFFSET LC3
    DW    OFFSET LC4
    DW    OFFSET LC5
    DW    OFFSET LC6
    DW    OFFSET LC7
    DW    OFFSET LC8
    DW    OFFSET LC9
    DW    OFFSET LCA
    DW    OFFSET LCB
    DW    OFFSET LCC
    DW    OFFSET LCD
    DW    OFFSET LCE
    DW    OFFSET LCF

    DW    OFFSET LD0
    DW    OFFSET LD1
    DW    OFFSET DoNothing
    DW    OFFSET LD3
    DW    OFFSET LD4
    DW    OFFSET LD5
    DW    OFFSET LD6
    DW    OFFSET LD7
    DW    OFFSET LD8
    DW    OFFSET LD9
    DW    OFFSET DoNothing
    DW    OFFSET LDB
    DW    OFFSET LDC
    DW    OFFSET LDD
    DW    OFFSET LDE
    DW    OFFSET LDF

    DW    OFFSET LE0
    DW    OFFSET LE1
    DW    OFFSET LE2
    DW    OFFSET LE3
    DW    OFFSET LE4
    DW    OFFSET LE5
    DW    OFFSET LE6
    DW    OFFSET LE7
    DW    OFFSET LE8
    DW    OFFSET LE9
    DW    OFFSET DoNothing
    DW    OFFSET LEB
    DW    OFFSET LEC
    DW    OFFSET LED
    DW    OFFSET LEE
    DW    OFFSET LEF

    DW    OFFSET LF0
    DW    OFFSET LF1
    DW    OFFSET DoNothing
    DW    OFFSET LF3
    DW    OFFSET LF4
    DW    OFFSET LF5
    DW    OFFSET LF6
    DW    OFFSET LF7
    DW    OFFSET LF8
    DW    OFFSET LF9
    DW    OFFSET DoNothing
    DW    OFFSET LFB
    DW    OFFSET LFC
    DW    OFFSET LFD
    DW    OFFSET LFE
    DW    OFFSET LFF
@Fill:
    MOV   CX,100h
    SUB   BX,BX
    MOV   SI,OFFSET @FillStart
    CLD
@FillLoop:
    MOV   AX,WORD PTR CS:[SI]
    MOV   WORD PTR Locations[BX],AX
    ADD   SI,2
    ADD   BX,2
    LOOP  @FillLoop
    MOV   DI,WORD PTR Start
    ADD   DI,OFFSET AtariSeg
    MOV   AL,BYTE PTR X
    MOV   AH,BYTE PTR Y
    MOV   CL,BYTE PTR A
    MOV   CH,BYTE PTR P
    MOV   DH,BYTE PTR S
    DEC   DI
DoNothing:
    INC   DI
EmulateLoop:
    DEC   WORD PTR ReadTime
    JNZ   NoReadTime
    PUSH  AX
    PUSH  DX
    PUSH  CX
    PUSH  DI
    CALL  Handle_Input
    MOV   WORD PTR ReadTime,Read_Delay
@CheckEsc:
    TEST  BYTE PTR Key[kESC],0FFh
    JZ    BackToLoop
    POP   DI
    POP   CX
    POP   DX
    POP   AX
    JMP   L02
{
    MOV   BYTE PTR X,AL
    MOV   BYTE PTR Y,AH
    MOV   BYTE PTR A,CL
    MOV   BYTE PTR P,CH
    MOV   BYTE PTR S,DH
    SUB   DI,OFFSET AtariSeg
    MOV   WORD PTR Start,DI}
  End; { Asm }
{  _P     := P;
  _A     := A;
  _X     := X;
  _Y     := Y;
  _S     := S;
  _Start := Start;
  Exit;}
BackToLoop:

  Asm
    MOV   AL,BYTE PTR AtariSeg[SWCHA1]
    MOV   BYTE PTR AtariSeg[SWCHA2],AL
    MOV   AL,BYTE PTR AtariSeg[SWCHB1]
    MOV   BYTE PTR AtariSeg[SWCHB2],AL
    POP   DI
    POP   CX
    POP   DX
    POP   AX
NoReadTime:


(*
    CMP   WORD PTR TimerInterval,0
    JE    @GetOut
    MOV   BX,WORD PTR AddCycle
    TEST  BYTE PTR TimerDone,0FFh
    JNZ   @LTimerDone
    MOV   SI,WORD PTR TimerInterval
    ADD   WORD PTR TimerValue,BX
    MOV   BX,WORD PTR TimerValue
    CMP   BX,SI
    JL    @GetOut
    MOV   WORD PTR TimerValue,0
    SUB   BX,SI
    SUB   BYTE PTR AtariSeg[INTTIM1],1
    JC    @Done
    ADD   WORD PTR TimerValue,BX
    JMP   @GetOut
@Done:
    MOV   BYTE PTR TimerDone,1
@LTimerDone:
    SUB   BYTE PTR AtariSeg[INTTIM1],BL
@GetOut:
*)



    { The write cycle is the last of the instruction cycles; add the }
    { instruction cycles first.                                      }

    DB    _32BIT_OPERAND
    MOV   BX,WORD PTR AddCycle
    DB    _32BIT_ADDRESS,8Dh,1Ch,5Bh   { LEA BX,[EBX + EBX * 2] }
    ADD   WORD PTR TIA_Count,BX
(*
    DB    _32BIT_OPERAND
    ADD   WORD PTR CyclesDone,BX  { BH = 0 here }
*)
    { Now handle a write to the TIA }

    TEST  BYTE PTR Write_TIA,0FFh
    JZ    @NoWriteTIA

    { If the write was to WSYNC, then Handle_IO has already properly set }
    { TIA_Count, don't add the instruction time to it.                   }

    CMP   BYTE PTR Write_TIA,2
    JNE   @NotWSYNC
    SUB   WORD PTR TIA_Count,BX
@NotWSYNC:
    PUSH  AX
    PUSH  DX
    PUSH  CX
    PUSH  DI



    MOV   BX,WORD PTR Save_BX
    CMP   BX,NUSIZ0
    JB    @AddDelay
    CMP   BX,NUSIZ1
    JA    @AddDelay
    TEST  WORD PTR DoHMOVE,0FFh
    JZ    @AddDelay
    CMP   WORD PTR TIA_Count,8
    JGE   @AddDelay
    SUB   BX,BX
@AddDelay:
    ADD   BX,BX
    MOV   BX,WORD PTR TIA_Delay[BX]

    CMP   BX,4
    JNE   @No
{    MOV   SI,WORD PTR TIA_Count
    AND   SI,3
    SUB   BX,SI}
    SUB   BX,WORD PTR TIA_Count
    DEC   BX
    AND   BX,3

    MOV   BL,BYTE PTR PFDelay[BX]

{    INC   BX


    CMP   BX,1
    JNE   @No
    MOV   BX,5}

@No:

    MOV   SI,WORD PTR TIA_Count
    ADD   WORD PTR TIA_Count,BX
    PUSH  SI
    CALL  Handle_TIA
    POP   SI
    MOV   WORD PTR TIA_Count,SI


{    MOV   WORD PTR Old_TIA_Count,SI}
{    SUB   WORD PTR TIA_Count,BX}
{
    CMP   BX,GRP0
    JB    @NormalTIA
    CMP   BX,GRP1
    JA    @NormalTIA
    INC   WORD PTR TIA_Count
    CALL  Handle_TIA
    DEC   WORD PTR TIA_Count
    JMP   @Continue
@NormalTIA:
    CALL  Handle_TIA
@Continue:
}
    MOV   BX,WORD PTR Save_BX
    MOV   AL,BYTE PTR AtariSeg[BX]
    MOV   BYTE PTR TIA_Regs[BX],AL
    CALL  Handle_IO_After
    POP   DI
    POP   CX
    POP   DX
    POP   AX

    { See if an object's position has been reset }

    TEST  WORD PTR ObjectSet,0FFh
    JZ    @L1
    MOV   SI,WORD PTR TIA_Count
{    CMP   SI,4
    JNE   @NoExtraAdd}
    TEST  BYTE PTR OldDoHMOVE,0FFh
    JZ    @NoExtraAdd

    MOV   BX,SI
    ADD   BX,BX
    ADD   SI,WORD PTR ExtraAdd[BX + 68 * 2]
{    ADD   SI,ExtraAdd}
    MOV   BYTE PTR OldDoHMOVE,0
@NoExtraAdd:
    ADD   SI,SetLocDelay         { Delay when setting object positions }
    MOV   BX,WORD PTR ObjectSet
    CMP   BX,Player1Set
    JA    @NotPlayerSet
    INC   SI
@NotPlayerSet:

    { If the object was placed in a negative x position, force it to zero. }

{    CMP   SI,160
    JB    @SignOk
    SUB   SI,SI
@SignOk:
}
{
    CMP   BX,Player1Set
    JA    @NotPlayer1SetA
    MOV   WORD PTR GRP0Write[BX + _Base - 2],SI
@NotPlayer1SetA:
}
    PUSH  AX

    TEST  BX,Player0Set
    JZ    @NotP0Set
{    MOV   WORD PTR ObjectLoc[Player0Set * 2],SI}

    MOV   AX,SI
    ADD   AX,WORD PTR ResetOffset[0]
    CMP   AX,160
    JB    @SignOk1
    SUB   AX,AX
{    MOV   AX,-8}

@SignOk1:
    MOV   WORD PTR ObjectLoc[Player0Set * 2],AX
    MOV   AX,WORD PTR OldPlayer0Size128
    ADD   AX,WORD PTR ResetPlayer0Size128
    MOV   WORD PTR Player0Size128,AX

    CALL  ResetMissile0

@NotP0Set:
    TEST  BX,Player1Set
    JZ    @NotP1Set
{    MOV   WORD PTR ObjectLoc[Player1Set * 2],SI}

    MOV   AX,SI
    ADD   AX,WORD PTR ResetOffset[2]
    CMP   AX,160
    JB    @SignOk2
    SUB   AX,AX
{    MOV   AX,-8}

@SignOk2:
    MOV   WORD PTR ObjectLoc[Player1Set * 2],AX
    MOV   AX,WORD PTR OldPlayer1Size128
    ADD   AX,WORD PTR ResetPlayer1Size128
    MOV   WORD PTR Player1Size128,AX

    CALL  ResetMissile1

@NotP1Set:
    TEST  BX,Missile0Set
    JZ    @NotM0Set
{    MOV   WORD PTR ObjectLoc[Missile0Set * 2],SI}

    MOV   AX,SI
    ADD   AX,WORD PTR ResetOffset[4]
    CMP   AX,160
    JB    @SignOk3
{    SUB   AX,AX}
{    CMP   AX,-68
    JGE   @SignOk3
    MOV   AX,-68}


{    MOV   AX,WORD PTR Missile0Size
    SHR   AX,1}

    TEST  BYTE PTR DoHMOVE,0FFh
    JNZ   @Hide0
    SUB   AX,AX
    JMP   @SignOk3
@Hide0:
    MOV   AX,WORD PTR AtariSeg[NUSIZ0]
    SHR   AX,4
    AND   AX,3
    CMP   AX,3
    JE    @SetM0
    SUB   AX,AX
@SetM0:
    NEG   AX
    SUB   AX,6



    {WORD PTR Missile0Size}
{    NEG   AX}

@SignOk3:
    MOV   WORD PTR ObjectLoc[Missile0Set * 2],AX

@NotM0Set:
    TEST  BX,Missile1Set
    JZ    @NotM1Set
{    MOV   WORD PTR ObjectLoc[Missile1Set * 2],SI}

    MOV   AX,SI
    ADD   AX,WORD PTR ResetOffset[6]
    CMP   AX,160
    JB    @SignOk4
{    SUB   AX,AX}
{    CMP   AX,-68
    JGE   @SignOk4
    MOV   AX,-68}

{    MOV   AX,WORD PTR Missile1Size
    SHR   AX,1}

    TEST  BYTE PTR DoHMOVE,0FFh
    JNZ   @Hide1
    SUB   AX,AX
    JMP   @SignOk4
@Hide1:
    MOV   AX,WORD PTR AtariSeg[NUSIZ1]
    SHR   AX,4
    AND   AX,3
    CMP   AX,3
    JE    @SetM1
    SUB   AX,AX
@SetM1:
    NEG   AX
    SUB   AX,6

    {WORD PTR Missile1Size}
{    NEG   AX}

@SignOk4:
    MOV   WORD PTR ObjectLoc[Missile1Set * 2],AX

@NotM1Set:
    TEST  BX,BallSet
    JZ    @NotBLSet
{    MOV   WORD PTR ObjectLoc[BallSet * 2],SI}

    MOV   AX,SI
    ADD   AX,WORD PTR ResetOffset[8]
    CMP   AX,160
    JB    @SignOk5
{    SUB   AX,AX}

{    MOV   AX,WORD PTR AtariSeg[CTRLPF]
    SHR   AX,4
    AND   AX,3
    NEG   AX
    SUB   AX,6}

    MOV   AX,WORD PTR AtariSeg[CTRLPF]
    SHR   AX,4
    AND   AX,3
    CMP   AX,3
    JE    @SetBL
    SUB   AX,AX
@SetBL:
    NEG   AX
    SUB   AX,2{6}


@SignOk5:
    MOV   WORD PTR ObjectLoc[BallSet * 2],AX

@NotBLSet:

{
    DB    _32BIT_OPERAND
    SUB   AX,AX
    DB    _32BIT_OPERAND
    MOV   WORD PTR ResetOffset[0],AX
    DB    _32BIT_OPERAND
    MOV   WORD PTR ResetOffset[4],AX
    MOV   WORD PTR ResetOffset[8],AX
}
    POP   AX

{
    ADD   BX,BX
    MOV   WORD PTR ObjectLoc[BX],SI
}
    MOV   WORD PTR ObjectSet,0
@L1:
    { If the write was to WSYNC, then the delay time has already been     }
    { figured into the correct TIA_Count.  Don't subtract the delay time. }

    CMP   BYTE PTR Write_TIA,2
    JE    @WSYNC
@WSYNC:
    MOV   BYTE PTR Write_TIA,0
@NoWriteTIA:

    MOV   WORD PTR ResetOfs,0

    CMP   BYTE PTR Controller,crPaddle
    JNE   @NoPaddle

    TEST  BYTE PTR AtariSeg[VBLANK],80h
    JNZ   @NoPaddle

    CALL  SetPaddlePositions


@NoPaddle:

    { Get the next instruction here to avoid a Pentium AGI }
    { (Address Generation Interlock)                       }

    MOV   SI,WORD PTR [DI]   {U}
    MOV   BX,160             {V}   { This sets BH to ZERO (IMPORTANT!) }
    AND   SI,0FFh            {U}

    { Check to see if we've reached the end of the scan line }

    CMP   WORD PTR TIA_Count,BX         {U}
    JL    @NoNewLine                           {V}
{@DoHalt:}





    CMP   WORD PTR Old_TIA_Count,BX
    JL    @NoOldAdjust
    MOV   WORD PTR Old_TIA_Count,BX
@NoOldAdjust:

    MOV   BL,BYTE PTR DoHMOVE
    MOV   BYTE PTR OldDoHMOVE,BL

    ADD   WORD PTR TimerElapsed,76
    ADC   WORD PTR TimerElapsed[2],0
    DB    _32BIT_OPERAND
    MOV   BX,WORD PTR TimerX
    DB    _32BIT_OPERAND
    ADD   WORD PTR TimerElapsed,BX
    DB    _32BIT_OPERAND
    SUB   BX,BX
    DB    _32BIT_OPERAND
    MOV   WORD PTR TimerX,BX


    DB    _32BIT_OPERAND
    MOV   BX,228
    DW    0
    DB    _32BIT_OPERAND
    ADD   WORD PTR CyclesDone,BX
    PUSH  AX
    PUSH  DX
    PUSH  CX
    PUSH  DI
    PUSH  SI
    PUSH  DI
    CALL  Handle_TIA
    POP   DI

    MOV   BX,WORD PTR OldPlayer0Size128
    MOV   WORD PTR Player0Size128,BX
    MOV   BX,WORD PTR OldPlayer1Size128
    MOV   WORD PTR Player1Size128,BX

    MOV   BX,WORD PTR TIA_Scan         { Ensure that BH = 0! }
    CMP   BX,WORD PTR MaxScan{222}
    JGE   @DoneLines
    INC   BX
@DoneLines:

    { If a player object was reset and this caused the first copy }
    { to disappear, cause the copy to reappear                    }

    CMP   WORD PTR ResetPlayer0Size128,0
    JE    @CheckResetP1
    MOV   AX,WORD PTR OldPlayer0Size128
    MOV   WORD PTR Player0Size128,AX
@CheckResetP1:
    CMP   WORD PTR ResetPlayer1Size128,0
    JE    @CheckResetDone
    MOV   AX,WORD PTR OldPlayer1Size128
    MOV   WORD PTR Player1Size128,AX
@CheckResetDone:
    MOV   WORD PTR ResetPlayer0Size128,0
    MOV   WORD PTR ResetPlayer1Size128,0

    { See if the debugger is set to halt at this scan line }

    TEST  BYTE PTR Debugger,0FFh
    JZ    @NoHalt
    CMP   BX,WORD PTR HaltLine
    JNE   @NoHalt
    POP   SI
    MOV   AX,SI
    MOV   BYTE PTR OldByte,AL
    MOV   BYTE PTR [DI],BreakInstruction
    MOV   SI,BreakInstruction
    PUSH  SI
    MOV   AX,DI
    SUB   AX,OFFSET AtariSeg
    MOV   WORD PTR OldStart,AX
@NoHalt:


    CMP   BX,WORD PTR MaxRows{200}
    JAE   @Negative
{$IFDEF LOWRES}
    MOV   AX,BX
    SHL   AX,5
    PUSH  BX
    SHL   BX,7
    ADD   AX,BX
    POP   BX
{$ELSE}
    MOV   AX,BX
    SHL   AX,6
    ADD   AH,BL
{$ENDIF}
    MOV   WORD PTR Addr,AX
    MOV   WORD PTR LineStart,AX
{    MOV   BYTE PTR DoHMOVE,0}
@Negative:
(*
    PUSH  BX
  MOV   AL,BYTE PTR AtariSeg[CTRLPF]
  MOV   BYTE PTR TIA_Regs[CTRLPF],AL
  MOV   BYTE PTR _CTRLPF,AL
  MOV   AL,BYTE PTR TIA_Regs[CTRLPF]
  MOV   SI,AX
  SHR   SI,4
  AND   SI,3
  MOV   CL,BYTE PTR MissileSize[SI]
  SUB   CH,CH
  MOV   WORD PTR BallSize,CX

  MOV   DX,CX
  DEC   DX
  SHR   DX,1
  MOV   WORD PTR BallAdjust,DX

  SUB   CX,160
  MOV   WORD PTR BallSize160,CX
  MOV   CX,WORD PTR ColorLum[0]
  MOV   DX,WORD PTR ColorLum[2]
  MOV   BX,WORD PTR ColorLum[4]
  TEST  AL,2
  JZ    @LCPF1
  MOV   WORD PTR CLW,CX
  MOV   WORD PTR CLW[2],CX
  MOV   WORD PTR CRW,DX
  MOV   WORD PTR CRW[2],DX
  JMP   @LCPF2
@LCPF1:
  MOV   WORD PTR CLW,BX
  MOV   WORD PTR CLW[2],BX
  MOV   WORD PTR CRW,BX
  MOV   WORD PTR CRW[2],BX
@LCPF2:
    POP   BX
*)
(*
    MOV   AL,BYTE PTR GRP0Latch
    MOV   BYTE PTR AtariSeg[GRP0],AL
    AND   BYTE PTR DispJump,0DFh
    TEST  AL,0FFh
    JZ    @LGRP0A
    OR    BYTE PTR DispJump,20h
@LGRP0A:

    MOV   AL,BYTE PTR GRP1Latch
    MOV   BYTE PTR AtariSeg[GRP1],AL
    AND   BYTE PTR DispJump,0F7h
    TEST  AL,0FFh
    JZ    @LGRP1A
    OR    BYTE PTR DispJump,8
@LGRP1A:
*)
    MOV   AL,BYTE PTR BallLatch
    MOV   BYTE PTR AtariSeg[ENABL],AL
    AND   BYTE PTR DispJump,0FDh
    TEST  AL,2
    JZ    @LVDELBL
    OR    BYTE PTR DispJump,2h
@LVDELBL:


    MOV   AX,WORD PTR AtariSeg[GRP0]
    MOV   WORD PTR TIA_Regs[GRP0],AX

    SUB   WORD PTR TIA_Count,228
{    SUB   WORD PTR Old_TIA_Count,228}
    MOV   WORD PTR Old_TIA_Count,-68
{
    JL    @DoneLines
    MOV   BX,-41
    MOV   WORD PTR Addr,0
@DoneLines:
    INC   BX
}
{
    CMP   BX,200
    JAE   @Negative
    MOV   AX,BX
    SHL   AX,6
    ADD   AH,BL
    MOV   WORD PTR Addr,AX
@Negative:
}
{
    CMP   BX,200
    JGE   @DoneLines
    INC   BX
@DoneLines:
    OR    BX,BX
    JS    @Negative
    MOV   AX,BX
    SHL   AX,6
    ADD   AH,BL
    MOV   WORD PTR Addr,AX
@Negative:
}
    POP   SI
    POP   DI
    POP   CX
    POP   DX
    POP   AX
    MOV   WORD PTR TIA_Scan,BX                              {U}
{    OR    BX,BX
    JNS   @Positive}
    SUB   BH,BH                                                    {V}
{@Positive:}
    AND   BYTE PTR DispJump,0FDh      { Turn ball off }     {U}
    TEST  BYTE PTR AtariSeg[ENABL],2                                       {U}
    JZ    @NoNewLine                                               {V}
    OR    BYTE PTR DispJump,2         { Display the ball }  {U}
@NoNewLine:


(*
    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI

    PUSH  WORD PTR ASeg[2]
    PUSH  WORD PTR ASeg[0]
    PUSH  DS
    PUSH  OFFSET BankSwitch
    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    PUSH  WORD PTR TIA_Scan
    CALL  LogInstruction

    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX
*)





    MOV   DL,BYTE PTR Cycles[SI]                                   {U}
    ADD   SI,SI                                                    {V}
    MOV   BYTE PTR AddCycle,DL                              {U}
    JMP   WORD PTR Locations[SI]                           {U}
  End; { Asm }

{ --------------------------- Assembly emulator --------------------------- }

L00:                 { BRK }

  Asm
    DEC    DH
    MOV    BL,DH
{    MOV    BH,1}            { A 6502 would have this, but not an Atari }

    ADD    DI,2
{
    PUSH   AX
    SUB    DI,OFFSET AtariSeg
    MOV    AX,DI
    MOV    BYTE PTR AtariSeg[BX],AL
    INC    BL
    MOV    BYTE PTR AtariSeg[BX],AH
    DEC    BL
    ADD    DI,OFFSET AtariSeg
    POP    AX
}
    SUB    DI,OFFSET AtariSeg

    PUSH   DI
    AND    WORD PTR Hi3,0E000h
    OR     DI,WORD PTR Hi3
    MOV    WORD PTR AtariSeg[BX],DI
    POP    DI

    ADD    DI,OFFSET AtariSeg


    MOV    WORD PTR ResetOfs,-12

    INC    BL
    PUSH   BX
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
    POP    BX
    DEC    BL

    PUSH   BX
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
    POP    BX

    DEC    BL
    MOV    BYTE PTR AtariSeg[BX],CH

    PUSH   BX
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
    POP    BX

    SUB    DH,2
    OR     CH,014h
    MOV    DI,WORD PTR AtariSeg[1FFEh]        { 6502: [0FFFEh] }

    MOV    WORD PTR Hi3,DI

    AND    DI,01FFFh         { Atari can only address 8K }
    ADD    DI,OFFSET AtariSeg
    JMP    EmulateLoop
  End; { Asm }

L01:                 { ORA ind. x }

 Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,07Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    OR     CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    OR     CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L02:                 { Breakpoint instruction }

  Asm
    MOV   BYTE PTR X,AL
    MOV   BYTE PTR Y,AH
    MOV   BYTE PTR A,CL
    MOV   BYTE PTR P,CH
    MOV   BYTE PTR S,DH
    SUB   DI,OFFSET AtariSeg
    MOV   WORD PTR Start,DI
    JMP   GetOut
{    INC    DI
    JMP    EmulateLoop}
  End; { Asm }

L03:                 { SLO ind. x - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }
    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,07Ch
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2
    OR     CH,1
  @L2:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2a
    OR     CH,1
  @L2a:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L04:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L05:                 { ORA zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    AND    CH,07Dh

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    OR     CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    OR     CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L06:                 { ASL zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    OR     CH,3

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX

    MOV    DL,BYTE PTR Input_Byte[BX]
    SHL    DL,1

    JC     @L2A
    AND    CH,0FEh
  @L2A:
    OR     DL,DL
    JZ     @L1A
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1A:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop

@NotCrit:
    OR     CH,3
    SHL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L07:                 { SLO zero page - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,07Ch
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2
    OR     CH,1
  @L2:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2a
    OR     CH,1
  @L2a:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L08:                 { PHP }

  Asm
    MOV    BL,DH
{    MOV    BH,1}

    TEST   BYTE PTR BankSwitch[BX + 100h],0FFh
    JZ     @NoSwitch
    ADD    BX,100h
    CALL   SwitchBank
    SUB    BX,100h
@NoSwitch:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],CH
    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    DEC    DH
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L09:                 { ORA immediate }

  Asm
    OR     CL,BYTE PTR [DI+1]
    JZ     @L1
    MOV    DL,CL
    AND    CH,7Dh
    AND    DL,80h
    ADD    DI,2
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    OR     CH,02h
    JMP    EmulateLoop
  End; { Asm }

L0A:                 { ASL accum. }

  Asm
    OR     CH,3
    ADD    CL,CL
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    CH,7Dh
    AND    DL,80h
    INC    DI
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L0B:                 { ANC immediate - UNDOCUMENTED }

  Asm
    AND    CL,BYTE PTR [DI+1]
    JZ     @L1
    MOV    DL,CL
    AND    CH,7Dh
    AND    DL,80h
    ADD    DI,2
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    OR     CH,02h
    JMP    EmulateLoop
  End; { Asm }

L0C:                 { SKW Quasi-Opcode }

  Asm
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L0D:                { ORA absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    OR     CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    OR     CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L0E:                 { ASL absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }


    CMP    BX,1000h
    JB     @NotROM

    CMP    BYTE PTR Cart,ctStarpath
    JE     @NotROM
    TEST   BYTE PTR BankSwitch[BX],0FFh
    JNZ    @NotROM
    ADD    DI,3
    JMP    EmulateLoop
@NotROM:

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    OR     CH,3
    SHL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L0F:                 { SLO absolute - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,07Ch
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2
    OR     CH,1
  @L2:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2a
    OR     CH,1
  @L2a:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L10:                 { BPL }

  Asm
    TEST   CH,80h
    JNZ    @L1
    DB     0Fh,0BEh,05Dh,01h    { MOVSX BX,BYTE PTR [DI+1] }
    ADD    DI,2
    PUSH   AX
    SUB    DI,OFFSET AtariSeg
    MOV    AX,DI
    ADD    DI,BX
    INC    WORD PTR AddCycle
    MOV    BX,DI
    ADD    DI,OFFSET AtariSeg
    CMP    BH,AH
    JE     @L2
    INC    WORD PTR AddCycle
  @L2:
    POP    AX
    JMP    EmulateLoop
  @L1:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L11:                 { ORA ind. y }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
{    ADC    BH,0}
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    OR     CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    OR     CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L12:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L13:                 { SLO ind. y - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    MOV    BL,BYTE PTR [DI+1]
    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,07Ch
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2
    OR     CH,1
  @L2:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2a
    OR     CH,1
  @L2a:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L14:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L15:                 { ORA z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    OR     CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    OR     CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L16:                 { ASL z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    OR     CH,3
    SHL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L17:                 { SLO z. page x - UNDOCUMENTED }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    MOV    BL,BYTE PTR [DI+1]
    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,07Ch
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2
    OR     CH,1
  @L2:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2a
    OR     CH,1
  @L2a:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L18:                 { CLC }

  Asm
    AND    CH,0FEh
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L19:                 { ORA abs. y }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    OR     CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    OR     CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L1A:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L1B:                 { SLO abs. y - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    CMP    BX,1000h
    JB     @NotROM

    CMP    BYTE PTR Cart,ctStarpath
    JE     @NotROM
    TEST   BYTE PTR BankSwitch[BX],0FFh
    JNZ    @NotROM
    ADD    DI,3
    JMP    EmulateLoop
@NotROM:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,07Ch
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2
    OR     CH,1
  @L2:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2a
    OR     CH,1
  @L2a:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L1C:                 { SKW Quasi-Opcode }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BYTE PTR AddCycle,DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L1D:                 { ORA abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    OR     CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    OR     CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L1E:                 { ASL abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    CMP    BX,1000h
    JB     @NotROM
    CMP    BYTE PTR Cart,ctStarpath
    JE     @NotROM
    TEST   BYTE PTR BankSwitch[BX],0FFh
    JNZ    @NotROM

    OR     CH,3
    MOV    DL,BYTE PTR AtariSeg[BX]
    SHL    DL,1
    JMP    @L3

{    ADD    DI,3
    JMP    EmulateLoop}
@NotROM:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    OR     CH,3
    SHL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L3:
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L1F:                 { SLO abs. x - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,07Ch
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2
    OR     CH,1
  @L2:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2a
    OR     CH,1
  @L2a:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L20:                 { JSR }

  Asm
    DEC    DH
    MOV    BL,DH
{    MOV    BH,1}
    SUB    DI,OFFSET AtariSeg

    PUSH   DI
    AND    WORD PTR Hi3,0E000h
    OR     DI,WORD PTR Hi3
    MOV    WORD PTR AtariSeg[BX],DI
    POP    DI

    ADD    DI,OFFSET AtariSeg
    ADD    WORD PTR AtariSeg[BX],2
    DEC    DH

    MOV    DI,WORD PTR [DI+1]

    MOV    WORD PTR Hi3,DI

{    AND    DI,1FFFh}          { Atari can only address 8K }
(*
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }
    PUSH   BX
    SUB    BH,BH
    MOV    BL,DH
    INC    BL
*)
    TEST   BYTE PTR BankSwitch[BX + 100h],0FFh
    JZ     @NoActivision
    CMP    BYTE PTR Cart,ctPitfall2
    JNE    @NoPitfall2
    XOR    DI,2000h        { Pitfall II bankswitching is reversed }
@NoPitfall2:
    TEST   DI,2000h
    JZ     @Act1
    CMP    BYTE PTR CurrentBank,0
    JNE    @Act1a
    MOV    BYTE PTR BankSwitch[BX + 100h],1     { Already at 1 }
    JMP    @Act2
@Act1A:
    MOV    BYTE PTR BankSwitch[BX + 100h],31    { Switching to 1 }
    JMP    @Act2

@Act1:
    CMP    BYTE PTR CurrentBank,4
    JNE    @Act2a
    MOV    BYTE PTR BankSwitch[BX + 100h],5     { Already at 2 }
    JMP    @Act2
@Act2a:
    MOV    BYTE PTR BankSwitch[BX + 100h],30    { Switching to 2 }
@Act2:
    ADD    BX,100h
    ADD    DI,OFFSET AtariSeg
    CALL   SwitchBank
    SUB    DI,OFFSET AtariSeg
    SUB    BX,100h
@NoActivision:



    AND    DI,1FFFh          { Atari can only address 8K }
    ADD    DI,OFFSET AtariSeg
    JMP    EmulateLoop
  End; { Asm }

L21:                 { AND ind. x }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    AND    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    AND    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End;{ Asm }

L22:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L23:                 { RLA ind. x - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX

    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L24:                 { BIT zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    BL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    MOV    DL,BL
    AND    DL,CL
    JZ     @L1
    AND    CH,3Dh
    AND    BL,0C0h
    OR     CH,BL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    BL,BYTE PTR AtariSeg[BX]
    MOV    DL,BL
    AND    DL,CL
    JZ     @L1
    AND    CH,3Dh
    AND    BL,0C0h
    OR     CH,BL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    AND    CH,3Fh
    AND    BL,0C0h
    OR     CH,BL
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L25:                 { AND zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    AND    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    AND    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L26:                 { ROL zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L27:                 { RLA zero page - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L28:                 { PLP }

  Asm
    INC    DH
    MOV    BL,DH
{    MOV    BH,1}

    TEST   BYTE PTR BankSwitch[BX + 100h],0FFh
    JZ     @NoSwitch
    ADD    BX,100h
    CALL   SwitchBank
    SUB    BX,100h
@NoSwitch:

    MOV    CH,BYTE PTR AtariSeg[BX]



    OR     CH,20h



    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L29:                 { AND immediate }

  Asm
    AND    CL,BYTE PTR [DI+1]
    JZ     @L1
    MOV    DL,CL
    AND    CH,7Dh
    AND    DL,80h
    ADD    DI,2
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    OR     CH,02h
    JMP    EmulateLoop
  End; { Asm }

L2A:                 { ROL accum. }

  Asm
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    CL,1
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    CH,7Dh
    AND    DL,80h
    INC    DI
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L2B:                 { ANC immediate - UNDOCUMENTED }

  Asm
    AND    CL,BYTE PTR [DI+1]
    JZ     @L1
    MOV    DL,CL
    AND    CH,7Dh
    AND    DL,80h
    ADD    DI,2
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    OR     CH,02h
    JMP    EmulateLoop
  End; { Asm }

L2C:                 { BIT absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    BL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    MOV    DL,BL
    AND    DL,CL
    JZ     @L1
    AND    CH,3Dh
    AND    BL,0C0h
    OR     CH,BL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    BL,BYTE PTR AtariSeg[BX]
    MOV    DL,BL
    AND    DL,CL
    JZ     @L1
    AND    CH,3Dh
    AND    BL,0C0h
    OR     CH,BL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    AND    CH,3Fh
    AND    BL,0C0h
    OR     CH,BL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L2D:                 { AND absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    AND    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    AND    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L2E:                 { ROL absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L2F:                 { RLA absolute - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L30:                 { BMI }

  Asm
    TEST   CH,80h
    JZ     @L1
    DB     0Fh,0BEh,05Dh,01h    { MOVSX BX,BYTE PTR [DI+1] }
    ADD    DI,2
{    ADD    DI,BX
    INC    WORD PTR AddCycle}
    PUSH   AX
    SUB    DI,OFFSET AtariSeg
    MOV    AX,DI
    ADD    DI,BX
    INC    WORD PTR AddCycle
    MOV    BX,DI
    ADD    DI,OFFSET AtariSeg
    CMP    BH,AH
    JE     @L2
    INC    WORD PTR AddCycle
  @L2:
    POP    AX
    JMP    EmulateLoop
  @L1:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L31:                 { AND ind. y }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    AND    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    AND    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L32:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L33:                 { RLA ind. y - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX

    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:

    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L34:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L35:                 { AND z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    AND    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    AND    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L36:                 { ROL z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:

    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L37:                 { RLA z. page x - UNDOCUMENTED }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:

    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L38:                 { SEC }

  Asm
    OR     CH,01h
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L39:                 { AND abs. y }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    AND    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    AND    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L3A:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L3B:                 { RLA abs. y - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX

    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:

    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L3C:                 { SKW Quasi-Opcode }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BYTE PTR AddCycle,DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L3D:                 { AND abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    AND    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    AND    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L3E:                 { ROL abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L3F:                 { RLA abs. x - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L40:                 { RTI }

  Asm
    INC    DH
    MOV    BL,DH
{    MOV    BH,1}
    MOV    CH,BYTE PTR AtariSeg[BX]


    OR     CH,20h



    INC    BL
    MOV    DI,WORD PTR AtariSeg[BX]

    MOV    WORD PTR Hi3,DI

    AND    DI,01FFFh         { Atari can only address 8K }
    ADD    DI,OFFSET AtariSeg
    ADD    DH,2
    JMP    EmulateLoop
  End; { Asm }

L41:                 { EOR ind. x }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    XOR    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    XOR    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L42:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L43:                 { SRE ind. x - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:
    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    XOR    CL,DL
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L44:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L45:                 { EOR zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,07Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    XOR    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    XOR    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L46:                 { LSR zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L47:                 { SRE zero page - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    XOR    CL,DL
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L48:                 { PHA }

  Asm
    MOV    BL,DH
{    MOV    BH,1}

    TEST   BYTE PTR BankSwitch[BX + 100h],0FFh
    JZ     @NoSwitch
    ADD    BX,100h
    CALL   SwitchBank
    SUB    BX,100h
@NoSwitch:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],CL
    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    DEC    DH
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L49:                 { EOR immediate }

  Asm
    XOR    CL,BYTE PTR [DI+1]
    JZ     @L1
    MOV    DL,CL
    AND    CH,7Dh
    AND    DL,80h
    ADD    DI,2
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    OR     CH,02h
    JMP    EmulateLoop
  End; { Asm }

L4A:                 { LSR accum. }

  Asm
    OR     CH,3
    SHR    CL,1
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    INC    DI
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L4B:                 { ASR immediate - UNDOCUMENTED }

  Asm
    XOR    CL,BYTE PTR [DI+1]
    OR     CH,3
    SHR    CL,1
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    CH,7Dh
    AND    DL,80h
    ADD    DI,2
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    OR     CH,02h
    JMP    EmulateLoop
  End; { Asm }

L4C:                 { JMP absolute }

  Asm
    MOV    DI,WORD PTR [DI+1]

    MOV    WORD PTR Hi3,DI

    AND    DI,1FFFh          { Atari can only address 8K }
    ADD    DI,OFFSET AtariSeg
    JMP    EmulateLoop
  End; { Asm }

L4D:                 { EOR absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    XOR    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    XOR    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L4E:                 { LSR absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    CMP    BX,1000h
    JB     @NotROM
    CMP    BYTE PTR Cart,ctStarpath
    JE     @NotROM
    TEST   BYTE PTR BankSwitch[BX],0FFh
    JNZ    @NotROM

    OR     CH,3
    MOV    DL,BYTE PTR AtariSeg[BX]
    SHR    DL,1
    JMP    @L3

{    ADD    DI,3
    JMP    EmulateLoop}
@NotROM:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
@L3:
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L4F:                 { SRE absolute - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    XOR    CL,DL
    MOV    Dl,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L50:                 { BVC }

  Asm
    TEST   CH,040h
    JNZ    @L1
    DB     0Fh,0BEh,05Dh,01h    { MOVSX BX,BYTE PTR [DI+1] }
    ADD    DI,2
{    ADD    DI,BX
    INC    WORD PTR AddCycle}
    PUSH   AX
    SUB    DI,OFFSET AtariSeg
    MOV    AX,DI
    ADD    DI,BX
    INC    WORD PTR AddCycle
    MOV    BX,DI
    ADD    DI,OFFSET AtariSeg
    CMP    BH,AH
    JE     @L2
    INC    WORD PTR AddCycle
  @L2:
    POP    AX
    JMP    EmulateLoop
  @L1:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L51:                 { EOR ind. y }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    XOR    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    XOR    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L52:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L53:                 { SRE ind. y - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:
    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    XOR    CL,DL
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L54:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L55:                 { EOR z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    XOR    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    XOR    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L56:                 { LSR z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L57:                 { SRE z. page x - UNDOCUMENTED }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    XOR    CL,DL
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L58:                 { CLI }

  Asm
    AND    CH,0FBh
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L59:                 { EOR abs. y }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    XOR    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    XOR    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L5A:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L5B:                 { SRE abs. y - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    XOR    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L5C:                 { SKW Quasi-Opcode }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BYTE PTR AddCycle,DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L5D:                 { EOR abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    XOR    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    XOR    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L5E:                 { LSR abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L5F:                 { SRE abs. x - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    XOR    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L60:                 { RTS }

  Asm
    MOV    SI,DI

    INC    DH
    MOV    BL,DH
{    MOV    BH,1}



{    TEST   BYTE PTR BankSwitch[BX + 100h],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:
    TEST   BYTE PTR BankSwitch[BX + 101h],0FFh
    JZ     @NoSwitch1
    INC    BX
    CALL   SwitchBank
    DEC    BX
@NoSwitch1:}

    MOV    DI,WORD PTR AtariSeg[BX]
    INC    DI

    MOV    WORD PTR Hi3,DI

    AND    DI,01FFFh         { Atari can only address 8K }
    ADD    DI,OFFSET AtariSeg
{
    CMP    DI,103Fh
    JA     @NoSwitch1
}
    TEST   BYTE PTR BankSwitch[BX + 100h],0FFh
    JZ     @NoSwitch
    ADD    BX,100h
    PUSH   SI
    CALL   SwitchBank
    POP    SI
    SUB    BX,100h
@NoSwitch:
    TEST   BYTE PTR BankSwitch[BX + 101h],0FFh
    JZ     @NoSwitch1
    ADD    BX,101h
    PUSH   SI
    CALL   SwitchBank
    POP    SI
    SUB    BX,101h
@NoSwitch1:
    INC    DH


    CMP    BYTE PTR Cart,ctStarpath
    JNE    @NotStarpath
    CMP    SI,(OFFSET AtariSeg) + 1FF8h
    JNE    @NotStarpath
    CALL   HandleStarpathRTS
@NotStarpath:


    JMP    EmulateLoop
  End; { Asm }

L61:                 { ADC ind. x }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    ADC    CL,BYTE PTR Input_Byte[BX]
    PUSHF
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    POPF
    ADC    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Input_Byte[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR Input_Byte[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6a
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR AtariSeg[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L62:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L63:                 { RRA ind. x - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    MOV    SI,BX
    MOV    BL,DL
    RCR    DL,1
    MOV    BH,BL                 { Set the overflow flag  }
    XOR    BH,DL                 { V=(New OR Old) AND 40h }
    AND    BH,40h
    AND    CH,0BFh
    OR     CH,BH
    TEST   CH,8                  { See if we're in decimal mode }
    JNZ    @BCD
    ROL    BL,1                  { Set carry flag = (Old AND 80h) }
    AND    BL,1
    AND    CH,0FEh
    OR     CH,BL
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,2
    JMP    EmulateLoop
@BCD:
    MOV    BH,BL                 { BCD fixup 1 }
    AND    BH,0Fh
    CMP    BH,4
    JLE    @BCD1
    MOV    BH,DL
    ADD    BH,6
    AND    BH,0Fh
    AND    DL,0F0h
    OR     DL,BH
@BCD1:
    AND    CH,0FEh
    CMP    BL,4Fh
    JLE    @BCD2
    ADD    DL,60h
    OR     CH,1
@BCD2:
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L64:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L65:                 { ADC zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    ADC    CL,BYTE PTR Input_Byte[BX]
    PUSHF
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    POPF
    ADC    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Input_Byte[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR Input_Byte[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6a
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR AtariSeg[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L66:                 { ROR zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    RCR    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L67:                 { RRA zero page - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    JMP    @L4
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    MOV    SI,BX
    MOV    BL,DL
    RCR    DL,1
    MOV    BH,BL                 { Set the overflow flag  }
    XOR    BH,DL                 { V=(New OR Old) AND 40h }
    AND    BH,40h
    AND    CH,0BFh
    OR     CH,BH
    TEST   CH,8                  { See if we're in decimal mode }
    JNZ    @BCD
    ROL    BL,1                  { Set carry flag = (Old AND 80h) }
    AND    BL,1
    AND    CH,0FEh
    OR     CH,BL
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,2
    JMP    EmulateLoop
@BCD:
    MOV    BH,BL                 { BCD fixup 1 }
    AND    BH,0Fh
    CMP    BH,4
    JLE    @BCD1
    MOV    BH,DL
    ADD    BH,6
    AND    BH,0Fh
    AND    DL,0F0h
    OR     DL,BH
@BCD1:
    AND    CH,0FEh
    CMP    BL,4Fh
    JLE    @BCD2
    ADD    DL,60h
    OR     CH,1
@BCD2:
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L68:                 { PLA }

  Asm
    INC    DH
    AND    CH,7Dh
    MOV    BL,DH
{    MOV    BH,1}

    TEST   BYTE PTR BankSwitch[BX + 100h],0FFh
    JZ     @NoSwitch
    ADD    BX,100h
    CALL   SwitchBank
    SUB    BX,100h
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    INC    DI
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    INC    DI
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L69:                 { ADC immediate }

  Asm
    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    OR     CH,3
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    ADC    CL,BYTE PTR [DI+1]
    PUSHF
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }

    MOV    DL,BYTE PTR [DI+1]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR [DI+1]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L6A:                 { ROR accum. }

  Asm
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCR    CL,1
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    CH,7Dh
    AND    DL,80h
    INC    DI
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L6B:                 { ARR immediate - UNDOCUMENTED }

  Asm
    TEST   CH,8
    JNZ    @BCD
    AND    CH,3Ch
    AND    CL,BYTE PTR [DI+1]
    RCR    CL,1
    TEST   CL,CL     { Set the zero flag }
    JNZ    @L1
    OR     CH,2
@L1:
    MOV    DL,CL     { Set the negative flag }
    AND    DL,80h
    OR     CH,DL
    MOV    DL,CL     { Set the carry flag }
    SHR    DL,6
    AND    DL,1
    OR     CH,DL
    MOV    DL,CL     { Set the overflow flag }
    SHL    DL,1
    XOR    DL,CL
    AND    DL,40h
    OR     CH,DL
    INC    DI
    JMP    EmulateLoop
@BCD:
    AND    CH,3Ch
    MOV    DL,CL
    AND    DL,BYTE PTR [DI+1]
    MOV    BL,CH     { Set the negative flag }
    ROR    BL,1
    AND    BL,80h
    OR     CH,BL
    MOV    BH,DL     { Set the zero flag -- note that it's reversed }
    SHR    BH,1
    OR     BH,BL
    MOV    CL,BH
    TEST   CL,CL
    JZ     @L2
    OR     CH,2
@L2:
    MOV    BL,DL     { Set the overflow flag }
    XOR    BL,CL
    AND    BL,40h
    OR     CH,BL

    MOV    BH,CL     { BCD fixup 1 -- low nibble }
    MOV    BL,CL
    AND    BX,0F01h
    ADD    BL,BH
    CMP    BL,5
    JLE    @L3
    AND    CL,0F0h
    ADD    BH,6
    AND    BH,0Fh
    OR     CL,BH
@L3:
    MOV    BH,CL     { BCD fixup 2 -- high nibble }
    MOV    BL,CL
    AND    BX,0F010h
    ADD    BL,BH
    CMP    BL,50h
    JLE    @L4
    OR     CH,1
    ADD    CL,60h
@L4:
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L6C:                 { JMP indirect }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh              { Atari can only address 8K }
    CMP    BX,200h
    JAE    @NoChop
    SUB    BH,BH
@NoChop:
    MOV    DL,BYTE PTR AtariSeg[BX]
    INC    BL
    MOV    BH,BYTE PTR AtariSeg[BX]
    MOV    BL,DL
    MOV    DI,BX

    MOV    WORD PTR Hi3,DI

    AND    DI,1FFFh              { Atari can only address 8K }
    ADD    DI,OFFSET AtariSeg
    JMP    EmulateLoop
  End; { Asm }

L6D:                 { ADC absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    ADC    CL,BYTE PTR Input_Byte[BX]
    PUSHF
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    POPF
    ADC    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Input_Byte[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR Input_Byte[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6a
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR AtariSeg[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L6E:                 { ROR absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    RCR    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
    CMP    BX,SWCHB1
    JNE    @L3
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCR    DL,1
    JMP    @L4
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L6F:                 { RRA absolute - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    MOV    SI,BX
    MOV    BL,DL
    RCR    DL,1
    MOV    BH,BL                 { Set the overflow flag  }
    XOR    BH,DL                 { V=(New OR Old) AND 40h }
    AND    BH,40h
    AND    CH,0BFh
    OR     CH,BH
    TEST   CH,8                  { See if we're in decimal mode }
    JNZ    @BCD
    ROL    BL,1                  { Set carry flag = (Old AND 80h) }
    AND    BL,1
    AND    CH,0FEh
    OR     CH,BL
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,3
    JMP    EmulateLoop
@BCD:
    MOV    BH,BL                 { BCD fixup 1 }
    AND    BH,0Fh
    CMP    BH,4
    JLE    @BCD1
    MOV    BH,DL
    ADD    BH,6
    AND    BH,0Fh
    AND    DL,0F0h
    OR     DL,BH
@BCD1:
    AND    CH,0FEh
    CMP    BL,4Fh
    JLE    @BCD2
    ADD    DL,60h
    OR     CH,1
@BCD2:
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L70:                 { BVS }

  Asm
    TEST   CH,40h
    JZ     @L1
    DB     0Fh,0BEh,05Dh,01h    { MOVSX BX,BYTE PTR [DI+1] }
    ADD    DI,2
{    ADD    DI,BX
    INC    WORD PTR AddCycle}
    PUSH   AX
    SUB    DI,OFFSET AtariSeg
    MOV    AX,DI
    ADD    DI,BX
    INC    WORD PTR AddCycle
    MOV    BX,DI
    ADD    DI,OFFSET AtariSeg
    CMP    BH,AH
    JE     @L2
    INC    WORD PTR AddCycle
  @L2:
    POP    AX
    JMP    EmulateLoop
  @L1:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L71:                 { ADC ind. y }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    ADC    CL,BYTE PTR Input_Byte[BX]
    PUSHF
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    POPF
    ADC    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Input_Byte[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR Input_Byte[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6a
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR AtariSeg[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L72:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L73:                 { RRA ind. y - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    MOV    SI,BX
    MOV    BL,DL
    RCR    DL,1
    MOV    BH,BL                 { Set the overflow flag  }
    XOR    BH,DL                 { V=(New OR Old) AND 40h }
    AND    BH,40h
    AND    CH,0BFh
    OR     CH,BH
    TEST   CH,8                  { See if we're in decimal mode }
    JNZ    @BCD
    ROL    BL,1                  { Set carry flag = (Old AND 80h) }
    AND    BL,1
    AND    CH,0FEh
    OR     CH,BL
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,2
    JMP    EmulateLoop
@BCD:
    MOV    BH,BL                 { BCD fixup 1 }
    AND    BH,0Fh
    CMP    BH,4
    JLE    @BCD1
    MOV    BH,DL
    ADD    BH,6
    AND    BH,0Fh
    AND    DL,0F0h
    OR     DL,BH
@BCD1:
    AND    CH,0FEh
    CMP    BL,4Fh
    JLE    @BCD2
    ADD    DL,60h
    OR     CH,1
@BCD2:
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L74:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L75:                 { ADC z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    ADC    CL,BYTE PTR Input_Byte[BX]
    PUSHF
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    POPF
    ADC    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Input_Byte[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR Input_Byte[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6a
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR AtariSeg[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L76:                 { ROR z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    RCR    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L77:                 { RRA z. page x - UNDOCUMENTED }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    JMP    @L4
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    MOV    SI,BX
    MOV    BL,DL
    RCR    DL,1
    MOV    BH,BL                 { Set the overflow flag  }
    XOR    BH,DL                 { V=(New OR Old) AND 40h }
    AND    BH,40h
    AND    CH,0BFh
    OR     CH,BH
    TEST   CH,8                  { See if we're in decimal mode }
    JNZ    @BCD
    ROL    BL,1                  { Set carry flag = (Old AND 80h) }
    AND    BL,1
    AND    CH,0FEh
    OR     CH,BL
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,2
    JMP    EmulateLoop
@BCD:
    MOV    BH,BL                 { BCD fixup 1 }
    AND    BH,0Fh
    CMP    BH,4
    JLE    @BCD1
    MOV    BH,DL
    ADD    BH,6
    AND    BH,0Fh
    AND    DL,0F0h
    OR     DL,BH
@BCD1:
    AND    CH,0FEh
    CMP    BL,4Fh
    JLE    @BCD2
    ADD    DL,60h
    OR     CH,1
@BCD2:
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L78:                 { SEI }

  Asm
    OR     CH,04h
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L79:                 { ADC abs. y }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    ADC    CL,BYTE PTR Input_Byte[BX]
    PUSHF
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    POPF
    ADC    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Input_Byte[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR Input_Byte[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6a
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR AtariSeg[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L7A:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L7B:                 { RRA abs. y - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    MOV    SI,BX
    MOV    BL,DL
    RCR    DL,1
    MOV    BH,BL                 { Set the overflow flag  }
    XOR    BH,DL                 { V=(New OR Old) AND 40h }
    AND    BH,40h
    AND    CH,0BFh
    OR     CH,BH
    TEST   CH,8                  { See if we're in decimal mode }
    JNZ    @BCD
    ROL    BL,1                  { Set carry flag = (Old AND 80h) }
    AND    BL,1
    AND    CH,0FEh
    OR     CH,BL
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,3
    JMP    EmulateLoop
@BCD:
    MOV    BH,BL                 { BCD fixup 1 }
    AND    BH,0Fh
    CMP    BH,4
    JLE    @BCD1
    MOV    BH,DL
    ADD    BH,6
    AND    BH,0Fh
    AND    DL,0F0h
    OR     DL,BH
@BCD1:
    AND    CH,0FEh
    CMP    BL,4Fh
    JLE    @BCD2
    ADD    DL,60h
    OR     CH,1
@BCD2:
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }


L7C:                 { SKW Quasi-Opcode }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BYTE PTR AddCycle,DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L7D:                 { ADC abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    ADC    CL,BYTE PTR Input_Byte[BX]
    PUSHF
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    POPF
    ADC    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Input_Byte[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR Input_Byte[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6a
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR AtariSeg[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L7E:                 { ROR abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    RCR    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L7F:                 { RRA abs. x - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    MOV    SI,BX
    MOV    BL,DL
    RCR    DL,1
    MOV    BH,BL                 { Set the overflow flag  }
    XOR    BH,DL                 { V=(New OR Old) AND 40h }
    AND    BH,40h
    AND    CH,0BFh
    OR     CH,BH
    TEST   CH,8                  { See if we're in decimal mode }
    JNZ    @BCD
    ROL    BL,1                  { Set carry flag = (Old AND 80h) }
    AND    BL,1
    AND    CH,0FEh
    OR     CH,BL
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,3
    JMP    EmulateLoop
@BCD:
    MOV    BH,BL                 { BCD fixup 1 }
    AND    BH,0Fh
    CMP    BH,4
    JLE    @BCD1
    MOV    BH,DL
    ADD    BH,6
    AND    BH,0Fh
    AND    DL,0F0h
    OR     DL,BH
@BCD1:
    AND    CH,0FEh
    CMP    BL,4Fh
    JLE    @BCD2
    ADD    DL,60h
    OR     CH,1
@BCD2:
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L80:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L81:                 { STA ind. x }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh        { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    JMP    @NotTimer
@NotTIA:
    CMP    BX,400h
    JAE    @NotTimer
    CMP    BX,200h
    JB     @NotTimer
    AND    BX,29Fh
    OR     BL,80h
    MOV    BL,BYTE PTR Timer_And[BX - 280h];
@NotTimer:

    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L82:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L83:                 { SAX ind. x - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh        { Atari can only address 8K }
    MOV    DL,CL
    AND    DL,AL

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],DL

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L84:                 { STY zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    CMP    BX,02Ch
    JA     @NotCrit
    MOV    BYTE PTR AtariSeg[BX],AH

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    BYTE PTR AtariSeg[BX],AH

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch1
    CALL   SwitchBank
@NoSwitch1:

    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L85:                 { STA zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    CMP    BX,02Ch
    JA     @NotCrit
    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch1
    CALL   SwitchBank
@NoSwitch1:

    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L86:                 { STX zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    CMP    BX,02Ch
    JA     @NotCrit
    MOV    BYTE PTR AtariSeg[BX],AL

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    BYTE PTR AtariSeg[BX],AL

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch1
    CALL   SwitchBank
@NoSwitch1:

    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L87:                 { SAX zero page - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    DL,CL
    AND    DL,AL
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    CMP    BX,02Ch
    JA     @NotCrit
    MOV    BYTE PTR AtariSeg[BX],DL

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    BYTE PTR AtariSeg[BX],DL

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch1
    CALL   SwitchBank
@NoSwitch1:

    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L88:                 { DEY }

  Asm
    DEC    AH
    JZ     @L1
    MOV    DL,AH
    AND    CH,7Dh
    AND    DL,80h
    INC    DI
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    INC    DI
    OR     CH,2
    JMP    EmulateLoop
  End; { Asm }

L89:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L8A:                 { TXA }

  Asm
    MOV    CL,AL
    OR     BH,AL   { BH = 0 at start }
    JZ     @L1
    AND    BH,80h
    AND    CH,7Dh
    ADD    CH,BH
    INC    DI
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    INC    DI
    OR     CH,2
    JMP    EmulateLoop
  End; { Asm }

L8B:                 { ANE immediate - UNDOCUMENTED }

  Asm
    OR     CL,0EEh
    AND    CL,AL
    AND    CL,BYTE PTR [DI+1]
    AND    CH,7Dh
    OR     BH,CL
    JZ     @L1
    AND    BH,80h
    ADD    DI,2
    ADD    CH,BH
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L8C:                 { STY absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    CMP    BX,400h
    JAE    @NotTimer
    CMP    BX,200h
    JB     @NotTimer
    AND    BX,29Fh
    OR     BL,80h
    MOV    BL,BYTE PTR Timer_And[BX - 280h];
@NotTimer:
    MOV    BYTE PTR AtariSeg[BX],AH

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L8D:                 { STA absolute }
  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    JMP    @NotTimer
@NotTIA:
    CMP    BX,400h
    JAE    @NotTimer
    CMP    BX,200h
    JB     @NotTimer
    AND    BX,29Fh
    OR     BL,80h
    MOV    BL,BYTE PTR Timer_And[BX - 280h];
@NotTimer:

    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L8E:                 { STX absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    CMP    BX,400h
    JAE    @NotTimer
    CMP    BX,200h
    JB     @NotTimer
    AND    BX,29Fh
    OR     BL,80h
    MOV    BL,BYTE PTR Timer_And[BX - 280h];
@NotTimer:
    MOV    BYTE PTR AtariSeg[BX],AL

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L8F:                 { SAX absolute - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }
    MOV    DL,CL
    AND    DL,AL

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],DL

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L90:                 { BCC }

  Asm
    TEST   CH,01
    JNZ    @L1
    DB     0Fh,0BEh,05Dh,01h    { MOVSX BX,BYTE PTR [DI+1] }
    ADD    DI,2
{    ADD    DI,BX
    INC    WORD PTR AddCycle}
    PUSH   AX
    SUB    DI,OFFSET AtariSeg
    MOV    AX,DI
    ADD    DI,BX
    INC    WORD PTR AddCycle
    MOV    BX,DI
    ADD    DI,OFFSET AtariSeg
    CMP    BH,AH
    JE     @L2
    INC    WORD PTR AddCycle
  @L2:
    POP    AX
    JMP    EmulateLoop
  @L1:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L91:                 { STA ind. y }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
{    ADC    BH,0}
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    JMP    @NotTimer
@NotTIA:
    CMP    BX,400h
    JAE    @NotTimer
    CMP    BX,200h
    JB     @NotTimer
    AND    BX,29Fh
    OR     BL,80h
    MOV    BL,BYTE PTR Timer_And[BX - 280h];
@NotTimer:

    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L92:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L93:                 { SHA ind. y - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    MOV    DL,BH
    INC    DL
    AND    DL,AL
    AND    DL,CL
    JNC    @L1
    INC    BYTE PTR AddCycle
    MOV    BH,DL
@L1:
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L94:                 { STY z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],AH
    CMP    BX,02Ch
    JA     @NotCrit
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L95:                 { STA z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],CL
    CMP    BX,02Ch
    JA     @NotCrit
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L96:                 { STX z. page y }

  Asm
    MOV    BL,AH
    ADD    BL,BYTE PTR [DI+1]
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],AL
    CMP    BX,02Ch
    JA     @NotCrit
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L97:                 { SAX z. page y - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AH
    MOV    DL,CL
    AND    DL,AL
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    CMP    BX,02Ch
    JA     @NotCrit
    MOV    BYTE PTR AtariSeg[BX],DL
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    BYTE PTR AtariSeg[BX],DL
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L98:                 { TYA }

  Asm
    MOV    CL,AH
    OR     BH,AH   { BH = 0 at start }
    JZ     @L1
    AND    BH,80h
    AND    CH,7Dh
    ADD    CH,BH
    INC    DI
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    INC    DI
    OR     CH,2
    JMP    EmulateLoop
  End; { Asm }

L99:                 { STA abs. y }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    CMP    BX,1000h
    JB     @NotROM
    CMP    BYTE PTR Cart,ctStarpath
    JE     @NotROM
    TEST   BYTE PTR BankSwitch[BX],0FFh
    JNZ    @NotROM
    ADD    DI,3
    JMP    EmulateLoop
@NotROM:

    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    JMP    @NotTimer
@NotTIA:
    CMP    BX,400h
    JAE    @NotTimer
    CMP    BX,200h
    JB     @NotTimer
    AND    BX,29Fh
    OR     BL,80h
    MOV    BL,BYTE PTR Timer_And[BX - 280h];
@NotTimer:

    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L9A:                 { TXS }

  Asm
    MOV    DH,AL
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L9B:                 { SHS ind. y - UNDOCUMENTED }

  Asm
    MOV    DH,AL
    AND    DH,CL
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    MOV    DL,BH
    INC    DL
    AND    DL,DH
    JNC    @L1
    INC    BYTE PTR AddCycle
    MOV    BH,DL
@L1:
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L9C:                 { SHY abs. x - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    MOV    DL,BH
    INC    DL
    AND    DL,AH
    JNC    @L1
    INC    BYTE PTR AddCycle
    MOV    BH,DL
@L1:
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L9D:                 { STA abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    JMP    @NotTimer
@NotTIA:
    CMP    BX,400h
    JAE    @NotTimer
    CMP    BX,200h
    JB     @NotTimer
    AND    BX,29Fh
    OR     BL,80h
    MOV    BL,BYTE PTR Timer_And[BX - 280h];
@NotTimer:

    CMP    BX,1000h
    JB     @NotROM
    CMP    BYTE PTR Cart,ctStarpath
    JE     @NotROM
    TEST   BYTE PTR BankSwitch[BX],0FFh
    JNZ    @NotROM
    ADD    DI,3
    JMP    EmulateLoop
@NotROM:

    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L9E:                 { SHX abs. y - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    MOV    DL,BH
    INC    DL
    AND    DL,AL
    JNC    @L1
    INC    BYTE PTR AddCycle
    MOV    BH,DL
@L1:
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L9F:                 { SHA abs. y - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    MOV    DL,BH
    INC    DL
    AND    DL,AL
    AND    DL,CL
    JNC    @L1
    INC    BYTE PTR AddCycle
    MOV    BH,DL
@L1:
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LA0:                 { LDY immediate }

  Asm
    MOV    AH,BYTE PTR [DI+1]
    AND    CH,7Dh
    OR     BH,AH
    JZ     @L1
    AND    BH,80h
    ADD    DI,2
    ADD    CH,BH
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LA1:                 { LDA ind. x }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LA2:                 { LDX immediate }

  Asm
    MOV    AL,BYTE PTR [DI+1]
    AND    CH,7Dh
    OR     BH,AL
    JZ     @L1
    AND    BH,80h
    ADD    DI,2
    ADD    CH,BH
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LA3:                 { LAX ind. x - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX
    MOV    AL,CL

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LA4:                 { LDY zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    AH,BYTE PTR Input_Byte[BX]

    AND    CH,7Dh
    OR     AH,AH
    JZ     @L1
    MOV    DL,AH
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    AH,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     AH,AH
    JZ     @L1
    MOV    DL,AH
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LA5:                 { LDA zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LA6:                 { LDX zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    AL,BYTE PTR Input_Byte[BX]

    AND    CH,7Dh
    OR     AL,AL
    JZ     @L1
    MOV    DL,AL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    AL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     AL,AL
    JZ     @L1
    MOV    DL,AL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LA7:                 { LAX zero page - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX
    MOV    AL,CL

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LA8:                 { TAY }

  Asm
    MOV    AH,CL
    AND    CH,7Dh
    OR     BH,AH
    JZ     @L1
    AND    BH,80h
    INC    DI
    ADD    CH,BH
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LA9:                 { LDA immediate }

  Asm
    MOV    CL,BYTE PTR [DI+1]
    AND    CH,7Dh
    OR     BH,CL
    JZ     @L1
    AND    BH,80h
    ADD    DI,2
    ADD    CH,BH
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LAA:                 { TAX }

  Asm
    MOV    AL,CL
    AND    CH,7Dh
    OR     BH,AL
    JZ     @L1
    AND    BH,80h
    INC    DI
    ADD    CH,BH
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LAB:                 { LXA immed + a - UNDOCUMENTED }

  Asm
    ADD    CL,BYTE PTR [DI+1]
    MOV    AL,CL
    AND    CH,7Dh
    OR     BH,CL
    JZ     @L1
    AND    BH,80h
    ADD    DI,2
    ADD    CH,BH
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LAC:                 { LDY absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    AH,BYTE PTR Input_Byte[BX]

    AND    CH,7Dh
    OR     AH,AH
    JZ     @L1
    MOV    DL,AH
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    AH,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     AH,AH
    JZ     @L1
    MOV    DL,AH
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LAD:                 { LDA absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LAE:                 { LDX absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    AL,BYTE PTR Input_Byte[BX]

    AND    CH,7Dh
    OR     AL,AL
    JZ     @L1
    MOV    DL,AL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    AL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     AL,AL
    JZ     @L1
    MOV    DL,AL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LAF:                 { LAX absolute - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX
    MOV    AL,CL

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LB0:                 { BCS }

  Asm
    TEST   CH,01
    JZ     @L1
    DB     0Fh,0BEh,05Dh,01h    { MOVSX BX,BYTE PTR [DI+1] }
    ADD    DI,2
{    ADD    DI,BX
    INC    WORD PTR AddCycle}
    PUSH   AX
    SUB    DI,OFFSET AtariSeg
    MOV    AX,DI
    ADD    DI,BX
    INC    WORD PTR AddCycle
    MOV    BX,DI
    ADD    DI,OFFSET AtariSeg
    CMP    BH,AH
    JE     @L2
    INC    WORD PTR AddCycle
  @L2:
    POP    AX
    JMP    EmulateLoop
  @L1:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LB1:                 { LDA ind. y }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    PUSHF
    ADC    BH,0
    POPF
    ADC    WORD PTR AddCycle,0
{    ADC    WORD PTR AddCycle,0
    ADD    BH,BYTE PTR AddCycle}
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LB2:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LB3:                 { LAX ind. y - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    PUSHF
    ADC    BH,0
    POPF
    ADC    WORD PTR AddCycle,0
{    ADC    WORD PTR AddCycle,0
    ADD    BH,BYTE PTR AddCycle}
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX
    MOV    AL,CL

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LB4:                 { LDY z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    AH,BYTE PTR Input_Byte[BX]

    AND    CH,7Dh
    OR     AH,AH
    JZ     @L1
    MOV    DL,AH
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    AH,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     AH,AH
    JZ     @L1
    MOV    DL,AH
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LB5:                 { LDA z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LB6:                 { LDX z. page y }

  Asm
    MOV    BL,AH
    ADD    BL,BYTE PTR [DI+1]
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    AL,BYTE PTR Input_Byte[BX]

    AND    CH,7Dh
    OR     AL,AL
    JZ     @L1
    MOV    DL,AL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    AL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     AL,AL
    JZ     @L1
    MOV    DL,AL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LB7:                 { LAX z. page y - UNDOCUMENTED }

  Asm
    MOV    BL,AH
    ADD    BL,BYTE PTR [DI+1]
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX
    MOV    AL,CL

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LB8:                 { CLV }

  Asm
    AND    CH,0BFh
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LB9:                 { LDA abs. y }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LBA:                 { TSX }

  Asm
    MOV    AL,DH
    AND    CH,7Dh
    OR     BH,AL
    JZ     @L1
    AND    BH,80h
    INC    DI
    ADD    CH,BH
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LBB:                 { LAS (abs. y) and s - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX
    AND    CL,DH
    MOV    AL,CL
    MOV    DH,CL

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LBC:                 { LDY abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    AH,BYTE PTR Input_Byte[BX]

    AND    CH,7Dh
    OR     AH,AH
    JZ     @L1
    MOV    DL,AH
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    AH,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     AH,AH
    JZ     @L1
    MOV    DL,AH
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LBD:                 { LDA abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LBE:                 { LDX abs. y }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    AL,BYTE PTR Input_Byte[BX]

    AND    CH,7Dh
    OR     AL,AL
    JZ     @L1
    MOV    DL,AL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    AL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     AL,AL
    JZ     @L1
    MOV    DL,AL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LBF:                 { LAX abs. y }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX
    MOV    AL,CL

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LC0:                 { CPY immediate }

  Asm
    MOV    DL,AH
    OR     CH,3
    SUB    DL,BYTE PTR [DI+1]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LC1:                 { CMP ind. x }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LC2:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LC3:                 { DCP ind. x - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    DEC    BYTE PTR Input_Byte[BX]
    SUB    DL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    DEC    BYTE PTR AtariSeg[BX]
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LC4:                 { CPY zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,AH
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LC5:                 { CMP zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LC6:                 { DEC zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    PUSH   BX
    AND    BX,0Fh
    MOV    DL,BYTE PTR Input_Byte[BX]
    POP    BX
    DEC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    JMP    @Continue
@NotTIA:
    DEC    BYTE PTR AtariSeg[BX]
@Continue:
    PUSHF
    CMP    BX,02Ch
    JA     @NotCrit
    PUSH   BX
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
    POP    BX
@NotCrit:
    POPF
    JZ     @L1
    MOV    DL,BYTE PTR AtariSeg[BX]
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LC7:                 { DCP zero page - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    DEC    BYTE PTR Input_Byte[BX]
    SUB    DL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    DEC    BYTE PTR AtariSeg[BX]
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LC8:                 { INY }

  Asm
    INC    AH
    JZ     @L1
    MOV    DL,AH
    AND    CH,7Dh
    AND    DL,80h
    INC    DI
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    INC    DI
    OR     CH,2
    JMP    EmulateLoop
  End; { Asm }

LC9:                 { CMP immediate }

  Asm
    MOV    DL,CL
    OR     CH,3
    SUB    DL,BYTE PTR [DI+1]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LCA:                 { DEX }

  Asm
    DEC    AL
    JZ     @L1
    MOV    DL,AL
    AND    CH,7Dh
    AND    DL,80h
    INC    DI
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    INC    DI
    OR     CH,2
    JMP    EmulateLoop
  End; { Asm }

LCB:                 { SBX immediate - UNDOCUMENTED }

  Asm
    MOV    DL,CL
    AND    DL,AL
    OR     CH,3
    SUB    DL,BYTE PTR [DI+1]
    MOV    AL,DL
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LCC:                 { CPY absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,AH
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LCD:                 { CMP absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LCE:                 { DEC absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    PUSH   BX
    AND    BX,0Fh
    MOV    DL,BYTE PTR Input_Byte[BX]
    POP    BX
    DEC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    JMP    @Continue
@NotTIA:
    DEC    BYTE PTR AtariSeg[BX]
@Continue:
    PUSHF
    TEST   BX,0FC00h
    JNZ    @NotCrit
    PUSH   BX
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
    POP    BX
@NotCrit:
    POPF
    JZ     @L1
    MOV    DL,BYTE PTR AtariSeg[BX]
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LCF:                 { DCP absolute - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    DEC    BYTE PTR Input_Byte[BX]
    SUB    DL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    DEC    BYTE PTR AtariSeg[BX]
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LD0:                 { BNE }

  Asm
    TEST   CH,02
    JNZ    @L1
    DB     0Fh,0BEh,05Dh,01h    { MOVSX BX,BYTE PTR [DI+1] }
    ADD    DI,2
{    ADD    DI,BX
    INC    WORD PTR AddCycle}
    PUSH   AX
    SUB    DI,OFFSET AtariSeg
    MOV    AX,DI
    ADD    DI,BX
    INC    WORD PTR AddCycle
    MOV    BX,DI
    ADD    DI,OFFSET AtariSeg
    CMP    BH,AH
    JE     @L2
    INC    WORD PTR AddCycle
  @L2:
    POP    AX
    JMP    EmulateLoop
  @L1:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LD1:                 { CMP ind. y }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    PUSHF
    ADC    BH,0
    POPF
    ADC    WORD PTR AddCycle,0
{    ADC    WORD PTR AddCycle,0
    ADD    BH,BYTE PTR AddCycle}
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LD2:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LD3:                 { DCP ind. y - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    PUSHF
    ADC    BH,0
    POPF
    ADC    WORD PTR AddCycle,0
{    ADC    WORD PTR AddCycle,0
    ADD    BH,BYTE PTR AddCycle}
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    DEC    BYTE PTR Input_Byte[BX]
    SUB    DL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    DEC    BYTE PTR AtariSeg[BX]
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LD4:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LD5:                 { CMP z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LD6:                 { DEC z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    PUSH   BX
    AND    BX,0Fh
    MOV    DL,BYTE PTR Input_Byte[BX]
    POP    BX
    DEC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    JMP    @Continue
@NotTIA:
    DEC    BYTE PTR AtariSeg[BX]
@Continue:
    PUSHF
    CMP    BX,02Ch
    JA     @NotCrit
    PUSH   BX
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
    POP    BX
@NotCrit:
    POPF
    JZ     @L1
    MOV    DL,BYTE PTR AtariSeg[BX]
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LD7:                 { DCP z. page x - UNDOCUMENTED }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    DEC    BYTE PTR Input_Byte[BX]
    SUB    DL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    DEC    BYTE PTR AtariSeg[BX]
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LD8:                 { CLD }

  Asm
    AND    CH,0F7h
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LD9:                 { CMP abs. y }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LDA:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LDB:                 { DCP abs. y - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    DEC    BYTE PTR Input_Byte[BX]
    SUB    DL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    DEC    BYTE PTR AtariSeg[BX]
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LDC:                 { SKW Quasi-Opcode }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BYTE PTR AddCycle,DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LDD:                 { CMP abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LDE:                 { DEC abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    TEST   BX,0FC00h
    JNZ    @NotCrit
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    PUSH   BX
    AND    BX,0Fh
    MOV    DL,BYTE PTR Input_Byte[BX]
    POP    BX
    DEC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    JMP    @Continue
@NotTIA:
    DEC    BYTE PTR AtariSeg[BX]
@Continue:
    JZ     @L1a
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
    MOV    DL,BYTE PTR AtariSeg[BX]
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1a:
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    DEC    BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,BYTE PTR AtariSeg[BX]
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LDF:                 { DCP abs. x - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    DEC    BYTE PTR Input_Byte[BX]
    SUB    DL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    DEC    BYTE PTR AtariSeg[BX]
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LE0:                 { CPX immediate }

  Asm
    MOV    DL,AL
    OR     CH,3
    SUB    DL,BYTE PTR [DI+1]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LE1:                 { SBC ind. x }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    SBB    CL,BYTE PTR Input_Byte[BX]
    PUSHF
    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    POPF
    SBB    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF


    MOV    DL,BYTE PTR Input_Byte[BX]
    CALL   SBC_BCD

(*
    SBB    AL,BYTE PTR Input_Byte[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6a              { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   SBC_BCD

(*
    SBB    AL,BYTE PTR AtariSeg[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6               { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LE2:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LE3:                 { ISB ind. x - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    AND    CH,03Ch         { Turn sign, overflow, and zero bits off }
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    PUSH   AX
    SUB    AX,AX

    MOV    AL,CL
    SUB    AL,DL
    SBB    AH,0
    MOV    BL,CH
    AND    BL,1
    XOR    BL,1
    SUB    AL,BL
    SBB    AH,0
    JNZ    @L1
    OR     CH,2
@L1:
    MOV    BL,AL
    AND    BL,80h
    OR     CH,BL

    MOV    BL,AL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    MOV    BL,DL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    OR     CH,40h
@L2:
    TEST   CH,8
    JZ     @NotBCD

    PUSH   CX
    MOV    BL,CL
    AND    BL,0Fh
    AND    CH,1
    ADD    BL,CH
    MOV    CH,DL
    AND    CH,0Fh
    CMP    BL,CH
    JGE    @L5
    SUB    AX,6
@L5:
    POP    CX
    CMP    AX,99h
    JLE    @NotBCD
    SUB    AX,60h
@NotBCD:
    TEST   AH,AH
    JNZ    @L6
    OR     CH,1
@L6:
    MOV    CL,AL
    POP    AX
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LE4:                 { CPX zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,AL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LE5:                 { SBC zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    SBB    CL,BYTE PTR Input_Byte[BX]
    PUSHF
    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    POPF
    SBB    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Input_Byte[BX]
    CALL   SBC_BCD

(*
    SBB    AL,BYTE PTR Input_Byte[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6a              { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR AtariSeg[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6               { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LE6:                 { INC zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    PUSH   BX
    AND    BX,0Fh
    MOV    DL,BYTE PTR Input_Byte[BX]
    POP    BX
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    JMP    @Continue
@NotTIA:
    INC    BYTE PTR AtariSeg[BX]
@Continue:
    PUSHF
    CMP    BX,02Ch
    JA     @NotCrit
    PUSH   BX
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
    POP    BX
@NotCrit:
    POPF
    JZ     @L1
    MOV    DL,BYTE PTR AtariSeg[BX]
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LE7:                 { ISB zero page - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    AND    CH,03Ch         { Turn sign, overflow, and zero bits off }
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    PUSH   AX
    SUB    AX,AX

    MOV    AL,CL
    SUB    AL,DL
    SBB    AH,0
    MOV    BL,CH
    AND    BL,1
    XOR    BL,1
    SUB    AL,BL
    SBB    AH,0
    JNZ    @L1
    OR     CH,2
@L1:
    MOV    BL,AL
    AND    BL,80h
    OR     CH,BL

    MOV    BL,AL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    MOV    BL,DL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    OR     CH,40h
@L2:
    TEST   CH,8
    JZ     @NotBCD

    PUSH   CX
    MOV    BL,CL
    AND    BL,0Fh
    AND    CH,1
    ADD    BL,CH
    MOV    CH,DL
    AND    CH,0Fh
    CMP    BL,CH
    JGE    @L5
    SUB    AX,6
@L5:
    POP    CX
    CMP    AX,99h
    JLE    @NotBCD
    SUB    AX,60h
@NotBCD:
    TEST   AH,AH
    JNZ    @L6
    OR     CH,1
@L6:
    MOV    CL,AL
    POP    AX
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LE8:                 { INX }

  Asm
    INC    AL
    JZ     @L1
    MOV    DL,AL
    AND    CH,7Dh
    AND    DL,80h
    INC    DI
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    INC    DI
    OR     CH,2
    JMP    EmulateLoop
  End; { Asm }

LE9:                 { SBC immediate }
  Asm
    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    XOR    DL,1
    OR     CH,3
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    SBB    CL,BYTE PTR [DI+1]
    PUSHF
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }

    MOV    DL,BYTE PTR [DI+1]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR [DI+1]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6               { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LEA:                 { NOP }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LEB:                 { SBC immediate - UNDOCUMENTED }

  Asm
    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    XOR    DL,1
    OR     CH,3
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    SBB    CL,BYTE PTR [DI+1]
    PUSHF
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }

    MOV    DL,BYTE PTR [DI+1]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR [DI+1]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6               { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LEC:                 { CPX absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,AL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LED:                 { SBC absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    SBB    CL,BYTE PTR Input_Byte[BX]
    PUSHF
    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    POPF
    SBB    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Input_Byte[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR Input_Byte[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6a              { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR AtariSeg[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6               { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LEE:                 { INC absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    CMP    BX,1000h
    JB     @NotROM
    CMP    BYTE PTR Cart,ctStarpath
    JE     @NotROM
    TEST   BYTE PTR BankSwitch[BX],0FFh
    JNZ    @NotROM
    ADD    DI,3
    JMP    EmulateLoop
@NotROM:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    PUSH   BX
    AND    BX,0Fh
    MOV    DL,BYTE PTR Input_Byte[BX]
    POP    BX
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    JMP    @Continue
@NotTIA:
    INC    BYTE PTR AtariSeg[BX]
@Continue:
    PUSHF
    TEST   BX,0FC00h
    JNZ    @NotCrit
    PUSH   BX
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
    POP    BX
@NotCrit:
    POPF
    JZ     @L1
    MOV    DL,BYTE PTR AtariSeg[BX]
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LEF:                 { ISB absolute - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    AND    CH,03Ch         { Turn sign, overflow, and zero bits off }
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    PUSH   AX
    SUB    AX,AX

    MOV    AL,CL
    SUB    AL,DL
    SBB    AH,0
    MOV    BL,CH
    AND    BL,1
    XOR    BL,1
    SUB    AL,BL
    SBB    AH,0
    JNZ    @L1
    OR     CH,2
@L1:
    MOV    BL,AL
    AND    BL,80h
    OR     CH,BL

    MOV    BL,AL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    MOV    BL,DL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    OR     CH,40h
@L2:
    TEST   CH,8
    JZ     @NotBCD

    PUSH   CX
    MOV    BL,CL
    AND    BL,0Fh
    AND    CH,1
    ADD    BL,CH
    MOV    CH,DL
    AND    CH,0Fh
    CMP    BL,CH
    JGE    @L5
    SUB    AX,6
@L5:
    POP    CX
    CMP    AX,99h
    JLE    @NotBCD
    SUB    AX,60h
@NotBCD:
    TEST   AH,AH
    JNZ    @L6
    OR     CH,1
@L6:
    MOV    CL,AL
    POP    AX
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LF0:                 { BEQ }

  Asm
    TEST   CH,02
    JZ     @L1
    DB     0Fh,0BEh,05Dh,01h    { MOVSX BX,BYTE PTR [DI+1] }
    ADD    DI,2
{    ADD    DI,BX
    INC    WORD PTR AddCycle}
    PUSH   AX
    SUB    DI,OFFSET AtariSeg
    MOV    AX,DI
    ADD    DI,BX
    INC    WORD PTR AddCycle
    MOV    BX,DI
    ADD    DI,OFFSET AtariSeg
    CMP    BH,AH
    JE     @L2
    INC    WORD PTR AddCycle
  @L2:
    POP    AX
    JMP    EmulateLoop
  @L1:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LF1:                 { SBC ind. y }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    PUSHF
    ADC    BH,0
    POPF
    ADC    WORD PTR AddCycle,0
{    ADC    WORD PTR AddCycle,0
    ADD    BH,BYTE PTR AddCycle}
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    SBB    CL,BYTE PTR Input_Byte[BX]
    PUSHF
    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    POPF
    SBB    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Input_Byte[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR Input_Byte[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6a              { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR AtariSeg[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6               { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LF2:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LF3:                 { ISB ind. Y - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    PUSHF
    ADC    BH,0
    POPF
    ADC    WORD PTR AddCycle,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    AND    CH,03Ch         { Turn sign, overflow, and zero bits off }
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    PUSH   AX
    SUB    AX,AX

    MOV    AL,CL
    SUB    AL,DL
    SBB    AH,0
    MOV    BL,CH
    AND    BL,1
    XOR    BL,1
    SUB    AL,BL
    SBB    AH,0
    JNZ    @L1
    OR     CH,2
@L1:
    MOV    BL,AL
    AND    BL,80h
    OR     CH,BL

    MOV    BL,AL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    MOV    BL,DL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    OR     CH,40h
@L2:
    TEST   CH,8
    JZ     @NotBCD

    PUSH   CX
    MOV    BL,CL
    AND    BL,0Fh
    AND    CH,1
    ADD    BL,CH
    MOV    CH,DL
    AND    CH,0Fh
    CMP    BL,CH
    JGE    @L5
    SUB    AX,6
@L5:
    POP    CX
    CMP    AX,99h
    JLE    @NotBCD
    SUB    AX,60h
@NotBCD:
    TEST   AH,AH
    JNZ    @L6
    OR     CH,1
@L6:
    MOV    CL,AL
    POP    AX
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LF4:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LF5:                 { SBC z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    SBB    CL,BYTE PTR Input_Byte[BX]
    PUSHF
    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    POPF
    SBB    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Input_Byte[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR Input_Byte[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6a              { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR AtariSeg[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6               { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LF6:                 { INC z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    PUSH   BX
    AND    BX,0Fh
    MOV    DL,BYTE PTR Input_Byte[BX]
    POP    BX
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    JMP    @Continue
@NotTIA:
    INC    BYTE PTR AtariSeg[BX]
@Continue:
    PUSHF
    CMP    BX,02Ch
    JA     @NotCrit
    PUSH   BX
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
    POP    BX
@NotCrit:
    POPF
    JZ     @L1
    MOV    DL,BYTE PTR AtariSeg[BX]
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LF7:                 { ISB z. page x - UNDOCUMENTED }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    AND    CH,03Ch         { Turn sign, overflow, and zero bits off }
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    PUSH   AX
    SUB    AX,AX

    MOV    AL,CL
    SUB    AL,DL
    SBB    AH,0
    MOV    BL,CH
    AND    BL,1
    XOR    BL,1
    SUB    AL,BL
    SBB    AH,0
    JNZ    @L1
    OR     CH,2
@L1:
    MOV    BL,AL
    AND    BL,80h
    OR     CH,BL

    MOV    BL,AL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    MOV    BL,DL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    OR     CH,40h
@L2:
    TEST   CH,8
    JZ     @NotBCD

    PUSH   CX
    MOV    BL,CL
    AND    BL,0Fh
    AND    CH,1
    ADD    BL,CH
    MOV    CH,DL
    AND    CH,0Fh
    CMP    BL,CH
    JGE    @L5
    SUB    AX,6
@L5:
    POP    CX
    CMP    AX,99h
    JLE    @NotBCD
    SUB    AX,60h
@NotBCD:
    TEST   AH,AH
    JNZ    @L6
    OR     CH,1
@L6:
    MOV    CL,AL
    POP    AX
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LF8:                 { SED }

  Asm
    OR     CH,08h
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LF9:                 { SBC abs. y }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    SBB    CL,BYTE PTR Input_Byte[BX]
    PUSHF
    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    POPF
    SBB    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  @BCD:
{     INC    WORD PTR AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Input_Byte[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR Input_Byte[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6a              { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR AtariSeg[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6               { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LFA:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LFB:                 { ISB abs. y - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    AND    CH,03Ch         { Turn sign, overflow, and zero bits off }
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    PUSH   AX
    SUB    AX,AX

    MOV    AL,CL
    SUB    AL,DL
    SBB    AH,0
    MOV    BL,CH
    AND    BL,1
    XOR    BL,1
    SUB    AL,BL
    SBB    AH,0
    JNZ    @L1
    OR     CH,2
@L1:
    MOV    BL,AL
    AND    BL,80h
    OR     CH,BL

    MOV    BL,AL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    MOV    BL,DL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    OR     CH,40h
@L2:
    TEST   CH,8
    JZ     @NotBCD

    PUSH   CX
    MOV    BL,CL
    AND    BL,0Fh
    AND    CH,1
    ADD    BL,CH
    MOV    CH,DL
    AND    CH,0Fh
    CMP    BL,CH
    JGE    @L5
    SUB    AX,6
@L5:
    POP    CX
    CMP    AX,99h
    JLE    @NotBCD
    SUB    AX,60h
@NotBCD:
    TEST   AH,AH
    JNZ    @L6
    OR     CH,1
@L6:
    MOV    CL,AL
    POP    AX
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LFC:                 { SKW Quasi-Opcode }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BYTE PTR AddCycle,DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LFD:                 { SBC abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    SBB    CL,0
{    PUSHF}
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

{    POPF}
    SUB    CL,BYTE PTR Input_Byte[BX]
    PUSHF
    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
{    POPF}
    SUB    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Input_Byte[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR Input_Byte[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6a              { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR AtariSeg[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6               { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LFE:                 { INC abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    PUSH   BX
    AND    BX,0Fh
    MOV    DL,BYTE PTR Input_Byte[BX]
    POP    BX
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    JMP    @Continue
@NotTIA:
    INC    BYTE PTR AtariSeg[BX]
@Continue:
    PUSHF
    TEST   BX,0FC00h
    JNZ    @NotCrit
    PUSH   BX
    MOV    WORD PTR Save_BX,BX
    CALL   Handle_IO
    POP    BX
@NotCrit:
    POPF
    JZ     @L1
    MOV    DL,BYTE PTR AtariSeg[BX]
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LFF:                 { ISB abs. X - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    AND    CH,03Ch         { Turn sign, overflow, and zero bits off }
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    PUSH   AX
    SUB    AX,AX

    MOV    AL,CL
    SUB    AL,DL
    SBB    AH,0
    MOV    BL,CH
    AND    BL,1
    XOR    BL,1
    SUB    AL,BL
    SBB    AH,0
    JNZ    @L1
    OR     CH,2
@L1:
    MOV    BL,AL
    AND    BL,80h
    OR     CH,BL

    MOV    BL,AL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    MOV    BL,DL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    OR     CH,40h
@L2:
    TEST   CH,8
    JZ     @NotBCD

    PUSH   CX
    MOV    BL,CL
    AND    BL,0Fh
    AND    CH,1
    ADD    BL,CH
    MOV    CH,DL
    AND    CH,0Fh
    CMP    BL,CH
    JGE    @L5
    SUB    AX,6
@L5:
    POP    CX
    CMP    AX,99h
    JLE    @NotBCD
    SUB    AX,60h
@NotBCD:
    TEST   AH,AH
    JNZ    @L6
    OR     CH,1
@L6:
    MOV    CL,AL
    POP    AX
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

(*
LFF:                 { Nothing }

  Asm
    MOV   BYTE PTR X,AL
    MOV   BYTE PTR Y,AH
    MOV   BYTE PTR A,CL
    MOV   BYTE PTR P,CH
    MOV   BYTE PTR S,DH
    SUB   DI,OFFSET AtariSeg
    MOV   WORD PTR Start,DI
  End; { Asm }
*)
GetOut:
  _P     := P;
  _A     := A;
  _X     := X;
  _Y     := Y;
  _S     := S;
  _Start := Start;
End; { Interpret }

(*
Procedure Test;
Var
  I,J,K,L,M                      : Word;
  Iterations                     : Word;
  RR,T,UU,V                      : Real;
  A,X,Y,P,S                      : Byte;
  Clock                          : Boolean;
  Clock_Ticks                    : Integer;
  Number_Bytes                   : Integer;
  Work_Byte                      : Array[1..100] Of Byte;

Begin
  Write('How many bytes for test opcode: ');
  ReadLn(Number_Bytes);
  Write('How many normal clock ticks per iteration: ');
  ReadLn(Clock_Ticks);
  For I := 1 To Number_Bytes Do
  Begin
    Write('Enter test opcode #',I,': ');
    ReadLn(Work_Byte[I]);
  End;
  Iterations := 65530 Div Number_Bytes;
  WriteLn(Iterations,' iterations x ',Passes,' passes.');
  For I := 0 To Iterations - 1 Do
  Begin
    J := I * Number_Bytes;
    If (I And $F) = 0 Then
    Begin
      GotoXY(37,12);
      Write(J);
    End;
    For K := 1 To Number_Bytes Do
     Mem[Lo_Seg:J + K - 1] := Work_Byte[K];
  End; { For I }
  WriteLn;
{  FillChar(C64LoSeg^,-4,Chr(Work_Byte));} { Fill with 10000 NOP's for time test }
  I := Iterations * Number_Bytes;
  Mem[Lo_Seg:I] := BreakInstruction;
  MemW[Lo_Seg:I + 1] := $4350;
  WriteLn('Speed check...');

  Clock := True;   { I am shutting off the clock to achieve speed }

  P := 0;          { set up registers }
  X := 0;
  Y := 0;
  S := 0;
  A := 0;

{  InLine($FA);}                     { CLI }
  RR := Timer;
{  For I := 1 To Passes Do Interpret(0,0,0,0,0,0);}   { (0,P,A,X,Y,S) }

{ ------------------------------------------------------------------------- }

  FillChar(AtariSeg^,SizeOf(AtariSeg^),0);  { Blank area with nulls again }

{ ------------------------------------------------------------------------- }

  UU := Timer;
{  InLine($FB);}                     { STI }

  T := (UU - RR) / (Passes + 1);     { To account for call and loop, }
                                     { add 1 for every 50 passes }
  WriteLn;
  If Clock Then
  Begin
    V := (Clock_Ticks * Iterations) / T;
    Work_Real := (V / 1022727.0) * 100;
    WriteLn('Effective clock speed is ',V:10:2,' Hz.');
    WriteLn('Commodore 64 runs at     1022727    Hz.');
    WriteLn('You are runnning at ',Work_Real:6:2,'% of true speed.');
    WriteLn;
    WriteLn('Elapsed time is ',(UU - RR):6:2,' seconds.');
  End
  Else WriteLn('Clock was shut off.  Rate incalculable.');
  WriteLn;
  { each NOP is 2 clock cycles, so it is 20000 / time taken }
  FillChar(AtariSeg^,SizeOf(AtariSeg^),0);  { Blank area with nulls }
End; { Test }
*)


{$F+}
  Procedure DeAllocSound; Far;
  Begin
    If SBuf[1] <> Nil Then FreeMem(SBuf[1],SoundBufSize + 64);
    If SBuf[0] <> Nil Then FreeMem(SBuf[0],SoundBufSize * 2 + 64);
  End; { DeAlocSound }

  Procedure InitSound; Far;
  Var I,J,FP: LongInt;
  Begin
    TIA_Sound_Init(Sample_Freq,Playback_Freq);
    GetMem(SBuf[0],SoundBufSize * 2 + 64);
    GetMem(SBuf[1],SoundBufSize + 64);
    SoundBuf[0] := SBuf[0];
    SoundBuf[1] := SBuf[1];
    If Ofs(SoundBuf[0]^) <> 0 Then SoundBuf[0] := Ptr(Seg(SoundBuf[0]^) + (Ofs(SoundBuf[0]^) Shr 4) + 1,0);
    If Ofs(SoundBuf[1]^) <> 0 Then SoundBuf[1] := Ptr(Seg(SoundBuf[1]^) + (Ofs(SoundBuf[1]^) Shr 4) + 1,0);
    PhysAddr0 := SegOffToPhys(SoundBuf[0]);
    PhysAddr1 := SegOffToPhys(Ptr(Seg(SoundBuf[0]^),Ofs(SoundBuf[0]^) + SoundBufSize));
    FillChar(SoundBuf[0]^,SoundBufSize * 2,#0);
    FillChar(SoundBuf[1]^,SoundBufSize,#0);
    If XMS.Init Then
    Begin
      Config.DoSound := False;
      Exit;
    End;
    If XMS.GetFreeXM(TotalFree,LargestFree) Then
    Begin
      Config.DoSound := False;
      Exit;
    End;
    If Handle.AllocXM(32 * 16 * 4) Then
    Begin
      Config.DoSound := False;
      Exit;
    End;
    LockXMS := Not Handle.LockXM(PhysAddr);
    Update_TIA_Sound(AUDV0,15);
    For I := 0 To 15 Do
    Begin
      Update_TIA_Sound(AUDC0,I);
      For J := 0 To 31 Do
      Begin
        Update_TIA_Sound(AUDF0,J);
        ProcessSound(SoundBuf[0],SoundBufSize);
{        TIA_Process1(SoundBuf[0],SoundBufSize);}
        FP := (I * 32 + J) * SoundBufSize;
        If LockXMS Then XMS.RawMove(PhysAddr + FP,SegOffToPhys(SoundBuf[0]),Even(SoundBufSize)) Else
        Begin
          MovePacket.Length     := SoundBufSize;
          MovePacket.srcHandle  := 0;
          MovePacket.srcOffset  := DWord(SoundBuf[0]);
          MovePacket.destHandle := Handle.Handle;
          MovePacket.destOffset := FP;
          XMS.MoveXM(MovePacket);
        End;
      End; { For J }
    End; { For I }
    Update_TIA_Sound(AUDV0,0);
    Update_TIA_Sound(AUDC0,0);
    Update_TIA_Sound(AUDF0,0);
    FillChar(SoundBuf[0]^,SoundBufSize * 2,#0);
    FillChar(SoundBuf[1]^,SoundBufSize,#0);
  End; { InitSound }
{$F-}

Procedure Emulate;
{Type
  RGB = Record
    R,G,B: Byte;
  End;}

Var
  F         : File;
{  TextFile  : Text;}
{  Pal       : Array[0..127] Of RGB;}
  I,J       : Word;
  B1,B2     : Word;
  St        : String[80];
  St1       : String[80];
  Start     : Word;
  T1,T2     : Real;
  P,A,X,Y,S : Byte;
  Buffer    : Pointer;
  Loaded    : LongInt;
  FP        : LongInt;
  WorkCh    : Char;
  Blaster   : String;
  _SHL      : LongInt;
  _SHR      : LongInt;
  Param     : String[80];
  K         : Integer;
(*
  Procedure Disassemble;
  Var
    I,J     : LongInt;{Word;}
    Start   : Word;
    Listing : Text;
    Opcode  : Byte;
    DBStart : Word;
    B       : Byte;
    OTyp    : String[3];
    Bank    : Word;
    OldASeg : Pointer;
    BAddr   : Word;
    NewBank : Word;

    Function TransWordWrite(Addr: Word): String;
    Begin
      If (Addr < $80) Or ((Addr >= $100) And (Addr < $180)) Then Addr := Addr And $3F;
      Case Addr Of
        0..$2C: TransWordWrite := TIA_Name[Addr];
{    $280..$297: TransWordWrite := PIA_Name[Addr];
    $380..$397: TransWordWrite := PIA_Name[Addr - $100];}
    $200..$3FF: TransWordWrite := PIA_Name[$200 Or Timer_And[Addr And $1F]];
      Else TransWordWrite := HexWord(Addr);
      End; { Case }
    End; { TransWordWrite }


    Function TransWordRead(Addr: Word): String;
    Begin
      Case Addr Of
        0..$7F,$100..$17F: TransWordRead := TIA_Read_Name[Addr And $F];
    $200..$3FF: TransWordRead := PIA_Name[$200 Or Timer_And[Addr And $1F]];
{    $280..$297: TransWordRead := PIA_Name[Addr];
    $380..$397: TransWordRead := PIA_Name[Addr - $100];}
      Else TransWordRead := HexWord(Addr);
      End; { Case }
    End; { TransWordRead }


    Function TransByteRead(Addr: Word): String;
    Begin
      Case Addr Of
        0..$7F,$100..$17F: TransByteRead := TIA_Read_Name[Addr And $F];
    $200..$3FF: TransByteRead := PIA_Name[$200 Or Timer_And[Addr And $1F]];
{    $280..$297: TransByteRead := PIA_Name[Addr];
    $380..$397: TransByteRead := PIA_Name[Addr - $100];}
       Else TransByteRead := HexByte(Addr);
       End; { Case }
    End; { TransByteRead }


    Function TransByteWrite(Addr: Word): String;
    Begin
      If (Addr < $80) Or ((Addr >= $100) And (Addr < $180)) Then Addr := Addr And $3F;
      Case Addr Of
        0..$2C: TransByteWrite := TIA_Name[Addr];
      Else TransByteWrite := HexByte(Addr);
      End; { Case }
    End; { TransByteWrite }


    Function TransWord(Addr: Word): String;
    Var Instr: String[3];
    Begin
      Instr := Mnem[Opcode];
      If (Addr < $80) And (Copy(Instr,1,2) = 'RO')
       Then TransWord := TransWordRead(Addr)
       Else
        If (Instr           = 'ADC') Or
           (Instr           = 'DEC') Or
           (Instr           = 'INC') Or
           (Instr           = 'SBC') Or
           (Copy(Instr,1,2) = 'PH')  Or
           (Copy(Instr,1,2) = 'RO')  Or
           (Copy(Instr,1,2) = 'ST')
         Then TransWord := TransWordWrite(Addr)
         Else TransWord := TransWordRead(Addr);
    End; { TransWord }


    Function TransByte(Addr: Word): String;
    Var Instr: String[3];
    Begin
      Instr := Mnem[Opcode];
      If (Addr < $80) And (Copy(Instr,1,2) = 'RO')
       Then TransByte := TransByteRead(Addr)
       Else
        If (Instr           = 'ADC') Or
           (Instr           = 'DEC') Or
           (Instr           = 'INC') Or
           (Instr           = 'SBC') Or
           (Copy(Instr,1,2) = 'PH')  Or
           (Copy(Instr,1,2) = 'RO')  Or
           (Copy(Instr,1,2) = 'ST')
         Then TransByte := TransByteWrite(Addr)
         Else TransByte := TransByteRead(Addr);
    End; { TransByte }


    Function GetROM(Addr: Word): Byte;
    Begin
      GetROM := Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + Addr];
    End; { GetROM }


    Function GetROMW(Addr: Word): Word;
    Begin
      GetROMW := MemW[Seg(ROMBackup^):Ofs(ROMBackup^) + Addr];
    End; { GetROMW }

    Function BankW(W: Word): Word;
    Begin
      BankW := W + (I And $F000) - $1000;
    End; { BankW }

  Begin
    GetMem(OldASeg,4096);
    Move(AtariSeg[$1000],OldASeg^,4096);
    New(Executed);
    New(Branched);
    FillChar(Executed^,SizeOf(Executed^),#0);
    FillChar(Branched^,SizeOf(Branched^),#0);
    Start            := MemW[Seg(AtariSeg):Ofs(AtariSeg) + $1FFC] And $1FFF;
    Branched^[Start] := True;
    Bank             := 0;
    If Cart = ct8k Then Bank := 4;
    Unassemble(Start,Bank);

    { Output listing }

    Assign(Listing,'LISTING.ASM');
    Rewrite(Listing);
    WriteLn(Listing,'; Listing for ',ParamStr(1));
    WriteLn(Listing);

    I       := $1000;
    DBStart := 0;
    While I <= ROMSize + 4095 Do
{    While I <= $1FFF Do}
    Begin
      Opcode := GetROM(I - $1000);
{      Opcode := AtariSeg[I];}

{      Write(HexWord(I),' ');}

      If Not Executed^[I - $1000] Then
      Begin

        { Tally the byte }

        If DBStart = 0 Then DBStart := I;
        Inc(I);
      End
      Else
      Begin

        { Output any accumulated data }

        If DBStart <> 0 Then
        Begin
          For J := DBStart To I - 1 Do
          Begin
            If ((J - DBStart) And $7) = 0 Then Write(Listing,HexWord(J),'            DB    ');
{            Write(Listing,HexByte(AtariSeg[J]),'h');}
            Write(Listing,HexByte(GetROM(J - $1000)),'h');
            If (J < I - 1) And (((J - DBStart) And $7) <> $7) Then Write(Listing,',');
            If (J < I - 1) And (((J - DBStart) And $7) =  $7) Then WriteLn(Listing);
          End;
          WriteLn(Listing);
          DBStart := 0;
        End;

        { Output the instruction }

        If Branched^[I - $1000]
         Then Write(Listing,HexWord(I),'  ')
         Else Write(Listing,'      ');
        For J := 1 To 5 Do
         If Bytes[Opcode] >= J
{          Then Write(Listing,HexByte(AtariSeg^[I + J - 1]))}
          Then Write(Listing,HexByte(GetROM(I + J - 1 - $1000)))
          Else Write(Listing,'  ');
        Write(Listing,Mnem[Opcode]);
        OTyp := ATyp[Opcode];
        If OTyp = 'ABS' Then Write(Listing,'   ',TransWord(BankW(GetROMW(I + 1 - $1000) And $1FFF)));
        If OTyp = 'A.X' Then Write(Listing,'   ',TransWord(BankW(GetROMW(I + 1 - $1000) And $1FFF)),',X');
        If OTyp = 'A.Y' Then Write(Listing,'   ',TransWord(BankW(GetROMW(I + 1 - $1000) And $1FFF)),',Y');
        If OTyp = 'ASY' Then Write(Listing,'   (',TransWord(BankW(GetROMW(I + 1 - $1000) And $1FFF)),',Y) & S');
        If OTyp = 'IND' Then Write(Listing,'   (',HexWord(BankW(GetROMW(I + 1 - $1000) And $1FFF)),')');
        If OTyp = 'I.X' Then Write(Listing,'   (',HexByte(GetROM(I + 1 - $1000)),',X)');
        If OTyp = 'I.Y' Then Write(Listing,'   (',HexByte(GetROM(I + 1 - $1000)),'),Y');
        If OTyp = 'ACC' Then Write(Listing,'   A');
        If OTyp = 'IMM' Then Write(Listing,'   #',HexByte(GetROM(I + 1 - $1000)));
        If OTyp = 'Z.P' Then Write(Listing,'   ',TransByte(GetROM(I + 1 - $1000)));
        If OTyp = 'Z.X' Then Write(Listing,'   ',TransByte(GetROM(I + 1 - $1000)),',X');
        If OTyp = 'Z.Y' Then Write(Listing,'   ',TransByte(GetROM(I + 1 - $1000)),',Y');
        If OTyp = 'I+A' Then Write(Listing,'   #',HexByte(GetROM(I + 1 - $1000)),' + A');
        If OTyp = 'REL' Then
        Begin
{          B := AtariSeg[I + 1];}
          B := GetROM(I + 1 - $1000);
          Asm
            MOV   BX,WORD PTR I
            ADD   BX,2
            MOV   AL,BYTE PTR B
            CBW
            ADD   BX,AX
            MOV   WORD PTR J,BX
          End; { Asm }
          Write(Listing,'   ',HexWord(J));
        End;

        { Look for bankswitching info }

        If OTyp = 'ABS' Then
        Begin
          BAddr := GetROMW(I + 1 - $1000) And $1FFF;
          If BankSwitch[BAddr] <> 0 Then
          Begin
            Case BankSwitch[BAddr] Of
              1..13: Begin                             { 2k/4k/8k/16k }
                       NewBank := BankSwitch[BAddr] - 1;
                       Write(Listing,'   <-- Switch to bank ',NewBank Shr 2);
                       Write(Listing,' (',HexWord((I And $FFF) + Bytes[Opcode] + NewBank * 1024 + $1000),'h)');
                     End;
           $21..$29: Begin                             { CBS }
                       NewBank := BankSwitch[BAddr] - $21;
                       Write(Listing,'   <-- Switch to bank ',NewBank Shr 2);
                       Write(Listing,' (',HexWord((I And $FFF) + Bytes[Opcode] + NewBank * 1024 + $1000),'h)');
                      End;
           $40..$4F: Begin                             { SuperChip }
                       NewBank := (BankSwitch[BAddr] - $40 Shl 2);
                       Write(Listing,'   <-- Switch to bank ',NewBank Shr 2);
                       Write(Listing,' (',HexWord((I And $FFF) + Bytes[Opcode] + NewBank * 1024 + $1000),'h)');
                     End;
            End; { Case }
          End;
        End;
        WriteLn(Listing);
        Inc(I,Bytes[Opcode]);
      End;
    End; { While }

    { Output any accumulated data }

    If DBStart <> 0 Then
    Begin
      For J := DBStart To I - 1 Do
      Begin
        If ((J - DBStart) And $7) = 0 Then Write(Listing,HexWord(J),'            DB    ');
        Write(Listing,HexByte(GetROM(J - $1000)),'h');
        If (J < I - 1) And (((J - DBStart) And $7) <> $7) Then Write(Listing,',');
        If (J < I - 1) And (((J - DBStart) And $7) =  $7) Then WriteLn(Listing);
      End;
      WriteLn(Listing);
      DBStart := 0;
    End;
    Close(Listing);
    Dispose(Branched);
    Dispose(Executed);
    Move(OldASeg^,AtariSeg[$1000],4096);
    FreeMem(OldASeg,4096);
  End; { Disassemble }
*)
(*
  Procedure SetPalette(Var Pal: TPalette);
  Var I: Integer;
  Begin
    Port[$3C8] := 0;
    For I := 0 To 127 Do
    Begin
      Port[$3C9] := Pal[I].B Shr 2;
      Port[$3C9] := Pal[I].G Shr 2;
      Port[$3C9] := Pal[I].R Shr 2;

      { Duplicate the colors here to avoid having to worry about bit 0 }

      Port[$3C9] := Pal[I].B Shr 2;
      Port[$3C9] := Pal[I].G Shr 2;
      Port[$3C9] := Pal[I].R Shr 2;
    End; { For I }
  End; { SetPalette }
*)

  Procedure LoadROM(Address,Amount: Word);
  Begin
    BlockRead(F,AtariSeg[Address],Amount);
  End; { LoadROM }

Begin
  Controller       := crJoystick;
  LockXMS          := False;
  MouseInit;
  If MouseVisible Then ToggleMouseVisibility;
  Top           := 0;
  Sel           := 0;
  SoundBuf[0]   := Nil;
  SoundBuf[1]   := Nil;
  SBuf[0]       := Nil;
  SBuf[1]       := Nil;

  { Load the config file }

  Config.UseJoystick1       := False;
  Config.UseJoystick2       := False;
  Config.DoSound            := True;
  Config.MinJoyX            := 10;
  Config.MaxJoyX            := 100;
  Config.MinJoyY            := 10;
  Config.MaxJoyY            := 100;
  Config.MinJoyX2           := 10;
  Config.MaxJoyX2           := 100;
  Config.MinJoyY2           := 10;
  Config.MaxJoyY2           := 100;
  Config.JoyCenterX         := 50;
  Config.JoyCenterY         := 50;
  Config.JoyCenterX2        := 50;
  Config.JoyCenterY2        := 50;
  Config.FrameRate          := 60;
  Config.SoundBufSize       := SoundBufSize;
  Config.PlaybackRate       := Playback_Freq;
  Config.UseRealControllers := False;
  Config.LPT1Port           := $278;
  Config.PaddleMax          := 750;
  Config.MaxRows            := 200;
  Config.Player1Fire        := 1;
  Config.JoystickReset      := 2;   { Also Booster-Grip button 1 }
  Config.Player2Fire        := 4;
  Config.JoystickSelect     := 8;   { Also Booster-Grip button 2 }
  Config.MousePaddle        := 0;
  If Exist(ConfigFile) Then
  Begin
    Assign(F,ConfigFile);
    Reset(F,1);
    If FileSize(F) = SizeOf(Config) Then
    Begin
      BlockRead(F,Config,SizeOf(Config));
      Close(F);
    End
    Else
    Begin
      Close(F);
      Assign(F,ConfigFile);
      ReWrite(F,1);
      BlockWrite(F,Config,SizeOf(Config));
      Close(F);
    End;
  End;
  If Config.LPT1Port = 0 Then Config.LPT1Port := $278;
  If Config.PaddleMax < 1 Then Config.PaddleMax := 1;
  If Not (Config.MaxRows In [200,204,215,250]) Then Config.MaxRows := 200;
  SoundBufSize  := Config.SoundBufSize;
  JoyCenterX    := Config.JoyCenterX;
  JoyCenterY    := Config.JoyCenterY;
  JoyMinX       := (JoyCenterX  + Config.MinJoyX) Div 2;
  JoyMinY       := (JoyCenterY  + Config.MinJoyY) Div 2;
  JoyMaxX       := (JoyCenterX  + Config.MaxJoyX) Div 2;
  JoyMaxY       := (JoyCenterY  + Config.MaxJoyY) Div 2;
  JoyCenterX2   := Config.JoyCenterX2;
  JoyCenterY2   := Config.JoyCenterY2;
  JoyMinX2      := (JoyCenterX2 + Config.MinJoyX2) Div 2;
  JoyMinY2      := (JoyCenterY2 + Config.MinJoyY2) Div 2;
  JoyMaxX2      := (JoyCenterX2 + Config.MaxJoyX2) Div 2;
  JoyMaxY2      := (JoyCenterY2 + Config.MaxJoyY2) Div 2;
  Playback_Freq := Config.PlaybackRate;

  { Set up the BCD table }

  For I := 0 To 255 Do
  Begin
    BCDTable[0,I] := (I Shr 4) * 10 + (I And $F);
    BCDTable[1,I] := (((I Mod 100) Div 10) Shl 4) Or (I Mod 10);
  End; { For I }

  { Set up the masks }

  Asm
    CLI
    SUB   DX,DX
@L1:
    MOV   AX,DX
    MOV   BX,DX
    RCR   AL,1
    RCL   AH,1
    RCR   AL,1
    RCL   AH,1
    RCR   AL,1
    RCL   AH,1
    RCR   AL,1
    RCL   AH,1
    RCR   AL,1
    RCL   AH,1
    RCR   AL,1
    RCL   AH,1
    RCR   AL,1
    RCL   AH,1
    RCR   AL,1
    RCL   AH,1
    MOV   BYTE PTR BitSwap[BX],AH
    INC   DX
    CMP   DX,256
    JL    @L1
    STI
  End; { Asm }
  For I := 0 To 228 Do Div3[I] := I Div 3;
  _SHR := $80000;
  _SHL := 1;
  For I := 0 To 19 Do
  Begin
    BitTest[I]      := _SHR;
    BitTest[I + 20] := _SHR;
    BitTest[I + 64] := _SHR;
    BitTest[I + 84] := _SHL;
    Asm
      DB    _32BIT_OPERAND
      SHL   WORD PTR _SHL,1
      DB    _32BIT_OPERAND
      SHR   WORD PTR _SHR,1
    End; { Asm }
(*
    BitTest[I]      := $80000 Shr I;
    BitTest[I + 20] := $80000 Shr I;
    BitTest[I + 64] := $80000 Shr I;
    BitTest[I + 84] := LongInt(1) Shl I;  { Need the type cast!!! }
*)
  End; { For I }

  FillChar(MissileTable,SizeOf(MissileTable),#0);
  For I := 0 To 31 Do
  Begin
    Case (I Shr 3) Of
      0: J := 1;
      1: J := 2;
      2: J := 4;
      3: J := 8;
    End; { Case }
    FillChar(MissileTable[(I Shl 7)],J,#255);
    Case (I And 7) Of
      1: FillChar(MissileTable[(I Shl 7) + 16],J,#255);
      2: FillChar(MissileTable[(I Shl 7) + 32],J,#255);
      3: Begin
           FillChar(MissileTable[(I Shl 7) + 16],J,#255);
           FillChar(MissileTable[(I Shl 7) + 32],J,#255);
         End;
      4: FillChar(MissileTable[(I Shl 7) + 64],J,#255);
      6: Begin
           FillChar(MissileTable[(I Shl 7) + 32],J,#255);
           FillChar(MissileTable[(I Shl 7) + 64],J,#255);
         End;
    End; { Case }
  End; { For I }

  FillChar(ByteShift,SizeOf(ByteShift),#0);
  For I := 0 To 7 Do
  Begin
    For J := 0 To 71 Do
    Begin
      B2 := (I Shl 8) + J;
      B1 := B2 + 128;
      If (J <= 7) And (I In [0..4,6]) Then
      Begin
        ByteShift[(I Shl 8) + J + 128] := 1   Shl J;
        ByteShift[(I Shl 8) + J]       := $80 Shr J;
      End;
      Case I Of
        1: Case J Of
             16..23:
             Begin
               ByteShift[B1] := 1   Shl (J - 16);
               ByteShift[B2] := $80 Shr (J - 16);
             End;
           End;
        2: Case J Of
             32..39:
             Begin
               ByteShift[B1] := 1   Shl (J - 32);
               ByteShift[B2] := $80 Shr (J - 32);
             End;
           End; { Case }
        3: Case J Of
             16..23:
             Begin
               ByteShift[B1] := 1   Shl (J - 16);
               ByteShift[B2] := $80 Shr (J - 16);
             End;
             32..39:
             Begin
               ByteShift[B1] := 1   Shl (J - 32);
               ByteShift[B2] := $80 Shr (J - 32);
             End;
           End; { Case }
        4: Case J Of
             64..71:
             Begin
               ByteShift[B1] := 1   Shl (J - 64);
               ByteShift[B2] := $80 Shr (J - 64);
             End;
           End; { Case }
        5: If J <= 15 Then
           Begin
             ByteShift[B1] := 1   Shl (J Shr 1);
             ByteShift[B2] := $80 Shr (J Shr 1);
           End;
        6: Case J Of
             32..39:
             Begin
               ByteShift[B1] := 1   Shl (J - 32);
               ByteShift[B2] := $80 Shr (J - 32);
             End;
             64..71:
             Begin
               ByteShift[B1] := 1   Shl (J - 64);
               ByteShift[B2] := $80 Shr (J - 64);
             End;
           End; { Case }
        7: If J <= 31 Then
           Begin
             ByteShift[B1] := 1   Shl (J Shr 2);
             ByteShift[B2] := $80 Shr (J Shr 2);
           End;
      End; { Case }
    End; { For J }
  End; { For I }

  FillChar(ExtraAdd,SizeOf(ExtraAdd),#0);
  ExtraAdd[-8] := 14;       { For Escape From the MindMaster }
  ExtraAdd[-2] := 8;        { For Double Dragon }
{  ExtraAdd[-1] := 7;
  ExtraAdd[0]  := 6;
  ExtraAdd[1]  := 5;
  ExtraAdd[2]  := 4;
  ExtraAdd[3]  := 3;}
  ExtraAdd[4]  := 2;        { For Grand Prix }
{  ExtraAdd[5]  := 1;}

  For K := 5 DownTo -8 Do ExtraAdd[K] := 6 - K;


  For I := 0 To 15 Do
  Begin
    For J := 0 To 66 Do
    Begin
      K := I;
      Asm
        SHL   WORD PTR K,12
        SAR   WORD PTR K,12
      End; { Asm }
      If (J <= 53) Or (I <= 1) Or (I >= 15)
       Then SetAdjust[J * 16 + I] := K
       Else SetAdjust[J * 16 + I] := 0;


{      SetAdjust[J * 16 + I] := Round(K * (66 - J) / 66);}
    End; { For J }
  End; { For I }




{  For K := 5 DownTo -68 Do ExtraAdd[K] := 6 - K;}

  DeAllocSound;
  InitSound;
  Blaster := GetEnv('BLASTER');
  If Blaster <> '' Then
  Begin
    For I := 1 To Length(Blaster) Do Blaster[I] := UpCase(Blaster[I]);
    While (Blaster <> '') And (Blaster[1] = ' ') Do Blaster := Copy(Blaster,2,Length(Blaster) - 1);
    While (Blaster <> '') And (Blaster[Length(Blaster)] = ' ') Do Blaster := Copy(Blaster,1,Length(Blaster) - 1);
  End;
  If Blaster <> '' Then
  Begin

    { Get the port number }

    I := Pos('A',Blaster) + 1;
    St := '';
    Repeat
      WorkCh := Blaster[I];
      Inc(I);
      If WorkCh <> ' ' Then St := St + WorkCh;
    Until (WorkCh = ' ') Or (I > Length(Blaster));
    I := 1;
    _IO_Addx := 0;
    For J := 1 To Length(St) Do
    Begin
      WorkCh := UpCase(St[Length(St) - (J - 1)]);
      If WorkCh In ['0'..'9']
       Then _IO_Addx := _IO_Addx + I * (Ord(WorkCh) - Ord('0'))
       Else _IO_Addx := _IO_Addx + I * (Ord(WorkCh) - Ord('A') + 10);
      I := I * 16;
    End; { For J }

    { Get the IRQ }

    I := Pos('I',Blaster) + 1;
    St := '';
    Repeat
      WorkCh := Blaster[I];
      Inc(I);
      If WorkCh <> ' ' Then St := St + WorkCh;
    Until (WorkCh = ' ') Or (I > Length(Blaster));
    Val(St,_Intr_Num,I);

    { Get the DMA }

    I := Pos('D',Blaster) + 1;
    St := '';
    Repeat
      WorkCh := Blaster[I];
      Inc(I);
      If WorkCh <> ' ' Then St := St + WorkCh;
    Until (WorkCh = ' ') Or (I > Length(Blaster));
    Val(St,_DMA,I);
  End
  Else
  Begin
    _IO_Addx      := SBPort;
    _Intr_Num     := SBInt;
    _DMA          := SBDMA;
  End;

  UseMenu := False;
  T1      := 0;
  T2      := 0;

  Controller  := crJoystick;
  Debugger    := False;
  Repeat
    Palette     := 0;
    CurrentBank := 0;
    BankStart   := $1000;
    BankSize    := 1024;    { Size in dwords }
    Cart        := ct4k;
    TigerLimit  := 0;
    SCLimit     := 0;
    FillChar(AtariSeg,SizeOf(AtariSeg),#0);  { Blank them with nulls }
    FillChar(BankSwitch,SizeOf(BankSwitch),#0);
    ClrScr;
    MegaBoyNum := 0;
    If (ParamCount = 0) Or
       ((ParamCount > 0) And Not Exist(ParamStr(1)))
     Then St := Menu(Config,Version,Top,Sel,JoyMinX,JoyMaxX,JoyMinY,JoyMaxY,
                     JoyCenterX,JoyCenterY,JoyMinX2,JoyMaxX2,JoyMinY2,JoyMaxY2,
                     JoyCenterX2,JoyCenterY2,Handle,SoundBuf,SoundBufSize,
                     Playback_Freq,BankSize,InitSound,DeAllocSound,Controller,
                     Debugger,Config.DoSound,UseMenu,@BankSwitch,Cart,
                     PF2ReadCount,MNetworkRAM,MegaBoyNum)
(*
     Then St := Menu{(Config,Top,Sel,JoyCenterX,JoyCenterY,JoyMinX,JoyMinY,
                     JoyMaxX,JoyMaxY,JoyCenterX2,JoyCenterY2,JoyMinX2,
                     JoyMinY2,JoyMaxX2,JoyMaxY2,BankSize,UseKBControllers,
                     Debugger,Config.DoSound,UseMenu,Activision,ParkerBS,MNetwork,
                     BankSwitch)}
*)
     Else St := ParamStr(1);

    If (St <> '') And Exist(St) Then
    Begin
      If Pos('.PAL',ToUpper(St)) <> 0 Then Palette := 1;
      Disasm := False;
      If ParamCount > 1 Then
      Begin
        For I := 2 To ParamCount Do
        Begin
          Param := ToUpper(ParamStr(I));
          If Param = 'PROFILE' Then
          Begin
            Cart := FindProfile(St,Controller);
            Case Cart Of
              ct8k: Param := 'BANK';
             ct16k: Param := 'BANK16';
       ctSuperChip: Param := 'BANKSC';
      ctParkerBros: Param := 'BANKP';
        ctMNetwork: Param := 'BANKM';
        ctStarpath: Param := 'BANKSP';
             ctCBS: Param := 'BANKC';
     ctTigerVision: Param := 'BANKT';
        ctPitfall2: Param := 'BANK2';
      ctActivision: Param := 'BANKA';
         ctMegaBoy: Param := 'BANKG';
           ct32In1: Param := 'BANK3';
            Else
              Param := '';
            End; { Case }
          End;
          If Param = 'DISASM' Then Disasm := True;
          If Param = 'BANK'   Then
          Begin
            BankSwitch[$1FF8] := 1;
            BankSwitch[$1FF9] := 5;
            Cart              := ct8k;
          End;
          If Param = 'BANKC' Then
          Begin
            BankSwitch[$1FF8] := 1 + 32;
            BankSwitch[$1FF9] := 5 + 32;
            BankSwitch[$1FFA] := 9 + 32;
            For J := $1000 To $10FF Do BankSwitch[J] := $30;
            BankSize := 1024 - 128{64};    { Size in dwords }
            Cart     := ctCBS;
          End;
          If Param = 'BANK16'   Then
          Begin
            BankSwitch[$1FF6] := 1;
            BankSwitch[$1FF7] := 5;
            BankSwitch[$1FF8] := 9;
            BankSwitch[$1FF9] := 13;
            Cart              := ct16k;
          End;
          If Param = 'BANKSC'   Then
          Begin
{            BankSwitch[$1FF6] := 1  + $40;
            BankSwitch[$1FF7] := 5  + $40;
            BankSwitch[$1FF8] := 9  + $40;
            BankSwitch[$1FF9] := 13 + $40;}
            Cart := ctSuperChip;
            For J := $1000 To $107F Do BankSwitch[J] := $5F;
            BankSize := 1024 - 64{32};    { Size in dwords }
          End;
          If Param = 'BANKSP'   Then
          Begin
            For J := $1000 To $1FFF Do BankSwitch[J] := $70;
            BankSwitch[$1FF8] := $70;
            BankSwitch[$0E00] := $70;
            Cart              := ctStarpath;
          End;
          If Param = 'BANKA'   Then
          Begin
            BankSwitch[$01FE] := 30;
            Cart              := ctActivision;
          End;
          If Param = 'BANKP'   Then
          Begin
            For J := $1FE0 To $1FF7 Do BankSwitch[J] := J And $FF;
            Cart := ctParkerBros;
          End;
          If Param = 'BANKM'   Then
          Begin
            For J := $1FE0 To $1FEB Do BankSwitch[J] := (J And $FF) - $10;
            For J := $1000 To $13FF Do BankSwitch[J] := $DC;
            For J := $1800 To $18FF Do BankSwitch[J] := $DD;
            Cart        := ctMNetwork;
            MNetworkRAM := 8;
          End;
          If Param = 'BANKT'   Then
          Begin
            BankSwitch[$003F] := $60;
            Cart              := ctTigerVision;
            BankSize          := 512;
          End;
          If Param = 'BANK2' Then
          Begin
            BankSwitch[$1FF8] := $CB;
            BankSwitch[$1FF9] := $CC;
            Cart              := ctPitfall2;
            FillChar(PF2ReadCount,SizeOf(PF2ReadCount),#0);
            For J := $1040 To $107F Do BankSwitch[J] := $CF;
            For J := $1840 To $187F Do BankSwitch[J] := $CF;
            For J := $1000 To $103F Do BankSwitch[J] := $CE;
            For J := $1800 To $183F Do BankSwitch[J] := $CE;
          End;
          If Param = 'BANKG' Then
          Begin
            BankSwitch[$1FF0] := $80;
            Cart := ctMegaBoy;
          End;
          If Param = 'BANK3' Then Cart := ct32In1;
          If Copy(Param,1,8) = '32IN1NUM' THen
          Begin
            St1 := Param;
            St1 := Copy(St1,9,Length(St1) - 8);
            Val(St1,MegaBoyNum,J);
            If J <> 0
             Then MegaBoyNum := 0
             Else MegaBoyNum := MegaBoyNum And $1F;
          End;

          If Param = 'DEBUG'   Then Debugger   := True;
          If Param = 'KB'      Then Controller := crKeyboard;
          If Param = 'INDY500' Then Controller := crDriving;
          If Param = 'VTP'     Then Controller := crVTP;
          If Param = 'PADDLE'  Then Controller := crPaddle;
          If Copy(Param,1,5) = 'FRAME' Then
          Begin
            St1 := Param;
            St1 := Copy(St1,6,Length(St1) - 5);
            Val(St1,Config.FrameRate,J);
            If J <> 0 Then Config.FrameRate := 0;
            If Config.FrameRate < 0 Then Config.FrameRate := 0;
          End;
        End;
      End;
      Assign(F,St);
      Reset(F,1);
      ROMSize := FileSize(F);
      If ROMSize > 65520 Then ROMSize := 65520;
      If (Cart = ctMNetwork) And (ROMSize <= 65520 - 2048)
       Then GetMem(ROMBackup,ROMSize + 2048)
       Else GetMem(ROMBackup,ROMSize);
      If ROMSize < 4096 Then
      Begin
        I := 0;
        While I * ROMSize < 4096 Do
        Begin
          Seek(F,0);
          If (I + 1) * ROMSize <= 4096
           Then Loaded := ROMSize
           Else Loaded := 4096 - I * ROMSize;
          LoadROM($1000 + I * ROMSize,Loaded);
          Inc(I);
        End; { While }
      End
      Else LoadROM($1000,4096);
      If (ROMSize = 8192) And (Cart = ct8k) Then
      Begin
        Seek(F,4096);
        LoadROM($1000,4096);
      End;

{
      If (ROMSize = 16384) And (Cart = ct16k) Then
      Begin
        Seek(F,3 * 4096);
        LoadROM($1000,4096);
        CurrentBank := 8;
      End;
}


{
      If Cart = ctMegaBoy Then
      Begin
        Seek(F,MegaBoyNum * 2048);
        LoadROM($1000,2048);
        Seek(F,MegaBoyNum * 2048);
        LoadROM($1800,2048);
      End;
}
      If Cart = ct32In1 Then
      Begin
        Seek(F,MegaBoyNum * 2048);
        LoadROM($1000,2048);
        Seek(F,MegaBoyNum * 2048);
        LoadROM($1800,2048);
      End;
      If (ROMSize >= 8192) And (Cart = ctParkerBros) Then
      Begin
        Seek(F,7168);
        LoadROM($1C00,1024);
        BankSize := 256;    { Size in dwords }
      End;
      If Cart = ctTigerVision Then
      Begin
        Seek(F,ROMSize - 2048);
        TigerLimit := (ROMSize - 2048) Shr 11;
        LoadROM($1800,2048);
      End;
{
      If Activision Then
      Begin
        Seek(F,4096);
        LoadROM($1000,4096);
      End;
}
      If (ROMSize = 16384) And (Cart = ctMNetwork) Then
      Begin
        Seek(F,14 * 1024);
        LoadROM($1800,2048);
        BankSize := 512;    { Size in dwords }
      End;

      { Load 2nd 4k for SuperChip }

      If Cart = ctSuperChip Then
      Begin
        Seek(F,4 * 1024);
        LoadROM($1000,4096);
        I := ROMSize Shr 12;
        Case I Of
           0..2: J := $1FF8;
           3..4: J := $1FF6;
           5..8: J := $1FF4;
          9..15: J := $1FEC;
        End; { Case }
        For I := J To J + (ROMSize Shr 12) - 1 Do BankSwitch[I] := $40 + (I - J);
      End;
(*
      If (ROMSize = 16384) And (BankSize = 1024 - 64) Then
      Begin
        Seek(F,4 * 1024);
        LoadROM($1000,4096);
      End;
      If ROMSize = 32768 Then
      Begin
        BankSwitch[$1FF4] := 1 + $40;
        BankSwitch[$1FF5] := 5 + $40;
        BankSwitch[$1FF6] := 9 + $40;
        BankSwitch[$1FF7] := 13 + $40;
        BankSwitch[$1FF8] := 17 + $40;
        BankSwitch[$1FF9] := 21 + $40;
        BankSwitch[$1FFA] := 25 + $40;
        BankSwitch[$1FFB] := 29 + $40;
        For J := $1000 To $107F Do BankSwitch[J] := $5F;
      End;
*)
      Seek(F,0);
      If Cart <> ctStarpath
       Then BlockRead(F,ROMBackup^,ROMSize)
       Else LoadStarpath(F,ROMBackup,ROMSize);
      If (Cart In [ctMegaBoy,ct32In1]) And (FileSize(F) = ROMSize + 16) Then BlockRead(F,MegaBoy,16);
      Close(F);
      If Disasm Then Disassemble(AtariSeg,BankSwitch,ROMBackup,Cart,ROMSize);

{      Go_Mode($13);}

      Assign(F,'PCAE.PA0');
      Reset(F,1);
      BlockRead(F,Pal,SizeOf(Pal));
      Close(F);

      Assign(F,'PCAE.PA1');
      Reset(F,1);
      BlockRead(F,Pal1,SizeOf(Pal1));
      Close(F);

{      SetPalette;}

      FillChar(FMChanOn,SizeOf(FMChanOn),#0);
      FillChar(FMFeedBack,SizeOf(FMFeedBack),#0);
      FillChar(FMBaseLevel,SizeOf(FMBaseLevel),#0);
      FillChar(FMScale,SizeOf(FMScale),#0);
      FillChar(FMFreq,SizeOf(FMFreq),#0);
      FillChar(FMRealScale,SizeOf(FMRealScale),#0);
      FillChar(FMVoc,SizeOf(FMVoc),#0);



{
      InitFM;
      SetFM(0,True);
      SetFM(1,True);
      SetFM(2,True);
      SetFM(3,True);
}
{      WriteFM(1,$20);}



      If Cart <> ctStarPath
       Then Start := MemW[Seg(AtariSeg):Ofs(AtariSeg) + $1FFC] And $1FFF
       Else Start := MemW[Seg(ROMBackup^):Ofs(ROMBackup^) + $2000] And $1FFF;
      If (Cart = ctPitfall2) And (ROMSize = 8192 + 2048 + 255) Then
       FillDump(St);

{
      If (Cart = ctPitfall2) And Exist('PF2-24.DMP') Then
      Begin
        Assign(F,'PF2-24.DMP');
        Reset(F,1);
        GetMem(PF2Read,65520);
        PF2ReadSize := 65520;
        BlockRead(F,PF2Read^,65520);
        Close(F);
      End;
}
      If Cart = ctStarPath Then
      Begin
        SPSearch := 0;
        Asm
          LES   DI,DWORD PTR ROMBackup
          MOV   BL,ES:[DI+2002h]


{
          LES   DI,DWORD PTR AtariSeg
          MOV   BYTE PTR ES:[DI+80h],BL
}
          MOV   BYTE PTR AtariSeg[80h],BL
{          MOV   BYTE PTR ES:[DI+1FF8h],BL}

          MOV   DL,BL
{          MOV   BH,0F0h}
          MOV   WORD PTR StarpathLastAddr,0 {BX}
          SHR   BL,1
          AND   BL,0Eh
          SUB   BH,BH

          MOV   AX,WORD PTR SP1[BX]
          MOV   CX,200h

{          LES   DI,DWORD PTR AtariSeg}

          MOV   DI,DS
          MOV   ES,DI
          MOV   DI,OFFSET AtariSeg

          PUSH  DS
          LDS   SI,DWORD PTR ROMBackup
          ADD   DI,1000h
          ADD   SI,AX
          CLD
          DB    _32BIT_OPERAND
          REP   MOVSW
          POP   DS

          MOV   AX,WORD PTR SP2[BX]
          MOV   CX,200h

{          LES   DI,DWORD PTR AtariSeg}

          MOV   DI,DS
          MOV   ES,DI
          MOV   DI,OFFSET AtariSeg

          PUSH  DS
          LDS   SI,DWORD PTR ROMBackup
          ADD   DI,1800h
          ADD   SI,AX
          CLD
          DB    _32BIT_OPERAND
          REP   MOVSW
          POP   DS

{          LES   DI,DWORD PTR AtariSeg}
          MOV   BYTE PTR SPBankNum,DL{ES:[DI+1FF8h],DL}
        End; { Asm }
      End;
      CyclesDone := 0;
      P := $20;
      A := 0;
      X := 0;
      Y := 0;
      S := $FF;{0;}
      FillChar(Key,SizeOf(Key),#0);
      InitEmulator;
      OldByte  := AtariSeg[Start];
      OldStart := Start;
      Go_Mode($13);
      FillChar(Mem[$A000:0],65535,0);


      If Palette = 0 Then SetPalette(Pal) Else SetPalette(Pal1);


      Hi3 := 0;

      SPBoot   := False;
      HaltLine := 999;

      Repeat
        If OldStart <> 0 Then
        Begin
          OldByte  := AtariSeg[OldStart];
          If Debugger Then AtariSeg[OldStart] := BreakInstruction;
        End;
{        KBFlag  := Mem[0:$417];}
{        InitKeyboard;}
        If Config.DoSound Then
        Begin

          InitFM;
{          SetFM(0,True);}
{          SetFM(1,True);}
{          SetFM(2,True);
          SetFM(3,True);}

          Delay(10);

          Tia_sound_init(sample_freq,playback_freq);

          FillChar(SoundBuf[0]^,SoundBufSize * 2,#0);
          FillChar(SoundBuf[1]^,SoundBufSize,#0);

{          OpenSB(playback_freq,num_bufs,SoundBufSize);}

          _CTV_Card_Here;
          _CTV_Detect;
(*
          { Reset the Sound Blaster }

          Port[_IO_Addx + 6] := 1;
          Delay(1);
          Port[_IO_Addx + 6] := 0;
          J := 0;
          Repeat
            Repeat
            Until (Port[_IO_Addx + $E] And $80) <> 0;
            I := Port[_IO_Addx + $A];
            Inc(J);
          Until (I = $AA) Or (J > 100);
          Delay(2);
*)
          _Voice_Status := 0;

{
          ExitKeyboard;
          TextMode(C80);
          WriteLn('About to start sound...hit a key');
          WriteLn;
          WriteLn('Free memory = ',MemAvail);
          WriteLn;
          WriteLn('SoundBuf[0] = ',HexWord(Seg(SoundBuf[0]^)),':',HexWord(Ofs(SoundBuf[0]^)));
          WriteLn('SoundBuf[1] = ',HexWord(Seg(SoundBuf[1]^)),':',HexWord(Ofs(SoundBuf[1]^)));
          ReadKey;
}
          _CTV_Output(SoundBuf[1],SoundBufSize,Playback_Freq);
{
          WriteLn('Sound started.  Hit a key');
          ReadKey;
          Go_Mode($13);
          InitKeyboard;
}
        End;


{$IFDEF LOWRES}
        Go_Mode($93);
        If Palette = 0 Then SetPalette(Pal) Else SetPalette(Pal1);
        If Config.MaxRows <> 200 Then
        Begin
          If Config.MaxRows <> 215 Then
          Begin
            Set160Rows(250);
            MaxRows := 250;
          End
          Else
          Begin
            Set160Rows(215);
            MaxRows := 215;
          End;
        End
        Else
        Begin
          Set160Cols;
          MaxRows := 200;
        End;
{$ELSE}
        If Config.MaxRows <> 200 Then
        Begin
          Go_Mode($93);
          If Palette = 0 Then SetPalette(Pal) Else SetPalette(Pal1);
          SetRows(204);
          MaxRows := 204;
        End
        Else MaxRows := 200;
{$ENDIF}
        InitKeyboard;
        Time0   := Clock;
        TimeErr := 0;
        Interpret(Start,P,A,X,Y,S);   { (0,P,A,X,Y,S) }

{$IFDEF LOWRES}
        Asm
          MOV   AX,93h
          INT   10h
        End; { Asm }
        If Palette = 0 Then SetPalette(Pal) Else SetPalette(Pal1);
{        SetPalette;}
{$ENDIF}

        If (Palette <> 0) And (Config.MaxRows >= 215) Then MaxScan := 275;

{        If Config.DoSound Then CloseSB;}
        If Config.DoSound Then
        Begin
          _CTV_Halt;
          _CTV_Uninstall;

          InitFM;
{          SetFM(0,False);
          SetFM(1,False);
          SetFM(2,False);
          SetFM(3,False);}

        End;
        Key[kESC] := 0;
        ExitKeyboard;
        If OldStart <> 0 Then AtariSeg[OldStart] := OldByte;
        HaltLine := 999;
{$IFDEF LOWRES}
      Until (Not Debugger) Or Not
       Debug(@AtariSeg,Start,P,A,X,Y,S,TIA_Scan,TIA_Count,CurrentBank,Addr,OldStart,
        @BankSwitch,ROMBackup,@TIA_Regs,@Input_Byte,@ObjectLoc,True,HaltLine);
{$ELSE}
      Until (Not Debugger) Or Not
       Debug(@AtariSeg,Start,P,A,X,Y,S,TIA_Scan,TIA_Count,
       CurrentBank,Addr,OldStart,
        @BankSwitch,ROMBackup,@TIA_Regs,@Input_Byte,@ObjectLoc,False,HaltLine);
{$ENDIF}
      If Config.UseRealControllers Then Port[Config.LPT1Port + 2] := $B;

      If Cart = ctMNetwork Then FreeMem(ROMBackup,ROMSize + 2048) Else FreeMem(ROMBackup,ROMSize);

{      If (Cart = ctPitfall2) And Exist('PF2-24.DMP') Then FreeMem(PF2Read,65520);}

      TextMode(C80);
    End;
  Until Not UseMenu;
  If LockXMS Then Handle.UnlockXM;
  Handle.FreeXM;
  DeAllocSound;
End; { Emulate }


Begin
{
  Assign(LogFile,'PCAE.LOG');
  ReWrite(LogFile);
}
  FileMode := 0;
  ClrScr;
{
  GotoXY(32,10);
  WriteLn('PCAE 2.0    BETA');
  GotoXY(32,12);
  WriteLn('DO NOT DISTRIBUTE');
  GotoXY(1,25);
  Write('Hit a key');
  ReadKey;
}
  TextMode(C80);
  TextColor(LightGray);
  WriteLn('Atari 2600 Emulator');
  WriteLn;
  WriteLn('Setting up system');
  WriteLn;
  ASeg := @AtariSeg;
  Emulate;

{  Close(LogFile);}
End.